% Demo initialization ====================
path(path,'/home/verma/LSOT');
if ~exist('SlideShowGUIFlag'), figNumber=0; end;

if ssinit(figNumber),
    str = str2mat(' ',' ',' ',' ','This demo illustrates the working of ADMIT-1 toolbox on ', ...
      ' miscellaneous sparse problems', ...
      ' ',...
      ' Press the "Start" button to see the demonstration.');
    ssdisp(figNumber,str);                                      
    drawnow;
if figNumber, return; end;
end
    str = str2mat(...
      ' ADMIT-1 has two layers of functionality :',...
      ' ',...
      '     1. Sparse Jacobians/Hessians', ...
      '     2. Low-level useful AD drivers', ...
      ' ', ...
      ' ', ...
      ' Press the "Next" button to choose one.', ...
      ' ');
ssdisp(figNumber,str);
drawnow;
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(2) ; end ;
if sspause(figNumber), return; end;
 


% Beginning of the demo ==================

% Make sure the figure has black background

%set(gcf,'Color',[0 0 0]) ;

k=menu('Choose a Class of Problem','Sparse Jacobians/Hessians demo','Low-level useful AD drivers demo');

if k==1
% Partial separable demo
	sparsedemo;
else
%General structured function
	driverdemo;
end


