function [f,JV]=ExtJVDI1(fun,x,V,fdata)
% Parameter Estimation Problem

p=size(V,2);

 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Recover
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
n=length(x);
        ExtraArg=fdata.py0;
        impl=fdata.impl;
        k=fdata.k;
        kind=fdata.kind;
        numstates=fdata.numstates;
        dims=fdata.dims;
        sizep=dims(1);
        m=dims(2);
        consts=fdata.consts;
        outind = fdata.outind;
        yfinal=fdata.yfinal;

 
 
 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Recovery complete
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
total=ceil(abs((k(2)-k(1))/k(3)));
if ((k(2) < k(1)) & (k(3) > 0))
        k(3)=-k(3);
end
 
data=[0;numstates;sizep;k(3);k(1);1;consts];

oldf=[zeros((numstates-1)*sizep,1);ExtraArg];
f=ExtraArg;
V=-V;
oldJV=zeros(sizep*numstates,p);
y=zeros(sizep,total+1);
y(:,1)=ExtraArg;
accumy=ExtraArg;
accumJV=oldJV;

for i=1:total-1
	[y(:,i+1),JV]=forwprod(fun(1,:),[x;oldf],[V ; oldJV],sizep,data);
	data(5)=data(5)+k(3);
	data(6)=data(6)+1;
        oldf=[oldf(sizep+1:numstates*sizep);y(:,i+1)];
        oldJV=[oldJV(sizep+1:numstates*sizep,:);JV];
	accumy=[accumy;y(:,i+1)];
        accumJV=[accumJV;JV];
end
if total > 0
        data(4)=k(2)-(total-1)*k(3);
	[y(:,total+1),JV]=forwprod(fun(1,:),[x;oldf],[V ; oldJV],sizep,data);
        accumy=[accumy;y(:,total+1)];
        accumJV=[accumJV; JV];
        f=y(:,total+1);
else
        f=ExtraArg;
        JV=zeros(sizep,p);
end

datag=n;
 
        if length(outind)==1
                if outind==0
			if size(fun,1) > 1
			[f,JV]=forwprod(fun(2,:),[x;f],[V;JV],m,datag);a
			end
                else
        % all ys, do it
			if size(fun,1) > 1
			[f,JV]=forwprod(fun(2,:),[x;accumy],[V;accumJV],m,datag);
			else
			f=accumy;
			JV=accumJV;
			end
                end
        else
        % outputindex is active
	myJV=[];
        outindy=[];
        for count=1:size(outind,1)
                outindy=[outindy;y(outind(count,2)),outind(count,1)];
		myJV=[myJV;accumJV(outind(count,1)*n+outind(count,2),:)];
        end
	if size(fun,1) > 1
		[f,JV]=forwprod(fun(2,:),[x;outindy],[V;myJV],m,datag);
	else
		f=outindy;
		JV=myJV;
	end
	end

f=f-yfinal;
JV=-JV;
