function fdata = GCFdata(fun,n,k,dims)
%
% Check for inconsistencies in Input data
%
if n <= 0 error('Need Problem size >= 0'); end

if nargin < 3 k=[]; end
if nargin < 4 dims=[]; end
 

	if isempty(k) k=1; end
	if isempty(dims) dims=n; end
	if length(dims) ~=1 error('dims must have only one value for GC class'); end
	if dims <=0  error('dims must be strictly positive'); end
	if k <=0 error('k should be >= 1'); end
	fdata.k=k;
        fdata.dims=dims; 
