function [fun,fdata] = MakeFdata(fun,n,dims)
%
% Check for inconsistencies in Input data
%
if n <= 0 error('Need Problem size >= 0'); end
if nargin < 3 dims=[]; end
 

	k=size(fun,1); 
	if isempty(dims) dims=n*ones(k,1); end
	fdata=[k]; 
	for i=1:k
		if length(deblank(fun(i,:))) >= 4
			if fun(i,1:4) =='imp_'
				if i>1
					fun=str2mat(fun(1:i-1,:),fun(i,5:length(deblank(fun(i,:)))),fun(i+1:k,:));
				else
					fun=str2mat(fun(i,5:length(deblank(fun(i,:)))),fun(i+1:k,:));
				end
				fdata=[fdata;1;dims(i,1)];
			else
				fdata=[fdata;0;dims(i,1)];
			end
		else
			fdata=[fdata;0;dims(i,1)];
		end
	end
