echo on 
 
%
% First doing a function evaluation, using K=10(number of nested function invokations)
%
f=funcvalJExt('CF',fun,ones(20,1),[],10);
f
pause
%
% Doing a J*V, using K=10(number of nested function invokations)
%
V=ones(20,1);
[f,JV]=ExtJV('CF',fun,ones(20,1),V,[],10);
JV
pause
%
% Now doing a reverse product W^T*J, using K=4
%
W=ones(20,1);
[f,WJ]=ExtWJ('CF',fun,ones(20,1),W,[],4);
WJ

%
% Now evaluating extended J , using K=10
%

[f,extJ]=evalJExt('CF',fun,ones(20,1),[],10,[],[],JPI);

%Sparsity structure of extended J

figure(1)
spy(extJ)
pause
% Now lets also compute the full Jacobian usinf linear algebra on Extended J

[f,extJ,J]=evalJExt('CF',fun,ones(20,1),[],10,[],[],JPI);
 
%Sparsity structure of J
 
figure(2)
spy(J)

echo off 
