echo on 
 
%
% First doing a function evaluation
%
f=funcvalJExt('GF',fun,ones(20,1),2);
f
pause
%
% Doing a J*V, using K=2(number of nested function invokations)
%
V=ones(20,1);
[f,JV]=ExtJV('GF',fun,ones(20,1),V,2);
f
JV
pause
%
% Now doing a reverse product W^T*J, using K=2
%
W=ones(20,1);
[f,WJ]=ExtWJ('GF',fun,ones(20,1),W,2);
f
WJ
pause
%
% Now evaluating extended J , using K=2
%

[f,extJ]=evalJExt('GF',fun,ones(20,1),2,[],JPI);
f
%Sparsity structure of extended J

figure(1)
spy(extJ)
pause
% Now lets also compute the full Jacobian usinf linear algebra on Extended J

[f,extJ,ns,J]=evalJExt('GF',fun,ones(20,1),2,[],JPI);
 
%Sparsity structure of J
 
figure(2)
spy(J)

echo off 
