echo on 
 
%
% First doing a function evaluation
%
f=funcvalJExt('GI',fun,ones(20,1),[],20,[],[],2,[],[],0.1);
f
pause
%
% Doing a H*V
%
V=ones(20,1);
[f,JV]=ExtJV('GI',fun,ones(20,1),V,[],20,[],[],2,[],[],0.1);
JV
pause

%
% Doing a V'*H*V
%
W=ones(20,1);
[f,WJ]=ExtWJ('GI',fun,ones(20,1),W,[],20,[],[],2,[],[],0.1);
WJ
pause

%
% Now evaluating extended J 
%

[f,extJ]=evalJExt('GI',fun,ones(20,1),[],20,JPI,[],[],[],2,[],[],0.1);

%Sparsity structure of extended J

figure(1)
spy(extJ)
pause
% Now lets also compute the full Jacobian usinf linear algebra on Extended J

[f,extJ,ns,J]=evalJExt('GI',fun,ones(20,1),[],20,JPI,[],[],[],2,[],[],0.1);
 
%Sparsity structure of J
 
figure(2)
spy(J)

echo off 
