echo on 
 
%
% First doing a function evaluation
%
f=funcvalJExt('GP',fun,ones(20,1),[],20);
f
pause
%
% Doing a J*V
%
V=ones(20,1);
[f,JV]=ExtJV('GP',fun,ones(20,1),V,[],20);
JV
pause
%
% Now doing a reverse product W^T*J 
%
W=ones(20,1);
[f,WJ]=ExtWJ('GP',fun,ones(20,1),W,[],20);
WJ

%
% Now evaluating extended J 
%

[f,extJ]=evalJExt('GP',fun,ones(20,1),[],20,JPI);

%Sparsity structure of extended J

figure(1)
spy(extJ)
pause
% Now lets also compute the full Jacobian using linear algebra on Extended J

[f,extJ,ns,J]=evalJExt('GP',fun,ones(20,1),[],20,JPI);
 
%Sparsity structure of J
 
figure(2)
spy(J)

echo off 
