function [f,g,H,ns]=compJ(class,fun,x,fdata,EJPI)

%
%funcvalJExt
%
%       compute the function value.
%
%       f=funcvalJExt(class,fun,x)
%
%       Please refer to ADMIT-2 users manual for complete reference.
%
%       ALSO SEE configureExtfun, evalHExt, ExtJV, ExtWJ, ExtHV, ExtVHV
%
%
%       ******************************************************************
%       *              ADMIT-2 Project   1996-97                         *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************

n=length(x);
 
if nargin < 4 fdata=[]; end
if nargin < 5 EJPI=[]; end
if isempty(EJPI)
                EJPI=GetExtJPI(class,fun,n,fdata);
end
 
if isempty(fdata)
        [fun,fdata]=MakeExtFdata(class,fun,n);
end

[f,g]=funcvalExt(class,fun,x,fdata,EJPI);
if nargout >=3
[f,H]=ExtHV(class,fun,x,eye(n),fdata);
end
if nargout==4
ns=-H\g;
end
