function [f,J,ns]=compJ(class,fun,x,fdata)
%
%funcvalJExt
%
%       compute the function value.
%
%       f=funcvalJExt(class,fun,x)
%
%       Please refer to ADMIT-2 users manual for complete reference.
%
%       ALSO SEE configureExtfun, evalHExt, ExtJV, ExtWJ, ExtHV, ExtVHV
%
%
%       ******************************************************************
%       *              ADMIT-2 Project   1996-97                         *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************

n=length(x);
if nargin < 4 fdata=[]; end
 
if isempty(fdata)
        [fun,fdata]=MakeExtFdata(class,fun,n);
end
 
[f,J]=ExtJV(class,fun,x,eye(n),fdata);
if nargout==3
ns=-J\f;
end
