function [f,g,extH]=evalHDI1(fun,fdata,x,PartInfo)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Recover
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

n=length(x);
        ExtraArg=fdata.py0;
        impl=fdata.impl;
        k=fdata.k;
        kind=fdata.kind;
        numstates=fdata.numstates;
        dims=fdata.dims;
        sizep=dims(1);
        m=dims(2);
        consts=fdata.consts;
        outind = fdata.outind;
        yfinal=fdata.yfinal;

 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Recovery complete
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
total=ceil(abs((k(2)-k(1))/k(3)));
if ((k(2) < k(1)) & (k(3) > 0))
        k(3)=-k(3);
end
 
data=[0;numstates;sizep;k(3);k(1);1;consts];
 
oldf=[zeros((numstates-1)*sizep,1);ExtraArg];
f=oldf; 
 
Identity=-speye(sizep);
extH=sparse(0,n+sizep);

if size(fun,1) > 1
[JPI,HPI1,HPI2]=ExtractJPI(PartInfo);
else
[JPI,HPI1]=ExtractJPI(PartInfo);
end
y=zeros(sizep,total+1);
y(:,1)=ExtraArg;
accumy=ExtraArg;
 
 
index=1;
for i=1:total-1
        [y(:,i+1),J]=evalJ(fun(1,:),[x;oldf],data,sizep,JPI);
        data(5)=data(5)+k(3);
        data(6)=data(6)+1;
                oldf=[oldf(sizep+1:numstates*sizep);y(:,i+1)];
       if i < numstates
                extH=[extH sparse((i-1)*sizep,sizep); J(:,[1:n n+1+(numstates-i)*sizep:n+numstates*sizep]) Identity];
        else
                extH=[extH sparse((i-1)*sizep,sizep); 
J(:,1:n) sparse(sizep,(i-numstates)*sizep) J(:,n+1:n+numstates*sizep) Identity];
        end
	accumy=[accumy;y(:,i+1)];
end

 
if total > 0
        data(4)=k(2)-(total-1)*k(3);
        [f,J]=evalJ(fun(1,:),[x;oldf],data,n,JPI);
        if total >= numstates
                extH=[extH sparse((total-1)*sizep,sizep); 
J(:,1:n) sparse(sizep,(total-numstates)*sizep) J(:,[1:n n+1+(numstates-total)*sizep:n+numstates*sizep]) Identity];
        else
                extH=[extH sparse((total-1)*sizep,sizep); J(:,1:n+total*sizep) Identity];
        end
else
        f=x;
end
 
datag=n;
outm=sizep;

        g_input=f;
 
        if length(outind)==1
            if outind==0
                if size(fun,1) > 1
                        outm=m;
                        [f,J]=evalJ(fun(2,:),[x;f],datag,m,JPI2);
                        extH=[extH ; J(1:n) sparse(m,total*sizep) J(:,n+1:sizep+n)];
                else
                        extH=extH(:,1:size(extH,2)-sizep);
                end
 
           else
                g_input=accumy;
        % all ys, do it
                if size(fun,1) > 1
                [f,J]=evalJ(fun(2,:),[x;accumy],datag,m,JPI2);
                        extH=[extH; J];
                        outm=m;
                else
			f=g_input;
                        outm=(total+1)*sizep;
                        extH=[extH ; sparse((total+1)*sizep,n) speye((total+1)*sizep) ];
                end
          end
        else
        % outputindex is active
        outindy=[];
        for count=1:size(outind,1)
                outindy=[outindy;y(outind(count,2)),outind(count,1)];
                ind=[ind;outind(count,1)*n+outind(count,2)];
        end
        if size(fun,1) > 1
                [f,J]=evalJ(fun(2,:),[ExtraArg;outindy],datag,m,JPI2);
                myJ=sparse(m,(total+1)*sizep);
                myJ(:,ind)=J(:,n+1:n+length(outindy));
                outm=m;
                extH=[extH; sparse(outm,n) myJ];
        else
		f=outindy;
                outm=length(outindy);
                myJ=sparse(length(outindy),(total+1)*sizep);
                myJ(:,ind)=speye(length(outindy));
                extH=[extH; sparse(outm,n) myJ];
        end
                g_input=outindy;
 
        end

[nrows,ncols]=size(extH);
extH=[extH(1:nrows-outm,:) sparse(nrows-outm,outm) ; extH(nrows-outm+1:nrows,:) -speye(outm)];
extH=[extH(:,1:n)  extH(:,1+n+sizep:size(extH,2))];
[nrows,ncols]=size(extH);
f=f-yfinal;
grad_y=[zeros(nrows-outm,1);f];
f=0.5*(f'*f);
L=extH(:,n+1:ncols);
w= -L'\grad_y;
g=extH(:,1:n)'*w;
windex=1;

% Do Hessians Now
% Extract all HPIs and compute evalH	

oldf=[zeros((numstates-1)*sizep,1);ExtraArg];
HessP=sparse(ncols-outm+sizep,ncols-outm+sizep);
data=[0;numstates;sizep;k(3);k(1);1;consts];
for i=1:total-1
        [val,H]=evalHTens(fun(1,:),[x;oldf],w(windex:windex+sizep-1),data,HPI1);
                oldf=[oldf(sizep+1:numstates*sizep);val];
	if i < numstates
	HessP=HessP+[H([1:n n+(numstates-i)*sizep:n+numsstates*sizep],[1:n n+(numstates-i)*sizep:n+numsstates*sizep])
sparse(n+i*sizep,(total-i)*sizep); 
		sparse((total-i)*sizep,n+total*sizep)];
        else
HessP=HessP+[H(1:n,1:n) sparse(n,(i-numstates)*sizep) H(1:n,n+1:n+numstates*sizep) sparse(n,(total-i)*sizep);
sparse((i-numstates)*sizep,n+total*sizep);
H(n+1:n+numstates*sizep,1:n) sparse(numstates*sizep,(i-numstates)*sizep) H(n+1:n+numstates*sizep,n+1:n+numstates*sizep) sparse(numstates*sizep,(total-i)*sizep);
                sparse((total-i)*sizep,n+(total)*sizep)];

        end

	windex=windex+sizep;
	data(5)=data(5)+k(3);
        data(6)=data(6)+1;
end
if total > 0
        data(4)=k(2)-(total-1)*k(3);
        [val,H]=evalHTens(fun(1,:),[x;oldf],w(windex:windex+sizep-1),data,HPI1);
        if total < numstates
	HessP=HessP+H([1:n n+(numstates-total)*sizep:n+numsstates*sizep],[1:n n+(numstates-total)*sizep:n+numsstates*sizep]);
        else
	HessP=HessP+[H(1:n,1:n) sparse(n,(total-numstates)*sizep) H(1:n,n+1:n+numstates*sizep);
sparse((total-numstates)*sizep,n+total*sizep);
H(n+1:n+numstates*sizep,1:n) sparse(numstates*sizep,(total-numstates)*sizep) H(n+1:n+numstates*sizep,n+1:n+numstates*sizep)];
        end
	windex=windex+sizep;
else
        f=x;
end

datag=n;
index=8+sizep+fdata(8+sizep)+1;
 
        if length(outind)==1
                if outind==0
                if size(fun,1) > 1
                [val,H]=evalHTens(fun(2,:),[x;g_input],w(windex:windex+outm-1),datag,HPI2);
 HessP=HessP+[H(1:n,1:n) sparse(n,total*sizep) H(1:n,n+1:n+sizep) sparse(n,ncols-outm-(total)*sizep-n);
             H(n+1:n+sizep,1:n) sparse(sizep,total*sizep) H(n+1:n+sizep,n+1:n+sizep)
		sparse(sizep,ncols-outm-(total)*sizep-n);
                sparse(ncols-outm-(total)*sizep-n,ncols-outm+sizep)];
                end
                else
                g_input=accumy;
        % all ys, do it
                if size(fun,1) > 1
                [val,H]=evalHTens(fun(2,:),[x;g_input],w(windex:windex+outm-1),datag,HPI2);
                HessP=HessP+H(1:n+(total+1)*sizep,1:n+(total+1)*sizep);
                end
                end
        else
        % outputindex is active
        outindy=[];
        for count=1:size(outind,1)
                outindy=[outindy;y(outind(count,2)),outind(count,1)];
                ind=[ind;outind(count,1)*n+outind(count,2)];
        end
        if size(fun,1) > 1
                [val,H]=evalHTens(fun(2,:),[x;g_input],w(windex:windex+outm-1),datag,HPI2);
                myJ=sparse(ncols-outm+sizep,ncols-outm+sizep);
                myJ([(1:n)';ind],[(1:n)';ind])=H(1:n+length(outindy),1:n+length(outindy));;
                HessP=HessP+myJ;
        end
        end


	HessP=HessP([1:n n+sizep+1:size(HessP,1)] , [1:n  n+sizep+1:size(HessP,2)]);
        HessP=[HessP sparse(ncols-outm,outm); sparse(outm,ncols-outm) speye(outm)];
        extH=[extH sparse(nrows,nrows); HessP(n+1:ncols,:) extH(1:nrows,n+1:ncols)';
             HessP(1:n,:) extH(1:nrows,1:n)'];
