function [f,g,extH]=evalHGC(fun,fdata,x,PartInfo)

 
k=fdata.k;
m=fdata.m;
data=0;
n=length(x);
 
index=1;
Identity=-speye(k*m);

f=x;
[JPI,HPI1,HPI2]=ExtractJPI(PartInfo);
	[f,J]=evalJ(fun(1,:),f,data,k*m,JPI);

	extH=[J Identity];

% Do gradient first
[f,w]=funcval(fun(2,:),f,data);
g=w'*J;

% Do Hessians Now
% Extract all HPIs and compute evalH	
f=x;
HessP=sparse(k*m+n,k*m+n);

        [f,H1]=evalHTens(fun(i,:),f,w,data,HPI1);
        [f,g,H2]=evalH(fun(2,:),f,data,HPI2);

	HessP=[H1 sparse(n,k*m); sparse(k*m,n) H2];
       extH=[extH sparse(k*m,k*m); HessP(n+1:k*m+n,:) extH(1:k*m,n+1:k*m+n)';
             HessP(1:n,:) extH(1:k*m,1:n)'];


