function [f,extH]=evalHDO(fun,fdata,x,PartInfo)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Recover
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

n=length(x);
k=fdata.k;
dims=fdata.dims;
ExtraArg=fdata.py0;
sizep=dims(1);
sizestate=dims(2);
 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Recovery complete
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
Identity=-speye(sizestate);
JPI=ExtractJPI(PartInfo);
y=zeros(sizep,k+1);
y(:,1)=ExtraArg;
accumy=ExtraArg;
data=sizep; 
extH=sparse(0,k*sizep+sizestate);
for i=1:k
        [y(:,i+1),J]=evalJ(fun(1,:),[x((i-1)*sizep+1:i*sizep);y(:,i)],data,sizestate,JPI);
	       extH=[extH sparse((i-1)*sizestate,sizestate); 
sparse(sizestate,(i-1)*sizep) J(:,1:sizep) sparse(sizestate,(k-i)*sizep+(i-1)*sizestate) J(:,sizep+1:sizestate+sizep) Identity];
	accumy=[accumy;y(:,i+1)];
end
datag=[k;sizep];
[nrows,ncols]=size(extH);
[f,grad_y]=funcval(fun(2,:),[x;accumy],datag);
extH=[extH; grad_y'];
