function [f,extJ]=evalJDI1(fun,fdata,x,PartInfo)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Recover
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
n=length(x);
        ExtraArg=fdata.py0;
        impl=fdata.impl;
        k=fdata.k;
        kind=fdata.kind;
        numstates=fdata.numstates;
        dims=fdata.dims;
        sizep=dims(1);
        m=dims(2);
        consts=fdata.consts;
        outind = fdata.outind;
        yfinal=fdata.yfinal;

 
 
 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Recovery complete
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
total=ceil(abs((k(2)-k(1))/k(3)));
if ((k(2) < k(1)) & (k(3) > 0))
        k(3)=-k(3);
end
 
 
data=[0;numstates;sizep;k(3);k(1);1;consts];
dataI=[1;numstates;sizep;k(3);k(1);1;consts];
 
oldf=[zeros((numstates-1)*n,1);x];
 

Identity=-speye(n);
extJ=sparse(0,n);
if size(fun,1) > 1
        [JPI1,JPI2]=ExtractJPI(PartInfo);
else
        JPI1=PartInfo;
end
 
y=zeros(n,total+1);
y(:,1)=x;
accumy=x;


for i=1:total-1
	y(:,i+1)=funcvalJ(fun(1,:),[ExtraArg;oldf],n,data);
	[dummy,J]=evalJ(fun(1,:),[ExtraArg;oldf;y(:,i+1)],dataI,n,JPI1);
        oldf=[oldf(n+1:numstates*n);y(:,i+1)];
        if i < numstates
		extJ=[extJ sparse((i-1)*n,n); J(:,sizep+(numstates-i)*n+1:sizep+(numstates+1)*n)];
	else
		extJ=[extJ sparse((i-1)*n,n); sparse(n,(i-numstates)*n) J(:,sizep+1:sizep+(numstates+1)*n)];
	end
	data(5)=data(5)+k(3);
        data(6)=data(6)+1;
	dataI(5)=dataI(5)+k(3);
        dataI(6)=dataI(6)+1;
	accumy=[accumy;y(:,i+1)];
end

if total > 0
        data(4)=k(2)-(total-1)*k(3);
        dataI(4)=k(2)-(total-1)*k(3);
	y(:,total+1)=funcvalJ(fun(1,:),[ExtraArg;oldf],n,data);
	[dummy,J]=evalJ(fun(1,:),[ExtraArg;oldf;y(:,total+1)],dataI,n,JPI1);
        if total < numstates
		extJ=[extJ sparse((total-1)*n,n); J(:,sizep+(numstates-total)*n+1:sizep+(numstates+1)*n)];
	else
		extJ=[extJ sparse((total-1)*n,n); sparse(n,(total-numstates)*n) J(:,sizep+1:sizep+(numstates+1)*n)];
	end
	accumy=[accumy;y(:,total+1)];
        f=y(:,total+1);
else
        f=x;
end

outm=n;
 
        datag=sizep;
        if length(outind)==1
                if outind==0
                if size(fun,1) > 1
                        [f,J]=evalJ(fun(2,:),[ExtraArg;f],datag,m,JPI2);
                        extJ=[extJ; sparse(m,total*n) J(:,sizep+1:sizep+n)];
                        outm=m;
                else
                        extJ=extJ(:,1:size(extJ,2)-n);
                end
                else
        % all ys, do it
                if size(fun,1) > 1
                [f,J]=evalJ(fun(2,:),[ExtraArg;accumy],datag,m,JPI2);
                        extJ=[extJ; J(:,sizep+1:sizep+(total+1)*n)];
                        outm=m;
                else
			f=accumy;
                        outm=(total+1)*n;
                        extJ=[extJ; speye((total+1)*n)];
                end
                end
        else
        % outputindex is active
        outindy=[];
        for count=1:size(outind,1)
                outindy=[outindy;y(outind(count,2)),outind(count,1)];
                ind=[ind;outind(count,1)*n+outind(count,2)];
	end
        if size(fun,1) > 1
        [f,J]=evalJ(fun(2,:),[ExtraArg;outindy],datag,m,JPI2);
        myJ=sparse(m,(total+1)*n);
        myJ(:,ind)=J(:,sizep+1:sizep+length(outindy));
        extJ=[extJ; myJ];
        outm=m;
        else
	f=outindy;
        outm=length(outindy);
        myJ=sparse(length(outindy),(total+1)*n);
        myJ(:,ind)=speye(length(outindy));
        extJ=[extJ; myJ];
        end
 
        end
 
f=f-yfinal;
 
