function [f,extJ]=evalJDI1(fun,fdata,x,PartInfo)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Recover
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
n=length(x);
        ExtraArg=fdata.py0;
        impl=fdata.impl;
        k=fdata.k;
        kind=fdata.kind;
        numstates=fdata.numstates;
        dims=fdata.dims;
        sizep=dims(1);
        m=dims(2);
        consts=fdata.consts;
        outind = fdata.outind;
        yfinal=fdata.yfinal;

 
 
 
 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Recovery complete
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
total=ceil(abs((k(2)-k(1))/k(3)));
if ((k(2) < k(1)) & (k(3) > 0))
        k(3)=-k(3);
end
 
data=[0;numstates;sizep;k(3);k(1);1;consts];
dataI=[1;numstates;sizep;k(3);k(1);1;consts];
 
oldf=[zeros((numstates-1)*sizep,1);ExtraArg];
f=ExtraArg;
 

Identity=-speye(sizep);
extJ=sparse(0,n+sizep);
if size(fun,1) > 1
        [JPI1,JPI2]=ExtractJPI(PartInfo);
else
        JPI1=PartInfo;
end
 
y=zeros(sizep,total+1);
y(:,1)=ExtraArg;
accumy=ExtraArg;
 

for i=1:total-1
	y(:,i+1)=funcvalJ(fun(1,:),[x;oldf],n,data);
        [dummy,J]=evalJ(fun(1,:),[x;oldf;y(:,i+1)],dataI,sizep,JPI1);
        oldf=[oldf(sizep+1:numstates*sizep);y(:,i+1)];
	if total < numstates
		extJ=[extJ sparse((i-1)*sizep,sizep); J(:,1:n) J(:,n+(numstates-i)*sizep+1:n+(numstates+1)*sizep)];
        else
		extJ=[extJ sparse((i-1)*sizep,sizep); J(:,1:n) sparse(sizep,(i-numstates)*sizep) J(:,n+1:n+(numstates+1)*sizep)];
        end
	data(5)=data(5)+k(3);
        data(6)=data(6)+1;
	dataI(5)=dataI(5)+k(3);
        dataI(6)=dataI(6)+1;
	accumy=[accumy;y(:,i+1)];
end

if total > 0
        data(4)=k(2)-(total-1)*k(3);
        dataI(4)=k(2)-(total-1)*k(3);
	y(:,total+1)=funcvalJ(fun(1,:),[x;oldf],n,data);
        [dummy,J]=evalJ(fun(1,:),[x;oldf;y(:,total+1)],dataI,sizep,JPI1);
	if total < numstates
		extJ=[extJ sparse((total-1)*sizep,sizep);J(:,1:n) J(:,n+(numstates-total)*sizep+1:n+(numstates+1)*sizep) ];
        else
		extJ=[extJ sparse((total-1)*sizep,sizep); J(:,1:n) sparse(sizep,(total-numstates)*sizep) J(:,n+1:n+(numstates+1)*sizep)];
        end
	accumy=[accumy;y(:,total+1)];
        f=y(:,total+1);
else
        f=x;
end


outm=sizep;
datag=n;
 
        if length(outind)==1
                if outind==0
                if size(fun,1) > 1
                outm=m;
                [f,J]=evalJ(fun(2,:),[x;f],datag,m,JPI2);
                extJ=[extJ; J(:,1:n) sparse(m,total*sizep) J(:,n+1:sizep+n)];
                else
                        extJ=[extJ(:,1:n)  extJ(:,1+n+sizep:size(extJ,2)-sizep)];
                end
                else
        % all ys, do it
 
        if size(fun,1) > 1
                outm=m;
                [f,J]=evalJ(fun(2,:),[x;accumy],datag,m,JPI2);
                        extJ=[extJ; J(:,1:n+(total+1)*sizep)];
        else
		f=accumy;
                outm=m;
                extJ=[extJ; sparse((total+1)*sizep,n) speye((total+1)*sizep)];
        end
 
                end
        else
        % outputindex is active
        outindy=[];
        for count=1:size(outind,1)
                outindy=[outindy;y(outind(count,2)),outind(count,1)];
                ind=[ind;outind(count,1)*n+outind(count,2)];
        end
        if size(fun,1) > 1
        outm=m;
        [f,J]=evalJ(fun(2,:),[x;outindy],datag,m,JPI2);
        myJ=sparse(m,(total+1)*sizep);
        myJ(:,ind)=J(:,n+1:n+length(outindy));
        extJ=[extJ; J(:,1:n) myJ];
 
        else
	f=outindy;
        outm=length(outindy);
        myJ=sparse(length(outindy),(total+1)*sizep);
        myJ(:,ind)=speye(length(outindy));
        extJ=[extJ; sparse(length(outindy),n) myJ];
 
        end
 
        end
f=f-yfinal;
 
extJ=[extJ(:,1:n)  extJ(:,1+n+sizep:size(extJ,2))];

spy(extJ)
