function A = gangstr(M,tol);
  [m,n] = size(M);
  if nargin < 2, tol = 1e-2; end
%
% Normalize M
  X=diag(M*M');
  X(find(X==0))=ones(length(find(X==0)),1);
  M=spdiags(1./sqrt(X),0,m,m)*M;


% Remove nonzeros
  dim = sprank(M);
  sprA = 0;
  A=M;
  while sprA < dim
    absM=abs(M);
    maxvec=full(tol*max(absM));
    maxM = repmat(maxvec,m,1);
    A = M.*(absM > maxM);
    sprA = sprank(A);
    tol = tol/10;
  end
