% Demo initialization ====================
path(path,'/home/verma/LSOT');
if ~exist('SlideShowGUIFlag'), figNumber=0; end;

if ssinit(figNumber),
    str = str2mat(' ',' ',' ',' ','This demo illustrates the working of  MATLAB AD toolbox(ADMAT) ', ...
      ' -- A toolbox written in MATLAB for Automatic differentiation of M-files ',...
      ' ', ...
      ' Press the "Start" button to see the demonstration.');
    ssdisp(figNumber,str);                                      
    drawnow;
if figNumber, return; end;
end
    str = str2mat(...
      ' This demo has three parts ', ...
      ' ', ...
      ' 1. Demo of the MATLAB AD tool ', ...
      ' 2. Demo of ADMIT-1 layer (uses MATLAB AD tool) ', ...
      ' 3. Demo of ADMIT-2 layer (uses ADMIT-1 & MATLAB AD tool) ', ...
      ' 4. Some timing comparisons ', ...
      ' ', ...
      ' Press next to choose a demo ', ...
      ' ');
ssdisp(figNumber,str);
drawnow;
if get(findobj(figNumber,'string','AutoPlay'),'value') pause(2) ; end ;
if sspause(figNumber), return; end;
 


% Beginning of the demo ==================

% Make sure the figure has black background

%set(gcf,'Color',[0 0 0]) ;

k=menu('Choose a Class of Problem','MATLAB AD tool Demo','ADMIT-1 demo',...
	'ADMIT-2 demo', 'Timing Demo');
if k==1
% Partial separable demo
	sshow demoadmat;
elseif k==2
% Composite function
	sshow ADMIT1demo;
elseif k==3
	sshow ADMIT2demo;
else
	sshow demotiming;
end


