function []=GPsetup(fig2)

set(fig2,'position',[200 500 300 250]);

controltext=uicontrol(fig2,'Style','text','String','Current Asset Price','Position',[0 225 100 20]);
setupSPRICE=uicontrol(fig2,'Style','edit','String','100','Position',[100 225 100 20]);

controltext=uicontrol(fig2,'Style','text','String','Exericise price','Position',[0 200 100 20]);
setupEPRICE=uicontrol(fig2,'Style','edit','String','95','Position',[100 200 100 20]);

controltext=uicontrol(fig2,'Style','text','String','IRATE','Position',[0 175 100 20]);
setupIRATE=uicontrol(fig2,'Style','edit','String','.1','Position',[100 175 100 20]);

controltext=uicontrol(fig2,'Style','text','String','DRATE','Position',[0 150 100 20]);
setupDRATE=uicontrol(fig2,'Style','edit','String','0','Position',[100 150 100 20]);

controltext=uicontrol(fig2,'Style','text','String','T','Position',[0 125 100 20]);
setupETIME=uicontrol(fig2,'Style','edit','String','0.25','Position',[100 125 100 20]);

controltext=uicontrol(fig2,'Style','text','String','DT(only for bin model)','Position',[0 100 100 20]);
setupDT=uicontrol(fig2,'Style','edit','String','0.05','Position',[100 100 100 20]);

controltext=uicontrol(fig2,'Style','text','String','VOLAT','Position',[0 75 100 20]);
setupVOLAT=uicontrol(fig2,'Style','edit','String','0.5','Position',[100 75 100 20]);

setupok=uicontrol(fig2,'Style','push','String','OK','Position',[100 0 100 20],'CallBack',...
        'closesetupfin');
setupcancel=uicontrol(fig2,'Style','push','String','CANCEL','Position',[0 0 100 20],'CallBack',...
        'closewin');

set(setupSPRICE,'Tag','SPRICE');
set(setupEPRICE,'Tag','EPRICE');
set(setupIRATE,'Tag','IRATE');
set(setupDRATE,'Tag','DRATE');
set(setupETIME,'Tag','ETIME');
set(setupDT,'Tag','DT');
set(setupVOLAT,'Tag','VOLAT');
