function []=GPsetup(fig2)

set(fig2,'position',[200 500 350 300]);

controltext=uicontrol(fig2,'Style','text','String','Option value Data','Position',[0 275 100 20]);
setupCALLV=uicontrol(fig2,'Style','edit','String','[10;12]','Position',[100 275 100 20]);
controltext=uicontrol(fig2,'Style','text','String','Minimizaton function','Position',[0 250 100 20]);
setupFUN=uicontrol(fig2,'Style','edit','String','sqrmin','Position',[100 250 100 20]);

controltext=uicontrol(fig2,'Style','text','String','Current Asset Price','Position',[0 225 100 20]);
setupSPRICE=uicontrol(fig2,'Style','edit','String','[100;102]','Position',[100 225 100 20]);

controltext=uicontrol(fig2,'Style','text','String','Exericise price','Position',[0 200 100 20]);
setupEPRICE=uicontrol(fig2,'Style','edit','String','95','Position',[100 200 100 20]);

controltext=uicontrol(fig2,'Style','text','String','IRATE','Position',[0 175 100 20]);
setupIRATE=uicontrol(fig2,'Style','edit','String','.1','Position',[100 175 100 20]);

controltext=uicontrol(fig2,'Style','text','String','DRATE','Position',[0 150 100 20]);
setupDRATE=uicontrol(fig2,'Style','edit','String','0','Position',[100 150 100 20]);

controltext=uicontrol(fig2,'Style','text','String','T','Position',[0 125 100 20]);
setupETIME=uicontrol(fig2,'Style','edit','String','0.25','Position',[100 125 100 20]);

controltext=uicontrol(fig2,'Style','text','String','DT(for bin model)','Position',[0 100 100 20]);
setupDT=uicontrol(fig2,'Style','edit','String','0.05','Position',[100 100 100 20]);

controltext=uicontrol(fig2,'Style','text','String','VOLAT','Position',[0 75 100 20]);
setupVOLAT=uicontrol(fig2,'Style','edit','String','','Position',[100 75 100 20]);

setupok=uicontrol(fig2,'Style','push','String','OK','Position',[100 0 100 20],'CallBack',...
        'closesetupfinopt');
setupcancel=uicontrol(fig2,'Style','push','String','CANCEL','Position',[0 0 100 20],'CallBack',...
        'closewinopt');

set(setupCALLV,'Tag','CALLV');
set(setupFUN,'Tag','FUN');
set(setupSPRICE,'Tag','SPRICE2');
set(setupEPRICE,'Tag','EPRICE2');
set(setupIRATE,'Tag','IRATE2');
set(setupDRATE,'Tag','DRATE2');
set(setupETIME,'Tag','ETIME2');
set(setupDT,'Tag','DT2');
set(setupVOLAT,'Tag','VOLAT2');
