function A = compA(sigma,r,q)
global K
global M
global T
global N
global NNew
global c
global S
global TV
Nnew=length(sigma);
if isa(r,'deriv') Nnew=deriv(Nnew); end
if isa(q,'deriv') Nnew=deriv(Nnew); end

TV=linspace(0,T,M); TV=TV(:);
x1=0;
x2=2*K;
S=linspace(x1,x2,N); S=S(:);
dx = (x2-x1)/(N-1);
dt = T/(M-1);
x = linspace(1,N-2,N-2); x=x(:);
sigma=sigma(1:N-2);

a= 0.5*(r-q)*dt*x-0.5*sigma.*sigma.*x.*x*dt;
b= 1+sigma.*sigma.*x.*x*dt+r*dt;
c= -0.5*(r-q)*dt*x-0.5*sigma.*sigma.*x.*x*dt;
A=spdiags([[a(2:N-2);0] b [0; c(1:N-3)]],-1:1,N-2,N-2);
