function u = solveoptie(sigma,r,q)
%
% Make the transformation etc.
%
global T
global M
global K
global N
global u
global S
global V
global TV

global A
global dx
global Nnew
global c
% Set up default parameters if not provided 

Nnew=length(sigma);
if isa(r,'deriv') Nnew=deriv(Nnew); end
if isa(q,'deriv') Nnew=deriv(Nnew); end
if isempty(M) M=4; end
TV=linspace(0,T,M); TV=TV(:);
x1=0;
x2=2*K;
S=linspace(x1,x2,N); S=S(:);

dx = (x2-x1)/(N-1);

dt = T/(M-1);

u=max(S-K,0);

x = linspace(1,N-2,N-2); x=x(:);
sigma=sigma(1:N-2);
a= 0.5*(r-q)*dt*x-0.5*sigma.*sigma.*x.*x*dt;
b= 1+sigma.*sigma.*x.*x*dt+r*dt;
c= -0.5*(r-q)*dt*x-0.5*sigma.*sigma.*x.*x*dt;
A=spdiags([[a(2:N-2);0] b [0; c(1:N-3)]],-1:1,N-2,N-2);

t=T;
V=u;
for i = dt : dt : T
	t=t-dt;
	u1=timestepie(u);
	u=u1;
V=[V u];
end
