function y = brown1(x,Extra);
      imx=10; jmx=10; ntx=5;
      h=1.0;
      k=0.55;
      ii=1;
      u2=x;
      u1=ones(2*imx+1,2*jmx+1);
      c=ones(2*imx+1,2*jmx+1);
      f=ones(ntx,1);
      pi=4.*atan2(1.,1.);
      dta=2*pi/ntx;
      for nta=0:ntx-1
          ta=nta*dta;
          xta=4.*cos(ta);
          yta=4.*sin(ta);
          ita(nta+1)=floor(xta/h);
          jta(nta+1)=floor(yta/h);
      end
      for i=0:ntx-1
          u2(ita(i+1)+imx+1,jta(i+1)+jmx+1)=...
                 u2(ita(i+1)+imx+1,jta(i+1)+jmx+1)+2.*h*f(i+1);
      end
      for j=-jmx+1:jmx-1
      for i=-imx+1:imx-1
              lapu=(u2(i+1+imx+1,j+jmx+1)+u2(i-1+imx+1,j+jmx+1)+u2(i+imx+1,j+jmx+1+1)+u2(i+imx+1,j+jmx+1-1)-...
                   4.*u2(i+imx+1,j+jmx+1))/(h^2);
              preu=(u1(i+imx+1,j+jmx+1)-2.*u2(i+imx+1,j+jmx+1))/(c(i+imx+1,j+jmx+1)^2*(k^2));
              coef=1./(c(i+imx+1,j+jmx+1)^2*(k^2));
              u3(i+imx+1,j+jmx+1)=(lapu-preu)/coef;
      end
	end
for j=-jmx+2:jmx-2
          ck=c(-imx+imx+1,j+jmx+1)*k;
          a1=1./(2.*ck*h)+1./(2.*ck^2);
          a2=1./(2.*ck*h)-1./(2.*ck^2)-1./(2.*h^2);
          a3=1./(4.*h^2);
          a4=1./(ck^2);
          a5=-a1;
          a6=a2;
          a7=a3;
          u3(-imx+imx+1,j+jmx+1)=(a2*u3(-imx+1+imx+1,j+jmx+1)+...
                   a3*(u3(-imx+1+imx+1,j+1+jmx+1)+u3(-imx+1+imx+1,j-1+jmx+1))+...
                   a4*(u2(-imx+imx+1,j+jmx+1)+u2(-imx+1+imx+1,j+jmx+1))+...
                   a5*u1(-imx+1+imx+1,j+jmx+1)+...
                   a6*u1(-imx+imx+1,j+jmx+1)+...
                   a7*(u1(-imx+imx+1,j-1+jmx+1)+u1(-imx+imx+1,j+1+jmx+1)))/a1;
      end
      ck=c(-imx+imx+1,-jmx+1+jmx+1)*k;
      a1=1./(2.*ck*h)+1./(2.*ck^2);
      a2=1./(2.*ck*h)-1./(2.*ck^2);
      a4=1./(ck^2);
      a5=-a1;
      a6=a2;
      a7=1./(ck^2)-1./(h^2);
      u3(-imx+imx+1,-jmx+1+jmx+1)=(a2*u3(-imx+1+imx+1,-jmx+1+jmx+1)+...
                  2.*a3*(u2(-imx+imx+1,-jmx+jmx+1)+u2(-imx+imx+1,-jmx+2+jmx+1))+...
                  a7*u2(-imx+imx+1,-jmx+1+jmx+1)+...
                  a4*u2(-imx+1+imx+1,-jmx+1+jmx+1)+...
                  a5*u1(-imx+1+imx+1,-jmx+1+jmx+1)+...
                  a6*u1(-imx+imx+1,-jmx+1+jmx+1))/a1;
      ck=c(-imx+imx+1,jmx-1+jmx+1)*k;
      a1=1./(2.*ck*h)+1./(2.*ck^2);
      a2=1./(2.*ck*h)-1./(2.*ck^2);
      a4=1./(ck^2);
      a5=-a1;
      a6=a2;
      a7=1./(ck^2)-1./(h^2);
      u3(-imx+imx+1,jmx-1+jmx+1)=(a2*u3(-imx+1+imx+1,jmx-1+jmx+1)+...
                  2.*a3*(u2(-imx+imx+1,jmx+jmx+1)+u2(-imx+imx+1,jmx-2+jmx+1))+...
                  a7*u2(-imx+imx+1,jmx-1+jmx+1)+...
                  a4*u2(-imx+1+imx+1,jmx-1+jmx+1)+...
                  a5*u1(-imx+1+imx+1,jmx-1+jmx+1)+...
                  a6*u1(-imx+imx+1,jmx-1+jmx+1))/a1;
      for j=-jmx+2:jmx-2
          ck=c(imx+imx+1,j+jmx+1)*k;
          a1=1./(2.*ck*h)+1./(2.*ck^2);
          a2=1./(2.*ck*h)-1./(2.*ck^2)-1./(2.*h^2);
          a3=1./(4.*h^2);
          a4=1./(ck^2);
          a5=-a1;
          a6=a2;
          a7=a3;
          u3(imx+imx+1,j+jmx+1)=(a2*u3(imx-1+imx+1,j+jmx+1)+...
                  a3*(u3(imx-1+imx+1,j+1+jmx+1)+u3(imx-1+imx+1,j-1+jmx+1))+...
                  a4*(u2(imx+imx+1,j+jmx+1)+u2(imx-1+imx+1,j+jmx+1))+...
                  a5*u1(imx-1+imx+1,j+jmx+1)+...
                  a6*u1(imx+imx+1,j+jmx+1)+...
                  a7*(u1(imx+imx+1,j-1+jmx+1)+u1(imx+imx+1,j+1+jmx+1)))/a1;
      end
      ck=c(imx+imx+1,-jmx+1+jmx+1)*k;
      a1=1./(2.*ck*h)+1./(2.*ck^2);
      a2=1./(2.*ck*h)-1./(2.*ck^2);
      a4=1./(ck^2);
      a5=-a1;
      a6=a2;
      a7=1./(ck^2)-1./(h^2);
      u3(imx+imx+1,-jmx+1+jmx+1)=(a2*u3(imx-1+imx+1,-jmx+1+jmx+1)+...
                  2.*a3*(u2(imx+imx+1,-jmx+jmx+1)+u2(imx+imx+1,-jmx+2+jmx+1))+...
                  a7*u2(imx+imx+1,-jmx+1+jmx+1)+...
                  a4*u2(imx-1+imx+1,-jmx+1+jmx+1)+...
                  a5*u1(imx-1+imx+1,-jmx+1+jmx+1)+...
                  a6*u1(imx+imx+1,-jmx+1+jmx+1))/a1;
      ck=c(imx+imx+1,jmx-1+jmx+1)*k;
      a1=1./(2.*ck*h)+1./(2.*ck^2);
      a2=1./(2.*ck*h)-1./(2.*ck^2);
      a4=1./(ck^2);
      a5=-a1;
      a6=a2;
      a7=1./(ck^2)-1./(h^2);
      u3(imx+imx+1,jmx+jmx+1-1)=(a2*u3(imx+imx+1-1,jmx+jmx+1-1)+...
                  2.*a3*(u2(imx+imx+1,jmx+jmx+1)+u2(imx+imx+1,jmx-2+jmx+1))+...
                  a7*u2(imx+imx+1,jmx+jmx+1-1)+...
                  a4*u2(imx-1+imx+1,jmx+jmx+1-1)+...
                  a5*u1(imx-1+imx+1,jmx+1+jmx-1)+...
                  a6*u1(imx+imx+1,jmx-1+jmx+1))/a1;
      for i=-imx+1:imx-1
          ck=c(i+imx+1,jmx+jmx+1)*k;
          a1=1./(2.*ck*h)+1./(2.*ck^2);
          a2=1./(2.*ck*h)-1./(2.*ck^2)-1./(2.*h^2);
          a4=1./(ck^2);
          a5=-a1;
          a6=a2;
          a7=a3;
          u3(i+imx+1,jmx+jmx+1)=(a2*u3(i+imx+1,jmx-1+jmx+1)+...
                  a3*(u3(i+1+imx+1,jmx-1+jmx+1)+u3(i-1+imx+1,jmx-1+jmx+1))+...
                  a4*(u2(i+imx+1,jmx+jmx+1)+u2(i+imx+1,jmx-1+jmx+1))+...
                  a5*u1(i+imx+1,jmx-1+jmx+1)+...
                  a6*u1(i+imx+1,jmx+jmx+1)+...
                  a7*(u1(i-1+imx+1,jmx+jmx+1)+u1(i+1+imx+1,jmx+jmx+1)))/a1;
      end

      for i=-imx+1:imx-1
          ck=c(i+imx+1,-jmx+jmx+1)*k;
          a1=1./(2.*ck*h)+1./(2.*ck^2);
          a2=1./(2.*ck*h)-1./(2.*ck^2)-1./(2.*h^2);
          a4=1./(ck^2);
          a5=-a1;
          a6=a2;
          a7=a3;
          u3(i+imx+1,-jmx+jmx+1)=(a2*u3(i+imx+1,-jmx+1+jmx+1)+...
                  a3*(u3(i+1+imx+1,-jmx+1+jmx+1)+u3(i-1+imx+1,-jmx+1+jmx+1))+...
                  a4*(u2(i+imx+1,-jmx+jmx+1)+u2(i+imx+1,-jmx+1+jmx+1))+...
                  a5*u1(i+imx+1,-jmx+1+jmx+1)+...
                  a6*u1(i+imx+1,-jmx+jmx+1)+...
                  a7*(u1(i-1+imx+1,-jmx+jmx+1)+u1(i+1+imx+1,-jmx+jmx+1)))/a1;
      end
      ck=c(-imx+imx+1,jmx+jmx+1)*k;
      b1=1./(ck*h)+3./(2.*ck^2);
      b2=1./(2.*ck*h);
      b3=3./(ck^2);
      b4=-b2;
      b5=1./(ck*h)-3./(2.*ck^2);
      u3(-imx+imx+1,jmx+jmx+1)=(b2*(u3(-imx+1+imx+1,jmx+jmx+1)+u3(-imx+imx+1,jmx-1+jmx+1))+...
                b3*u2(-imx+imx+1,jmx+jmx+1)+...
                b4*(u1(-imx+1+imx+1,jmx+jmx+1)+u1(-imx+imx+1,jmx-1+jmx+1))+...
                b5*u1(-imx+imx+1,jmx+jmx+1))/b1;
      ck=c(imx+imx+1,jmx+jmx+1)*k;
      b1=1./(ck*h)+3./(2.*ck^2);
      b2=1./(2.*ck*h);
      b3=3./(ck^2);
      b4=-b2;
      b5=1./(ck*h)-3./(2.*ck^2);
      u3(imx+imx+1,jmx+jmx+1)=(b2*(u3(imx-1+imx+1,jmx+jmx+1)+u3(imx+imx+1,jmx-1+jmx+1))+...
               b3*u2(imx+imx+1,jmx+jmx+1)+...
               b4*(u1(imx-1+imx+1,jmx+jmx+1)+u1(imx+imx+1,jmx-1+jmx+1))+...
               b5*u1(imx+imx+1,jmx+jmx+1))/b1;
      ck=c(-imx+imx+1,-jmx+jmx+1)*k;
      b1=1./(ck*h)+3./(2.*ck^2);
      b2=1./(2.*ck*h);
      b3=3./(ck^2);
      b4=-b2;
      b5=1./(ck*h)-3./(2.*ck^2);
      u3(-imx+imx+1,-jmx+jmx+1)=(b2*(u3(-imx+1+imx+1,-jmx+jmx+1)+u3(-imx+imx+1,-jmx+1+jmx+1))+...
                b3*u2(-imx+imx+1,-jmx+jmx+1)+...
                b4*(u1(-imx+1+imx+1,-jmx+jmx+1)+u1(-imx+imx+1,-jmx+1+jmx+1))+...
                b5*u1(-imx+imx+1,-jmx+jmx+1))/b1;
      ck=c(imx+imx+1,-jmx+jmx+1)*k;
      b1=1./(ck*h)+3./(2.*ck^2);
      b2=1./(2.*ck*h);
      b3=3./(ck^2);
      b4=-b2;
      b5=1./(ck*h)-3./(2.*ck^2);
      u3(imx+imx+1,-jmx+jmx+1)=(b2*(u3(imx-1+imx+1,-jmx+jmx+1)+u3(imx+imx+1,-jmx+1+jmx+1))+...
                b3*u2(imx+imx+1,-jmx+jmx+1)+...
                b4*(u1(imx-1+imx+1,-jmx+jmx+1)+u1(imx+imx+1,-jmx+1+jmx+1))+...
                b5*u1(imx+imx+1,-jmx+jmx+1))/b1;

      y=u3;
