function [s,it,normres]=cg(fun,x,m,tol,P)

n=length(x);
if nargin < 3 m =[]; end
if nargin < 4 tol =[]; end
if nargin < 5 P =[]; end

if isempty(m) m =n; end
if isempty(tol) tol =1e-6; end
if isempty(P) P=speye(n); end

f=funcvalJ(fun,x,m);
k=0;
s=zeros(n,1);
[tmp,r]=revprod(fun,x,f);
r=-r;
normb=norm(r);
rho=normb;

while (rho > tol*normb) 
	z=P\r;
	k=k+1;
	if k==1
		p=z;
	else
		beta=r'*z/(rprev'*zprev);
		p=z+beta.*p;
	end
	[xxx,temp]=forwprod(fun,x,p);
	alpha=r'*z/(temp'*temp);
	s=s+alpha.*p;
	zprev=z;
	rprev=r;
	[yyy,temp2]=revprod(fun,x,temp);
	r=r-alpha.*temp2;
	rho=norm(r);
end
it=k;
normres=rho;

	
