#include <string.h>
#include <malloc.h>
#include <stdio.h>
#include "mex.h"
 
#include <stream.h>
#include <math.h>
 
void val_proc(int, double *,double *, int, int, double *, int, int);

#define FUNCVAL  1
#define FUNCVALJ  2
#define FDAPPROX 3
#define HESSAPPROX 4
#define eps 0.00001 

void
mexFunction(int nlhs,mxArray *plhs[],int nrhs,const mxArray *prhs[])
{
	int k,n,m,p,j,i,funtag,count[11];
        double *ExtraArg=NULL,*epsilon;
	int newm,newn;
	int op;
	op=(int)*mxGetPr(prhs[0]);

	switch(op){
	case FUNCVAL : 
{
#include "myfuncval.c"
}
	break;
	case FUNCVALJ : 
{
#include "myfuncvalJ.c"
}
	break;
	case FDAPPROX : 
{
#include "myFDapprox.c"
}
	break;

	case HESSAPPROX : 
{
#include "myFDHessapp.c"
}

	}
}
