        if (nrhs <= 3)
                mexErrMsgTxt("At Least 3 Input Arguments Required");
        n = mxGetM(prhs[3]);
        p = mxGetN(prhs[3]);
	epsilon=mxGetPr(prhs[4]);
        m=n; 
        if (nlhs > 2)
                mexErrMsgTxt("FDapprox takes <=2 Output Argument");
if (nrhs==6)
{
newm=mxGetM(prhs[5]);
newn= mxGetN(prhs[5]);
ExtraArg=new double[newm*newn];
for(k=0;k<newn;k++)
for (j=0;j<newm;j++)
ExtraArg[k*newm+j]=*(mxGetPr(prhs[5])+j+newm*k);
}

	funtag=(int)*mxGetPr(prhs[1]); 
	plhs[0] = mxCreateDoubleMatrix(m, p, mxREAL);

        double out,oldval;
        double out2;
        double* v=new double [n];
        double* outgrad=new double [n];
        double* out2grad=new double [n];
 
 
        for (j=0;j<n;j++)
                        v[j]=*(mxGetPr(prhs[2])+j);
        val_proc(funtag,v,&out,m,n,ExtraArg,newm,newn);
        for (j=0;j <n;j++)
	{
        oldval=v[j];
        v[j]=v[j]+eps; 
        val_proc(funtag,v,&out2,m,n,ExtraArg,newm,newn);
        v[j]=oldval;
        out2grad[j]=(out2-out)/eps;
	}
	
        for(k=0;k<p;k++){
 
        for (j=0;j<n;j++)
                        v[j]=*(mxGetPr(prhs[3])+j+n*k)*epsilon[k]+*(mxGetPr(prhs[2])+j);
        val_proc(funtag,v,&out,m,n,ExtraArg,newm,newn);

        for (j=0;j <n;j++)
	{
        oldval=v[j];
        v[j]=v[j]+eps; 
        val_proc(funtag,v,&out2,m,n,ExtraArg,newm,newn);
        v[j]=oldval;
        outgrad[j]=(out2-out)/eps;
	}
 
        for (j=0;j<m;j++)
                        *(mxGetPr(plhs[0])+j+m*k)=(outgrad[j]-out2grad[j])/epsilon[k];
        }

	free((char *)outgrad);
	free((char *)out2grad);
	free((char *)v);
