        if (nrhs <= 3)
                mexErrMsgTxt("At Least 3 Input Arguments Required");
        n = mxGetM(prhs[3]);
        p = mxGetN(prhs[3]);
	funtag=(int)*mxGetPr(prhs[1]);
	m=1;
	epsilon=mxGetPr(prhs[4]);
	
if (nrhs==6)
{
newm=mxGetM(prhs[5]);
newn= mxGetN(prhs[5]);
ExtraArg=new double[newm*newn];
for(k=0;k<newn;k++)
for (j=0;j<newm;j++)
ExtraArg[k*newm+j]=*(mxGetPr(prhs[5])+j+newm*k);
}

double* px;
double* py=new double[m];
	px=mxGetPr(prhs[2]);

	trace_proc(funtag,px,py,m,n,ExtraArg,newm,newn);
        double* outgrad=new double [n];
        double* outgrad2=new double [n];
        double* v=new double [n];
	for (j=0;j<n;j++)
                        v[j]=*(mxGetPr(prhs[2])+j);

	plhs[0] = mxCreateDoubleMatrix(n, p, mxREAL);
	gradient(funtag,n,v,outgrad);

	for (k=0;k<p;k++)
	{
	for (j=0;j<n;j++)
		v[j]=*(mxGetPr(prhs[3])+j+n*k)*epsilon[k]+*(mxGetPr(prhs[2])+j);
	gradient(funtag,n,v,outgrad2);
	for (j=0;j<n;j++)
                        *(mxGetPr(plhs[0])+j+n*k)=(outgrad2[j]-outgrad[j])/epsilon[k];
	}
	free((char *)py);
	free((char *)outgrad);
	free((char *)outgrad2);
	free((char *)v);
