function [numg]=numgrH(PartInfo)
%
%numgrH
%
%       Returns the total number of groups used in the partition
%       PartInfo returned by GetHPI
%
%       numg=numgrH(PartInfo) 
%
%       Please refer to ADMIT users manual for complete reference.
%
%       ALSO SEE evalH, GetHPI
%
%
%       ******************************************************************
%       *              ADMIT Project   10-1-96                           *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************

n=size(PartInfo,2);
group=PartInfo(n+1,:);
numg=full(max(group));
