function PartInfo=part(Jd,verb)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FINDS PARTITION AND FORMS THE GRAPH TOO :- DIRECT METHOD
%
% INPUT:
%	Jd= Structure of Jacobian Matrix
% 
% OUTPUT :
%	Ar,Jr :- Information related to Jr
%	Ac,Jc :- Information related to Jc
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
J=spones(Jd);
[m,n]=size(J);
sumc=zeros(1,n);
sumr=zeros(1,m);
sumc=full(sum(J));
sumr=full(sum(J'));
currrowcount=0;
currcolcount=0;
rowsconsideredcomp=linspace(1,m,m)';
colsconsideredcomp=linspace(1,n,n)';
counter=1;
numrowscons=0;
numcolscons=0;
Jr=[];
Jc=[];
Ar=sparse(m,m);
Ac=sparse(n,n);
last=1;
colcons=zeros(0,1);
rowcons=zeros(0,1);

% Initialize %%%%%%%%%%%%
rows=rowsconsideredcomp(1:m);
cols=colsconsideredcomp(1:n);
[colmin,Ic]=min(sumc);
[rowmin,Ir]=min(sumr);
incrrow=max(rowmin-currrowcount,0);
incrcol=max(colmin-currcolcount,0);
row=0;
col=0;
if incrrow <2*incrcol
        row=1;
elseif incrrow > 2*incrcol
        col=1;
elseif last==1
        row=1;
else
        col=1;
end
if (row ==1 & numrowscons < m)
last=1;
else
last=0;
end

counter=1;


while (counter<=m+n)
if (row ==1 & numrowscons < m)
	Ir=find(sumr-currrowcount<=incrrow);
        if (length(Ir) > 1)
	sumc=sumc-sum(J(Ir,:));
	else
	sumc=sumc-J(Ir,:);
	end
        sumr(Ir)=(m+n+1).*ones(1,length(Ir));
	counter=counter+length(Ir);

	currrowcount=currrowcount+incrrow;
        rowsconsideredcomp(Ir)=zeros(1,length(Ir));
	numrowscons=numrowscons + length(Ir);
	rowcons(numrowscons-length(Ir)+1: numrowscons)=Ir;
	Jr=[Jr;
             J(Ir,colcons)];
        Jc=[Jc; sparse(length(Ir),numcolscons)];

	if ((length(cols) >0) &(length(colcons) >0))
	Ac = Ac+[sparse(length(colcons), length(colcons))  J(Ir,colcons)'*J(Ir,cols);
	     sparse(length(cols),n)];
	end
        rows=find(rowsconsideredcomp>0);
else
	Ic=find(sumc-currcolcount<=incrcol);
	if (length(Ic) > 1)
        sumr=sumr-sum(J(:,Ic)');
        else
        sumr=sumr-J(:,Ic)';
        end
	
        counter=counter+length(Ic);
        sumc(Ic)=(m+n+1).*ones(1,length(Ic));
	currcolcount=currcolcount+incrcol;

        colsconsideredcomp(Ic)=zeros(1,length(Ic));

	numcolscons=numcolscons + length(Ic);
	colcons(numcolscons-length(Ic)+1:numcolscons)=Ic;
        Jc=[Jc J(rowcons,Ic)];
        Jr=[Jr sparse(numrowscons,length(Ic))];

	if ((length(rows) >0) &(length(rowcons) >0))
	Ar = Ar+[sparse(length(rowcons), length(rowcons))  J(rowcons,Ic)*J(rows,Ic)';
	     sparse(length(rows),m)];
	end
	cols=find(colsconsideredcomp>0);
end
if (counter <=m+n)
[colmin,Ic]=min(sumc);
[rowmin,Ir]=min(sumr);
incrrow=max(rowmin-currrowcount,0);
incrcol=max(colmin-currcolcount,0);
row=0;
col=0;
if incrrow <2*incrcol
        row=1;
elseif incrrow > 2*incrcol
        col=1;
elseif last==1
        row=1;
else
        col=1;
end
if (row ==1 & numrowscons < m)
last=1;
else
last=0;
end
end
end
if size(Jr,1) < m
Jc=[Jc ; sparse(m-size(Jr,1),n)];
Jr=[Jr; J(rowcons(size(Jr,1)+1:m),colcons)];
end
if size(Jr,2) < n
Jc=[Jc J(rowcons,colcons(size(Jr,2)+1:n))];
Jr=[Jr  sparse(m,n-size(Jr,2))];
end

[y,invpermrow]=sort(rowcons);
[y,invpermcol]=sort(colcons);
Jr=Jr(invpermrow,invpermcol);
Jc=Jc(invpermrow,invpermcol);
Ar=Ar(invpermrow,invpermrow);
Ac=Ac(invpermcol,invpermcol);
% Also try Row and Column colorings 
                Ar=Ar+Ar';
                Ac=Ac+Ac';
                Hr=spones(Ar+Jr*Jr');
                Hc=spones(Ac+Jc'*Jc);
                pr=id(Hr,full(sum(Hr)));
                pc=id(Hc,full(sum(Hc)));
		gr=colorHess(Hr,pr);
		gc=colorHess(Hc,pc);

bgc=max(gc);
bgr=max(gr);
rmax=max(full(sum(J)));
cmax=max(full(sum(J')));
rmax=m;
cmax=n;
if ((2*rmax <= bgc+bgr+1) & (2*rmax < cmax))
		Jr=J;
		Jc=sparse(m,n);
		Hr=spones(J*J');
		pr=id(Hr,full(sum(Hr)));
		gr=colorHess(Hr,pr);
		gc=ones(n,1);	
	end
	if ((cmax <= bgc+bgr+1) & (cmax <= 2*rmax))
		Jc=J;
		Jr=sparse(m,n);
		Hc=spones(J'*J);
		pc=id(Hc,full(sum(Hc)));
		gc=colorHess(Hc,pc);
		gr=ones(m,1);	
	end
maxval=max(gc);
i=1;
while (i<=maxval)
        [j,l] = find(Jc(:,gc==i)');
        if length(j)==0 
		gc(find(gc==i))=zeros(sum(gc==i),1);	
		 if (i~= maxval)
		 gc(find(gc==max(gc)))=i.*ones(sum(gc==max(gc)),1);
		end
		maxval=maxval-1;
	end
i=i+1;
end
i=1;
maxval=max(gr);
while (i<=maxval)
        [j,l] = find(Jr(gr==i,:)');
	if length(j)==0 
		gr(find(gr==i))=zeros(sum(gr==i),1);	
		 if (i~= maxval)
		 gr(find(gr==max(gr)))=i.*ones(sum(gr==max(gr)),1);
		end
		maxval=maxval-1;
	end
i=i+1;
end
PartInfo =[Jc Jr  gr; gc' zeros(1,n+1)];
end

