/*
   ----------------------------------------------------------------------------
   Author  : Uwe Geitner
   Hardware: IBM-compatible PC 386/40
   Software: g++-GNU-Compiler (v2.4) under Linux
   Date    : 14/07/95
   Content : - Definition of the procedure error_report
             - contains the error messages from different operations
   ----------------------------------------------------------------------------
*/

#define _ERROR_CPP

#include <iostream.h>
#include <stdlib.h>

void error_report(unsigned int number)
{
  cout << "\n\n" ;
  switch (number)
  {
    case 1 : cout << "Fatal error in myBitPattern::" ;
             cout << "OR(unsigned int, unsigned int, unsigned int).\n" ;
             break ;
    case 2 : cout << "Fatal error in myBitpattern::" ;
             cout << "OR_EQ(unsigned int, unsigned int).\n" ;
             break ;
    case 3 : cout << "Fatal error in myBitpattern::" ;
             cout << "OR_EQ(unsigned int, myBitPattern*, unsigned int).\n" ;
             break ;
    case 4 : cout << "Fatal error in myBitpattern::" ;
             cout << "AND(unsigned int, myBitPattern*, unsigned int).\n" ;
             break ;
    case 5 : cout << "Fatal error in mybitpattern::" ;
             cout << "AND(unsigned int, unsigned int).\n" ;
             break ;
    case 6 : cout << "Fatal error in myBitPattern::" ;
             cout << "AND_EQ(unsigned int, unsigned int).\n" ;
             break ;
    case 7 : cout << "Fatal error in myBitPattern::" ;
             cout << "EQUAL(unsigned int, myBitPattern*, unsigned int).\n" ;
             break ;
    case 8 : cout << "Fatal error in myBitPattern::" ;
             cout << "EQUAL(unsigned int, unsigned int).\n" ;
             break ;
    case 9 : cout << "Fatal error in myBitPattern::" ;
             cout << "setBit(unsigned int, unsigned int).\n" ;
             break ;
    case 10: cout << "Fatal error in myBitPattern::" ;
             cout << "readBit(unsigned int, unsigned int).\n" ;
             break ;
    case 11: cout << "Fatal error in Liste::getElement(int).\n" ;
             break ;
  }
  exit(0) ;
} 

#undef _ERROR_CPP


