function [v,dv]= DefineV(g,x,l,u);
%
% determine v(x) and dv
%
n = length(x); v = zeros(n,1); dv=zeros(n,1);

arg1 = (g < 0) & (u < inf ); arg2 = (g >= 0) & (l >-inf);
arg3 = (g < 0) & (u == inf); arg4 = (g >=0) & (l == -inf);

v(arg1) = x(arg1) - u(arg1); dv(arg1) = -ones(length(arg1(arg1>0)),1);
v(arg2) = x(arg2) - l(arg2); dv(arg2) = ones(length(arg2(arg2>0)),1);
v(arg3)=-ones(length(arg3(arg3>0)),1);
dv(arg3)=zeros(length(arg3(arg3>0)),1);
v(arg4)=ones(length(arg4(arg4>0)),1);
dv(arg4)=zeros(length(arg4(arg4>0)),1);

return
