function [x]=Perturb(x,l,u);
%
%   reset or perturb the starting point to satisfy feasibility
%
%if ( infsb >0 )
%    disp('xstart is infeasible, reset the starting point');
%    i = find( x<l );
%    x(i)=l(i)+0.1*(u(i)-l(i));
%    i = find( x>u );
%    x(i)=u(i)-0.1*(u(i)-l(i));
%end
h=min(x-l,u-x);      i = find( h == inf ); h(i) = ones(length(i),1);
if ( min(h) < 100*eps )
     disp('xstart is at the boundary, perturb the starting point');
     i =find( (x-l) < 100*eps );
     x(i)=l(i)+ 0.1*(u(i)-l(i));
     i =find( (u-x) < 100*eps );
     x(i)=u(i)- 0.1*(u(i)-l(i));
     h=min(x-l,u-x); i = find( h == inf ); h(i) = ones(length(i),1);
end;
infsb = sum( x<l | x >u );
if (infsb >0 ) infsb = infsb, keyboard;end;
return

