function [x,perturbed]=Perturb_eps(x,l,u);
%
%   reset or perturb the starting point to satisfy feasibility
%
del = 10*eps;
infeasibility = min(min(x-l,u-x));
perturbed=0;
if  infeasibility < del
    arg7 = find((u-x) < del); arg8 = find((x-l) < del);
    if ~isempty(arg7)
        x(arg7) = u(arg7) - del*ones(length(arg7),1);
    end;
    if ~isempty(arg8)
        x(arg8) = l(arg8) + del*ones(length(arg8),1);
    end;
    perturbed=1;
end;

