function [Z] = Subspace(M,sqrtv,p,sgr,tsize,posdef,v1);
%
%  find sx for the scaled trust region problem satisfying convergence criteria
%
n = length(sqrtv);

Z = zeros(n,2);
if posdef ==1 
%
%  form a two dimensional subspace if possible
%
   Z=orth2[v1,sgr];
else
%
%  indefinite: form a two dimensional subspace if possible
%
%   [V,D]=eig(full(M));
%   [mineig,ii]=min(diag(D));
%   v1= V(:,ii);
%   mineig= v1'*M*v1

    cc = v1./sqrtv;

    else
       w=zeros(n,1); weig=0;
    end

    normv1 = norm(v1); 
    v1=v1/normv1;
    veig =full(v1'*M*v1);
    if veig < weig  
       w=v1;
    end;
    Z=orth2(v1,sgr);
end
