function Jspline = computeJspline(y,Extra,valconds)
%%%%%
% DERIVATIVE of spline
%%%%%
global OBSERVED
numtimesteps=Extra.numtimesteps;
S0=Extra.S0;
N=Extra.N;
knotS=Extra.knotS;
knotT=Extra.knotT;
consts=Extra.consts;
I =[]; J = [];
if ~isempty(Extra.Index)
   I=Extra.Index(:,1);
   J=Extra.Index(:,2);
end;
numconsts=length(consts);
numknotS=length(knotS);
numknotT=length(knotT);

gridS = linspace(0,2*S0,N)';
gridT = linspace(0,max(Extra.T),numtimesteps)';


pp=csape({knotS,knotT},reshape(y,numknotS,numknotT),valconds);
initGridSigma =ppual(pp,{gridS, gridT});
n=numknotS*numknotT-numconsts;

Jspline=zeros(N,numtimesteps,n);
fdeps=1e-5;
   count=1;
   count2=1;
   count3=1;

for j=1:length(knotT)
for i=1:length(knotS)

if (count3 <= length(consts)) & I(count3)==i & J(count3)==j
count3=count3+1;
else
y2=reshape(y+fdeps*[zeros(count-1,1);1;zeros(numknotS*numknotT-count,1)],length(knotS),length(knotT));
pp2=csape({knotS,knotT},y2,valconds);
XX2 =ppual(pp2,{gridS, gridT});
Jspline(:,:,count2)=(XX2-initGridSigma)./fdeps;
count2=count2+1;
end
count=count+1;
end
end
