function [f,mygrad,H]=optionH(sigma,Extra)
% optionH
%       Returns the option value, gradient and Hessian matrix.
%
%       sigma is a vector of size >= 5.
%

[f,mygrad]=revprod('optionfunw',sigma,1,Extra);
n=length(sigma);
V=eye(n);
H=zeros(n,n);

for i=1:n
HV=HtimesV('optionfunw',sigma,V(:,i),Extra);
H(:,i)=HV;
end
