function [f,mygrad,HV]=optionHV(sigma,V,Extra)
%optionHV 
%	Returns the option value, gradient and Hessian vector product
% 
%       sigma is a vector of size >= 5.
%
%

[f,mygrad]=revprod('optionfunw',sigma,1,Extra);
HV=HtimesV('optionfunw',sigma,V,Extra);
