function [f,J]=optionJ(y,Extra,eps)
% optionJspline
%       Returns the option value, Jacobian
%       y is the spline vector of size >= 5.
%
n=length(y);
if nargout < 3 eps=1e-5; end

f=optionfunspline(y,Extra);

if nargout ==2
m=length(f);
J=zeros(m,length(y));
V=eye(n);
for i=1:length(y)
z=(optionfunspline(y+eps*V(:,i),Extra)-f)/eps;
J(:,i)=z(:);
end
end
