function val = optionfun(y,Extra)
% OPTIONFUN 
%       Returns the option values-observed values
%
%
%	y is the spline vector of size >= 5.
%	
%
S0=Extra.S0;
r=Extra.r;
q=Extra.q;
M=Extra.numtimesteps;
T=Extra.T;
K=Extra.K;
x=Extra.knotS;
N=Extra.N;

sigma=sigmay(y,x,S0,N);

val=optionblsprice(S0,K,r,T,sigma,q,M);
