function val = optionfun(y,Extra)
% OPTIONFUN 
%       Returns the option values-observed values
%
%	y is the spline 2d knot values
%	

S0=Extra.S0;
r=Extra.r;
q=Extra.q;
T=Extra.T;
K=Extra.K;
NUMT=Extra.numtimesteps;
N=Extra.N;
knotS=Extra.knotS;
knotT=Extra.knotT;
sigma=sigmay2d(knotS,knotT,y,S0,T,NUMT,N);
val=optionblsprice2d(S0,K,r,T,sigma,q,NUMT,N);
