echo on

%
% Example of european call option where sigma =sigma(S)
%


%Initialise
S0=100;
r=0.1;
q=0;
numtimesteps=10;
T=[1;0.32];
K=[100;80];
N=20;

numknotS=6;
numknotT=4;
knotS=[0    50     90     110   150   200]';
knotT=[0  .4 .6  1]';
y=rand(numknotS,numknotT);
y=reshape(y,numknotS*numknotT,1);

Extra.S0=S0;
Extra.r=r;
Extra.q=q;
Extra.T=T;
Extra.K=K;
Extra.numtimesteps=numtimesteps;
Extra.N=N;
Extra.knotT=knotT;
Extra.knotS=knotS;
f=optionfunspline2d(y,Extra)
f

%AD
[f,J]=optionJspline2d(y,Extra);
J

%FD
[f,J]=optionJspline2dfd(y,Extra);
J
