echo on

%
% Example of european call option where sigma =sigma(S)
%


%Initialise
S0=100;
r=0.1;
q=0.2;
numtimesteps=5;

% These vectors should be sorted w.r.t. increasing maturity time

T=[0.32;1];
K=[80;100];
N=10;
numspline=5;
y=[.2;.24;.25;.285;.3];
x=[50;75;100;125;150];


Extra.S0=S0;
Extra.r=r;
Extra.q=q;
Extra.numtimesteps=numtimesteps;
Extra.T=T;
Extra.K=K;
Extra.N=N;
Extra.knotS=x;

[f,J]=optionJsplineam(y,Extra);
J

