#include "mex.h"
void
mexFunction(int nlhs,mxArray *plhs[],int nrhs,const mxArray *prhs[])
{
	int i,j,n,p;
	double *d, *c, *e, *b;

      n=mxGetM(prhs[3]);
      p=mxGetN(prhs[3]);
      c=new double[n];
      d=new double[n];
      e=mxGetPr(prhs[2]);
      b=new double[n*p];
			for (i=0;i<n;i++)
                        {
				c[i]=*(mxGetPr(prhs[0])+i);
				d[i]=*(mxGetPr(prhs[1])+i);
	}
                for(j=0;j<p;j++)
			for (i=0;i<n;i++)
                        b[i+n*j]=*(mxGetPr(prhs[3])+i+n*j);
      for (i = 0; i < n-1; i++)
      {
      c[i]=c[i]/d[i];
      d[i+1]=d[i+1]-c[i]*e[i+1];
	}

      for (j = 0; j < p; j++)
      {
      for (i = 1; i < n; i++)
      b[i+n*j]=b[i+n*j]-c[i-1]*b[i-1+n*j];

      b[n-1+n*j]=b[n-1+n*j]/d[n-1];

      for (i = n-2; i >= 0; i--)
      b[i+n*j]=(b[i+n*j]-e[i+1]*b[i+1+n*j])/d[i];

      }


plhs[0] = mxCreateDoubleMatrix(n, p, mxREAL);
     
                for(j=0;j<p;j++)
			for (i=0;i<n;i++)
                        *(mxGetPr(plhs[0])+i+n*j)=b[i+n*j];
	delete[] c;
	delete[] d;
	delete[] b;
}
