function south=updatesph(s1,s2)
global globp;

if ~isa(s1,'derivsph')
    s1h=s2.derivsph;
    s1j=getspj(s2);
    q1=length(getval(s2));
    q2=length(getval(s1));
    
    % JUST ONE SPH
    
    if q1==1 & q2~=1
        for i=1:globp
            for j=1:globp
                south{i,j}=spones(getval(s1))\s1h;
            end
        end
    else
        south=s1h;
    end
    
    
elseif ~isa(s2,'derivsph')
    s1h=s1.derivsph;
    s1j=getspj(s1);
    q1=length(getval(s1));
    q2=length(getval(s2));
    
    % JUST ONE SPH
    
    if q1==1 & q2~=1
        for i=1:globp
            for j=1:globp
                south{i,j}=s1h(i,j)*spones(getval(s2));
            end
        end
        
    else
        south=s1h;
    end
    
else
    
    
    s1h=s1.derivsph;
    s1j=getspj(s1);
    s2h=s2.derivsph;
    s2j=getspj(s2);
    q1=length(getval(s1));
    q2=length(getval(s2));
    
    
    if ((q1==1)&(q2~=1))
        [m,n]=size(getval(s2));
        if (m==1) | (n==1)
            for i=1:globp
                for j=1:globp
                    south{i,j}=s1h(i,j)+...
                        s1j(j)'*s2j(:,i)+s2j(:,i)'*s1j(j);
                end
            end
            south=south+s2h;
            
        else
            for i=1:globp
                for j=1:globp
                    south{i,j}=s1h(i,j)+...
                        s1j(j)*s2j{i}+s2j{j}*s1j(i);
                end
            end
            south=south+s2h;
        end
        
        
    elseif ((q2==1)&(q1~=1))
        [m,n]=size(getval(s1));
        
        if (m==1) | (n==1)
            for i=1:globp
                for j=1:globp
                    south{i,j}=s2h(i,j)+...
                        s2j'*s1j(:,i)+s1j(:,i)'*s2j;
                end
            end
            south=south+s1h;
            
        else
            
            for i=1:globp
                for j=1:globp
                    south{i,j}=s2h(i,j)+...
                        s2j(j)*s1j{i}+s1j{j}*s2j(i);
                end
            end
            south=south+s1h;
        end
        
        
    else
        [m,n]=size(getval(s1));
        
        if (m==1)
            if n==1
                south=s1j'*s2j+s2j'*s1j+s1h+s2h;
            else
                south=s1j'*s2j+s2j'*s1j+sum(s1h)+sum(s2h);
            end
            
        elseif n==1
            for i=1:globp
                for j=1:globp
                    south{i,j}= s1j(:,j)*s2j(:,i)'+s2j(:,j)*s1j(:,i)'+s1h{i,j}*ones(1,q2)+ones(q1,1)*s2h{i,j}';
                end
            end
        else
            [m2,n2]=size(getval(s2));
            if n2~=1
                for i=1:globp
                    for j=1:globp
                        south{i,j}= s1j{i}*s2j{j}+s2j{i}*s1j{j};
                    end
                end
                south=south+s1h+s2h;
            else
                
                for i=1:globp
                    for j=1:globp
                        south{i,j}=s1h{i,j}*ones(m2,1)+s1j{i}*s2j(:,j)+s1j{j}*s2j(:,i);
                    end
                end
                south=south+s2h;
                
            end
            
        end
        
    end
end

