function sout=sparse(i,j,s,m,n)
global varcounter;
i=derivtape(i);
j=derivtape(j);
if nargin == 2
sout.val=sparse(i.val,j.val);
sout.varcount=varcounter;
sout=class(sout,'derivtape');
savetape('sparse',sout,i.val,j.val);
elseif nargin == 3
s=derivtape(s);
sout.val=sparse(i.val,j.val,s.val);
sout.varcount=varcounter;
sout=class(sout,'derivtape');
savetape('sparse',sout,i.val,j.val,s.varcount);
elseif nargin == 4
s=derivtape(s);
m=derivtape(m);
sout.val=sparse(i.val,j.val,s.val,m.val);
sout.varcount=varcounter;
sout=class(sout,'derivtape');
savetape('sparse',sout,i.val,j.val,s.varcount,m.val);
else
s=derivtape(s);
m=derivtape(m);
n=derivtape(n);
sout.val=sparse(i.val,j.val,s.val,m.val,n.val);
sout.varcount=varcounter;
sout=class(sout,'derivtape');
savetape('sparse',sout,i.val,j.val,s.varcount,m.val,n.val);
end
