function s= derivtape(a,V)
%
% Derivative class for AD of M-files
%
global globp;
global tapecounter
if nargin==0
    s.val=derivtape(0);
    s.deriv=derivtape(0);
    s=class(s,'derivtapeH');
elseif isa(a,'derivtapeH')
    s.val=a.val;
    s.deriv=a.deriv;
    s=class(s,'derivtapeH');
    if nargin==2 s.deriv=derivtape(V); end
else
   if ~isa(a,'derivtape') a=derivtape(a); end
   s.val=a;
   [m,n]=size(getval(a));
   if nargin==2 
   s.deriv=derivtape(V); 
   if m==1|n==1 globp=size(V,2); else globp=size(V,3); end
   else
   if ((m==1) &(n==1))
        s.deriv=derivtape(zeros(1,globp));
   elseif (m==1)
        s.deriv=derivtape(zeros(n,globp));
   elseif (n==1)
        s.deriv=derivtape(zeros(m,globp));
   else
        s.deriv=derivtape(zeros(m,n,globp));
   end
   end
   s=class(s,'derivtapeH');
end
