function c=bmod_fun(src_CH3CCl3,Extra)

ny=Extra.ny; 
ntpy=Extra.ntpy;
m=Extra.m;
n=Extra.n;
src_CH3CCl3=reshape(src_CH3CCl3,m,n);

src = zeros(2,ny)+0*src_CH3CCl3(1,1);
%
%     Initialisierung der Quellen  
%     Lesen von drei Zeilen und der Arrays fuer 1977 und 1978,
%     d.h. man startet mit den 1979'er Quellen
%



for i=1:ny
  src(1,i) = src_CH3CCl3(i+2,2)*src_CH3CCl3(i+2,4);
  src(2,i) = src_CH3CCl3(i+2,3)*src_CH3CCl3(i+2,4);
end 

mixrate = 1.;             
invlif = 1./4.7;         

%     Konversion fuer kt zu pptv innerhalb einer Hemisphaere

kt2pptv = 0.471 * 2 * 12/133.5; 

%     Initialisiere Konzentrationen  

c=zeros(2,1)+0*src_CH3CCl3(1,1);

c(1) = 84.0;           
c(2) = 60.0;           

str = 'Die simulierte Konzentration ist: ';
j1 = [ 0 c(1) c(2)];

for i=1:ny
  for l=1:ntpy
    cnew = c(1)+1./ntpy.*(kt2pptv.*src(1,i)-(c(1)-c(2)).*mixrate - invlif.*c(1));
    c(2) = c(2)+1./ntpy.*(kt2pptv.*src(2,i) - (c(2)-c(1)).*mixrate - invlif.*c(2));
    c(1) = cnew;
  end
  j = [i c(1) c(2)];
end

