% 
%     Beispiel: Explosionsgleichung
%

dim = 7; 
parmax = 2;  

F = zeros(dim,1);
%
%        Schrittweite 
%
      
h = 2.0/(dim+1.0);
      
%
%        Initialisierung der Startwerte: 
%      

x = [    
     1.72  
     3.45  
     4.16  
     4.87  
     4.16  
     3.45 
     1.72 
  ];
%
%        Parameterwerte: 
%
prm = [ 
   1.3  
   0.245828
 ];
%
%        Funktionsauswertung Beginn:
%

Extra=[];
Extra.x=x;
Extra.h=h;
Extra.dim=dim;

%
% Function eval
%
F=expl_fun(prm,Extra);
F



% J'*W from ADMIT
% compute the whole Jacobian
% try different W's

W=eye(7,2);
[F,WJ]=revprod('expl_fun',prm,W,Extra);

% see the space required to store the tape
spacerequired


% J from ADMIT

[F,J]=evalJ('expl_fun',prm,Extra);
J
% J*V from ADMIT

V=ones(2,2);
[F,JV]=forwprod('expl_fun',prm,V,[],Extra);
JV
