% driver for Mike Giles test problem
% I want to calculate a'*J*dq where J is the Jacobian of the
% function described in flux.m
ewt=[ 1 2 3];
q= [0.9 0.1 0.2 0.3 1.7]';
a= [ 0.4 0.8 0.3 0.1 0.9]';
dq= [0.7 0.1 0.5 0.2 0.3]';

% flux calculation

% straight mode !
disp('Flux calc')
f=flux(q,ewt)

[f,Jdq]=forwprod('flux',q,dq,5,ewt);

disp('Result from forward mode')
atJdq=a'*Jdq
% reverse mode
% ============
disp(' Reverse Mode')

[f,Jta]=revprod('flux',q,a,ewt);

% atJdq
disp('Results from reverse mode')
atJdqnew=Jta'*dq
