function [gfad]=fadgrad(x)
% calculates gradients via forward AD
% initialise derivatives
xdot=eye(size(x,1));
% set up AD variable
xad=deriv(x,xdot);
% calculate function
f=rosenfunc(xad);
% extract derivatives
gfad=getydot(f);


