      subroutine getfun(x,n,y,m,ExtraArg,newm,newn)
      integer n,m,newm,newn
      real*8 x(n),y(m),ExtraArg(newm,newn)
C      subroutine func(n,x,fvec,nc,mc,ac)
C      integer n
      real*8 nc,mc,ac

      real*8   zr(2),zz(2),z(2),dc(2),anc(2),mc0(2),tvc(2),r0(2),vtc(2)
      real*8 trm1(2),trm2(2),veleq(2),hvareq(2),vert_var(2),vareq(2)
      real*8 u(2),e(2),a(2),nu(2),al(2), phi(2), pi
      pi=355/113

      nc = 1.0
      mc = 0.8
      ac =1
      u(1)=x(1)
      u(2)=x(2) 
      e(1)=x(3)
      e(2)=x(4)
c      zr(1)=x(3); zz(1)=x(4) ;
c      zr(2)=x(5); zz(2)=x(6);

      eps1=100.0d0 
c      z = 2.0/3.0*(zr+zz/2.0) ; e=3.0/4.0*z;
      z(1)=4.0/3.0*e(1)
      z(2)=4.0/3.0*e(2)
      dc(1)=1.0d0
      dc(2)=ac**2 

      anc(1)=1.0
      anc(2)=nc 
      tvc(1)=1.0
      tvc(2)=ac/mc
      vtc(1)=1.0
      vtc(2)=mc/ac

      mc0(1) = 1.0/(1+mc)
      mc0(2) = 1-mc0(1)
      drt = (1+ac)**2/4.0
      r0(1) = 1.0/(1.0+nc*mc)
      r0(2) = 1.0 - r0(1)
      
      do i=1, 2
         k=3-i 
         a(k) = 8.0/3.0*eps1*anc(k)*drt*mc0(k)*sqrt((z(1)+z(2))/pi) 
         
         tmp1 = u(i)*(u(i)-u(k)) + 1.5*( mc0(i)*z(i)-mc0(k)*z(k) ) 
         tmp1 = tmp1 - mc0(k)*( u(1)-u(2) )**2 
         trm1(i) = 2.0*a(k)*tmp1 
                                                                         
         tmp1 = (2.0*mc0(i)+1.2*mc0(k))*zr(i)
     $        -0.8*mc0(k)*(zr(k)+(u(1)-u(2))**2) 
         tmp1 = (tmp1 - 1.2*mc0(k)*(z(i)+z(k)))*a(k) 
         trm2(i) = tmp1 + 
     $      8.0/5.0*eps1*anc(i)*dc(i)*sqrt(2.0*z(i)/pi)*(zr(i)-z(i)) 

      enddo

c$$$c     g:radial distribution function
c$$$            p = phi(1)+phi(2) ;
c$$$            g = (2-p)/2/(1-p)**3 ;
      g=1.0d0

      do  i=1, 2
         k=3-i 
         
c$$$         veleq(i) = tvc(i)*(vtc(i)-u(i)) - g*a(k)*(u(i)-u(k)) 
c$$$         
c$$$         vareq(i) = 2.0*tvc(i)*(vtc(i)*u(i)-1.5*z(i)-u(i)**2) 
c$$$     $        - g*trm1(i) 
c$$$         
c$$$         hvareq(i) = -2*tvc(i)*zr(i) - g*trm2(i) 
c$$$         
c$$$     vert_var(i) = 2.0*(vareq(i) -2.0*u(i)*veleq(i) - hvareq(i)) 


         veleq(i) = tvc(i)*(vtc(i)-u(i)) / ( g*a(k)*(u(i)-u(k)) ) 

         vareq(i) = -2.0d0*e(i)*tvc(i) / (g*a(k)*
     $        (2.0*(mc0(i)*e(i)-mc0(k)*e(k))-mc0(k)*(u(i)-u(k))**2) )

c$$$         vareq(i) = 2.0*tvc(i)*(vtc(i)*u(i)-1.5*z(i)-u(i)**2) / 
c$$$     $        ( g*trm1(i) )  
c$$$         
c$$$         hvareq(i) = -2*tvc(i)*zr(i) / ( g*trm2(i) ) 
c$$$         
c$$$     vert_var(i) = 2.0*(vareq(i) -2.0*u(i)*veleq(i) - hvareq(i)) 


      enddo


      y(1) = veleq(1)-1.0d0  
      y(2) = veleq(2)-1.0d0 
               
      y(3) = vareq(1)-1.0d0  
      y(4) = vareq(2)-1.0d0  
                
c$$$      fvec(5) = hvareq(2)-1.0d0  
c$$$      fvec(6) = vareq(2)-1.0d0  
      

      return 
      end
