function [g]=rosengrad(x)
% gradient of generalised rosenbrock's function for column vector x
n=size(x,1);
j=1;
g(j)=-400.*(x(j+1)-x(j).^2).*x(j)+2.*(x(j)-1);
for j=2:n-1
  g(j)=-400.*(x(j+1)-x(j).^2).*x(j)+2.*(x(j)-1)+200*(x(j)-x(j-1).^2);
end
j=n;
g(j)=200.*(x(j)-x(j-1)^2);


