function [h]=rosenhess(x)
% hessian of generalised rosenbrock's function for column vector x
n=size(x,1);
h=zeros([n n]);
j=1;
h(1,1)=-400.*(x(j+1)-3*x(j).^2)+2;
h(1,2)=-400.*x(j);
for j=2:n-1
  h(j,j)=-400.*(x(j+1)-3*x(j).^2)+2+200;
  h(j,j-1)=-400*x(j-1);
  h(j,j+1)=-400.*x(j);
end
j=n;
h(j,j)=200;
h(j,j-1)=-400.*x(j-1);


