function result = intefprime2(x,Extra);

valconds = 'variational';

knotS = Extra.knotS;
knotT = Extra.knotT;
numknotS=length(knotS);
numknotT=length(knotT);
numtimesteps=Extra.numtimesteps;
T = Extra.T;

pp=csape({knotS,knotT},reshape(x,numknotS,numknotT), valconds);

fprimeS = fnder(pp,[1,0]);
fprimeT = fnder(pp,[0,1]);

gridS=Extra.S0;
gridT = linspace(0,max(T),numtimesteps)';

mtxS = ppual(fprimeS,{gridS, gridT});
mtxT = ppual(fprimeT,{gridS, gridT});

result = sum(sum(mtxS.^2))+sum(sum(mtxT.^2));
