function []=example(fun1,fun2)
n=10;
V=ones(n,4);
x=ones(n,1);
disp('Forward Mode Product :- JV=forwprod(x,V,n);');
V
[f,JV]=forwprod(fun1,x,V,n,[]);
JV
disp(' ');
disp('Done..Press any key to continue ...');
pause
W=ones(10,4);
disp('Reverse Mode Product :- WJ=revprod(x,W);');
W
[f,WJ]=revprod(fun1,x,W,[]);
WJ
disp(' ');
disp('Done..Press any key to continue ...');
pause
disp('Computing Function :-  val=funcvalJ(x,n);');
val=funcvalJ(fun1,x,n,[]);
val
disp(' ');
disp('Done..Press any key to continue ...');
pause

disp('Computing Jacobian Sparsity :- SPJ=JacSP(n,n);');
SPJ=jacsp(fun1,n,n,[]);
spy(SPJ);
title 'sparsity Pattern of J'
disp(' ');
disp('Done..Press any key to continue ...');
pause

disp('Computing Hessian Sparsity :- SPH=HessSP(n);');
SPH=hesssp(fun2,n,[]);
spy(SPH);
title 'sparsity Pattern of Hessian'
disp(' ');
disp('Done..Press any key to continue ...');
pause

disp('Computing Scalar Function/Gradient Value :- [val,grad]=funcval(x);');
[val,grad]=funcval(fun2,x,[]);
val
grad
disp(' ');
disp('Done..Press any key to continue ...');
pause

disp('Computing Hessian Matrix Product :- HV=HtimesV(x,V)');
V
HV=HtimesV(fun2,x,V);
HV
