function y=sparse(i,j,s,m,n)
i=getval(i);
if nargin == 1
y=sparse(i);
y=deriv(y);
elseif nargin == 2
j=getval(j);
y=sparse(i,j);
y=deriv(y);
elseif nargin == 3
j=getval(j);
s=getval(s);
y=sparse(i,j,s);
y=deriv(y);
elseif nargin == 4
j=getval(j);
m=getval(m);
y=sparse(i,j,s,m);
y=deriv(y);
else
j=getval(j);
m=getval(m);
n=getval(n);
y.val=sparse(i,j,s.val,m,n);
y.deriv=sparse(i,j,s.deriv,m,n);
y=class(y,'deriv');
end
