function normout=norm(x,p)
global globp
if nargin < 2 p=2; end

[m,n]=size(x.val);

if m==1 | n==1


if p=='inf'

normout=max(abs(x));
elseif p=='-inf'

normout=min(abs(x));

else
normout.val=norm(x.val,p);
if normout.val~=0
if m==1
normout.derivS=((abs(x.val).^(p-1))./(normout.val^(p-1)))*x.derivS;
else
normout.derivS=((abs(x.val).^(p-1))./(normout.val^(p-1)))'*x.derivS;
end
else
normout.derivS=sum(x.derivS);
end

normout=class(normout,'derivS');
end

else
% matrices 

if p=='inf'
normout=max(sum(abs((x'))));
elseif p=='fro'
normout=sqrt(sum(diag(x'*x)));
elseif p==1
normout=max(sum(abs((x))));
else
normout=max(svd(x));
end

end

