function fdata = DOFdata(fun,n,k,dims,py0)
%
% Check for inconsistencies in Input data
%
	if n <= 0 error('Need Problem size >= 0'); end
if nargin < 3 k=[]; end
if nargin < 4 dims=[]; end
if nargin < 5 py0=[]; end
 

        if (isempty(k) & isempty(dims)) k=1; end
	if isempty(dims)
		if isempty(py0) py0=zeros(n/k,1);end
		dims=[n/k;length(py0)]; 
	end
	if isempty(k) k=n/dims(1); end
	if isempty(py0) py0=zeros(n/k,1);end
        if k*dims(1)~=n error('mismatch in setting of k, dims parameters'); end
	fdata.k=k;
        fdata.dims=dims;
	fdata.py0=py0;
