function [f,HV]=ExtHVDI2(fun,x,V,fdata)

n=length(x);
p=size(V,2);
        ExtraArg=fdata.py0;
        impl=fdata.impl;
        k=fdata.k;
        kind=fdata.kind;
        numstates=fdata.numstates;
        dims=fdata.dims;
        sizep=dims(1);
        m=dims(2);
        consts=fdata.consts;
        outind = fdata.outind;
        yfinal=fdata.yfinal;

 
 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Recovery complete
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
total=ceil(abs((k(2)-k(1))/k(3)));
if ((k(2) < k(1)) & (k(3) > 0))
        k(3)=-k(3);
end
 
data=[0;numstates;sizep;k(3);k(1);1;consts];
 

JV=zeros(n,p);
oldJV=zeros(numstates*sizep,p);
saveV=V;
V=-V;
oldf=[zeros((numstates-i)*sizep,1);ExtraArg];
LinvAV=[];
y=zeros(n,total+1);
accumy=ExtraArg;
accumJV=JV;
y(:,1)=ExtraArg;
 
% Forward Pass
for i=1:total-1
	[y(:,i+1),JV]=forwprod(fun(1,:),[x;oldf],[V;oldJV],n,data);
	data(5)=data(5)+k(3);
        data(6)=data(6)+1;
        oldf=[oldf(n+1:numstates*n);y(:,i+1)];
        oldJV=[oldJV(n+1:numstates*n,:);JV];
        LinvAV=[LinvAV;JV];
        accumy=[accumy;y(:,i+1)];
        accumJV=[accumJV;JV];
end
if total > 0
        data(4)=k(2)-(total-1)*k(3);
        [y(:,total+1),JV]=forwprod(fun(1,:),[x;oldf],[V ; oldJV],n,data);
        LinvAV=[LinvAV;JV];
        accumy=[accumy;y(:,total+1)];
        accumJV=[accumJV;JV];
        f=y(:,total+1);
else
        f=ExtraArg;
end
outm=n;
outn=n;
datag=sizep;
 
        if length(outind)==1
                if outind==0
                        if size(fun,1) > 1
        outm=m;
        [f,JV]=forwprod(fun(1,:),[x;f],[V ; JV],m,data);
        LinvAV=[LinvAV;JV];
                                [f,grad_y]=revprod(fun(2,:),[x;f],f,datag);
                                grad_y=[grad_y(1:n);zeros(total*sizep,1);grad_y(n+1:n+sizep)];
                        else
                                grad_y=[grad_y(1:n);zeros(total*sizep,1);f];
                        end
                else
                if size(fun,1) > 1
                outm=m;
                outn=(total+1)*sizep;
        [f,JV]=forwprod(fun(1,:),[x;accumy],[V;accumJV],m,data);
        LinvAV=[LinvAV;JV];
                         f=funcvalJ(fun(2,:),[x;accumy],datag,m);
                        [f,grad_y]=revprod(fun(2,:),[x;accumy],f,datag);
                else
                outm=(total+1)*sizep;
                outn=(total+1)*sizep;
                f=accumy;
                grad_y=[zeros(n,1);f];
                end
                end
        else
        % outputindex is active
        outindy=[];
        for count=1:size(outind,1)
                outindy=[outindy;y(outind(count,2)),outind(count,1)];
                ind=[ind;outind(count,1)*n+outind(count,2)];
        end
        if size(fun,1) > 1
        outm=m;
        outn=length(outindy);
        [f,JV]=forwprod(fun(2,:),[x;outindy],[V ; accumJV(ind)],m,data);
                [f,g_y]=revprod(fun(2,:),[x;outindy],f,datag);
                grad_y=zeros((total+1)*sizep,1);
                grad_y(ind)=g_y(n+1:sizep+n);
		grad_y=[g_y(1:n);grad_y];
        else
                outm=length(outindy);
                outn=length(outindy);
                f=outindy;
                grad_y=zeros((total+1)*sizep,1);
                grad_y(ind)=f;
		grad_y=[zeros(n,1);grad_y];
        end
        end
% Compute w

p=1;
W=-grad_y(total*sizep+1:(total+1)*sizep);
WJaccbig=-grad_y(1:total*sizep);
if size(fun,1) > 1
myw=[W;-f];
else
myw=W;
end
f=f-yfinal;
f=0.5*(f'*f);

 
if total > 0
W=W(n+1:n+sizep,:);
[val,W]=revprod(fun(1,:),[x;oldf],W,data);
outWJacc=outWJacc+W(1:n,:);
W=W(n+1:n+sizep,:)+WJaccbig((total-1)*n+1:total*n,:);
data(4)=k(3);
if numstates > 1
                WJacc=zeros((numstates-1)*sizep,total*p);
                WJacc(:,(total-1)*p+1:total*p)=W(n+1:(numstates-1)*sizep+n,:);
end
 
end
 
for i=total-1:-1:1
        data(5)=data(5)-k(3);
        data(6)=data(6)-1;
        oldf=[y(:,i-numstates+1);oldf(1:(numstates-1)*sizep)];
        [val,W]=revprod(fun(1,:),[x; oldf],W,data);
        if i < numstates
                if ((i > 1) & (numstates > 1))
                        WJacc(1:(i-1)*sizep,(i-1)*p+1:i*p)=W(n+1+(numstates-i)*sizep:(numstates-1)*sizep+n,:);
                end
                W=W(n+(i-1)*sizep+1:n+i*sizep,:)+WJaccbig((i-1)*sizep+1:i*sizep,:);
                for j=i+1:min(i+numstates-1,total)
                        W=W+WJacc((2*i-j)*sizep+1:(2*i-j+1)*sizep,(j-1)*p+1:j*p);
                end
        else
                if (numstates > 1)
                WJacc(:,(i-1)*p+1:i*p)=W(n+1:(numstates-1)*sizep+n,:);
                end
                W=W(n+(numstates-1)*sizep+1:n+numstates*sizep,:)+WJaccbig((i-1)*sizep+1:i*sizep,:);
                for j=i+1:min(i+numstates-1,total)
                        W=W+WJacc((numstates-j+i-1)*sizep+1:(numstates-j+i)*sizep,(j-1)*p+1:j*p);
                end
 
        end
 
        outWJacc=WJacc+W(1:n,:);
	myw=[W;myw];
end
myw=-myw(sizep+1:(total+1)*sizep);
 
% Compute HtimesV
p=size(V,2);
C=zeros(n+(total+1)*sizep,p);
ourHV=zeros(numstates*sizep,p);
zz=zeros(sizep,p);
oldf=y(:,1);
data=[0;numstates;sizep;k(3);k(1);1;consts];
accumHV=ourHV;
 
for i=1:total-1
        temp=tensprod(fun(1,:),[x;oldf],[V;ourHV],myw((i-1)*sizep+1:i*sizep),data);
        data(5)=data(5)+k(3);
        data(6)=data(6)+1;
                oldf=[oldf(sizep+1:numstates*sizep);y(:,i+1)];
                ourHV=[ourHV(sizep+1:numstates*sizep,:);-LinvAV((i-1)*sizep+1:i*sizep,:)];
        if i < numstates
                C(1:n+i*sizep,:)=C(1:n+i*sizep,:)+temp([1:n n+(numstates-i)*sizep+1: n+numstates*sizep],:);
        else
        C((i-numstates)*sizep+1:i*sizep,:)=C((i-numstates)*sizep+1:i*sizep,:)+temp(n+1:n+numstates*sizep,:);
        C(1:n,:)=C(1:n,:)+temp(1:n,:);
        end
        accumHV=[accumHV;-LinvAV((i-1)*sizep+1:i*sizep,:)];
end
if total > 0
        data(4)=k(2)-(total-1)*k(3);
        temp=tensprod(fun(1,:),[x;oldf],[V ; ourHV],myw((total-1)*sizep+1:total*sizep),data);
        if total < numstates
        C(1:n+total*sizep,:)=C(1:n+total*sizep,:)+temp([1:n n+(numstates-total)*sizep+1: n+numstates*sizep],:);
        else
        C((total-numstates)*sizep+1:total*sizep,:)=C((total-numstates)*sizep+1:total*sizep,:)+temp(n+1:n+numstates*sizep,:);
        C(1:n,:)=C(1:n,:)+temp(1:n,:);
        end
        accumHV=[accumHV;-LinvAV((total-1)*sizep+1:total*sizep,:)];
end
 
 
datag=sizep;
 
        if length(outind)==1
                if outind==0
                        if size(fun,1) > 1
                temp=tensprod(fun(2,:),[x;y(:,total+1)],[V;ourHV],myw(total*sizep+1:total*sizep+outm,datag));
                C(total*sizep+1:(total+1)*sizep,:)=temp(n+1:sizep+n,:);
                [val,W]=revprod(fun(2,:),[x;y(:,total+1)],[V;-LinvAV(total*sizep+1:total*sizep+outm)],datag);
                W=-C(total*sizep+1:(total+1)*sizep,:)-W(n+1:sizep+n,:);
                        else
                W=-C(total*sizep+1:(total+1)*sizep)+LinvAV((total-1)*sizep+1:total*sizep,:);
 
                        end
                else
                if size(fun,1) > 1
                temp=tensprod(fun(2,:),[x;acummy],[V;accumHV],myw(total*n+1:total*n+outm,datag));
                C=C+temp(n+1:n+(total+1)*sizep,:);
                [val,W]=revprod(fun(2,:),[x;accumy],[V;-LinvAV],datag);
                C=C+W;
                W=-C(total*sizep+1:(total+1)*sizep,:);
                else
                C=C-LinvAV;
                W=-C(total*sizep+1:(total+1)*sizep,:);
                end
                end
        else
        % outputindex is active
        outindy=[];
        for count=1:size(outind,1)
                outindy=[outindy;y(outind(count,2)),outind(count,1)];
                ind=[ind;outind(count,1)*n+outind(count,2)];
        end
        if size(fun,1) > 1
                temp=tensprod(fun(2,:),[x;outindy],[V;accumHV(ind)],myw(total*sizep+1:total*sizep+outm,datag));
                C(ind+n,ind+n)=C(n+ind,n+ind)+temp(n+1:n+length(outindy),:);
                C(1:n,:)=C(1:n,:)+temp(1:n,:);
                [val,W]=revprod(fun(2,:),[x;outindy],[V;-LinvAV(ind)],datag);
                C(ind,ind)=C(ind,ind)+W;
                W=-C(total*sizep+1:(total+1)*sizep,:);
        else
                C(ind,ind)=C(ind,ind)-LinvAV(ind);
                W=-C(total*sizep+1:(total+1)*sizep,:);
        end
        end
if total > 0
outWJacc=-C(1:n,:);
WJaccbig=C(n+1:size(C,1),:);
[val,W]=revprod(fun(1,:),[x;oldf],W,data);
outWJacc=outWJacc+W(1:n,:);
W=W(n+1:n+sizep,:)+WJaccbig((total-1)*sizep+1:total*sizep,:);
data(4)=k(3);
if numstates > 1
                WJacc=zeros((numstates-1)*sizep,total*p);
                WJacc(:,(total-1)*p+1:total*p)=W(n+1:(numstates-1)*sizep+n,:);
end
 
end
 
for i=total-1:-1:1
        data(5)=data(5)-k(3);
        data(6)=data(6)-1;
        oldf=[y(:,i-numstates+1);oldf(1:(numstates-1)*sizep)];
        [val,W]=revprod(fun(1,:),[x; oldf],W,data);
        if i < numstates
                if ((i > 1) & (numstates > 1))
                        WJacc(1:(i-1)*sizep,(i-1)*p+1:i*p)=W(n+1+(numstates-i)*sizep:(numstates-1)*sizep+n,:);
                end
                W=W(n+(i-1)*sizep+1:n+i*sizep,:)+WJaccbig((i-1)*sizep+1:i*sizep,:);
                for j=i+1:min(i+numstates-1,total)
                        W=W+WJacc((2*i-j)*sizep+1:(2*i-j+1)*sizep,(j-1)*p+1:j*p);
                end
        else
                if (numstates > 1)
                WJacc(:,(i-1)*p+1:i*p)=W(n+1:(numstates-1)*sizep+n,:);
                end
                W=W(n+(numstates-1)*sizep+1:n+numstates*sizep,:)+WJaccbig((i-1)*sizep+1:i*sizep,:);
                for j=i+1:min(i+numstates-1,total)
                        W=W+WJacc((numstates-j+i-1)*sizep+1:(numstates-j+i)*sizep,(j-1)*p+1:j*p);
                end
 
        end
 
        outWJacc=WJacc+W(1:n,:);
        myw=[W;myw];
end
HV=-outWJacc(1:n,1:p);

