function [f,HV]=ExtHVGI(x,V,fdata)

n=length(x);
id =fdata(1);
idf =fdata(2);
k=fdata(3);
k=k+1;
m=fdata(4);
ExtraArg=fdata(5:n+4);
f=[x;ExtraArg];

% Initialise 
p=size(V,2);
JV=zeros(n,p);
saveV=V;
V=-V;
inputpt=x;
LinvAV=[];
y=zeros(n,k);
 
y(:,1)=ExtraArg;
 
% Forward Pass
for i=1:k-1
	[y(:,i+1),JV]=forwprod(id,f,[V;JV],n);
	f=[x;y(:,i+1)];
	LinvAV=[LinvAV;JV];
end
inputptsave=inputpt;
% Compute gradient
[f,grad_y]=revprod(idf,y(:,k),1);
% Compute w
p=1;
W=-grad_y;
WJacc=zeros(n,p);
myw=W; 
for i=k-1:-1:1
        [f1,W]=revprod(id,[x;y(:,i+1)],W);
	WJacc=WJacc+W(1:n,:);
	W=W(n+1:2*n,:);
	myw=[W;myw];
end
myw=-myw(n+1:k*n);
% Compute HtimesV
p=size(V,2);
C=zeros(k*n,p);
inputpt=inputptsave;
ourHV=zeros(n,p);
for i=1:k-1
	temp=tensprod(id,[x;y(:,i)],[saveV;ourHV],myw((i-1)*n+1:i*n));
	C(1:n,:)=C(1:n,:)+temp(1:n,:);
	if (i > 1)
	C((i-1)*n+1:i*n,:)=C((i-1)*n+1:i*n,:)+temp(n+1:2*n,:);
	end
	ourHV=-LinvAV((i-1)*n+1:i*n,:);
end
C((k-1)*n+1:k*n,:)=C((k-1)*n+1:k*n,:)+HtimesV(idf,y(:,k),ourHV); 
% Compute final H*V
W=-C((k-1)*n+1:k*n,:);
inputpt=inputptsave;
for i=k-1:-1:1
        [f1,W]=revprod(id,[x;y(:,i)],W);
	if (i > 1)
	W=W(n+1:2*n,:);
	end
end
HV=C(1:n,:)-W(1:n,1:p);
