function [f,HV]=ExtHVGI(fun,x,V,fdata)

n=length(x);
k=fdata.k;
dims=fdata.dims;
ExtraArg=fdata.py0;
sizep=dims(1);
sizestate=dims(2);
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Recovery complete
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


data=sizep;
p=size(V,2);
JV=zeros(sizestate,p);
saveV=V;
V=-V;
LinvAV=[];
y=zeros(sizestate,k+1);
accumy=ExtraArg;
accumJV=JV;
y(:,1)=ExtraArg;
% Forward Pass
for i=1:k
	[y(:,i+1),JV]=forwprod(fun(1,:),[x((i-1)*sizep+1:i*sizep);y(:,i)],[V((i-1)*sizep+1:i*sizep,:);JV],sizestate,data);
        LinvAV=[LinvAV;JV];
        accumy=[accumy;y(:,i+1)];
        accumJV=[accumJV;JV];
end

datag=[k;dims(1)];
[f,grad_y]=funcval(fun(2,:),[x;accumy],datag);

W=-grad_y(k*(sizep+sizestate)+1:k*sizep+(k+1)*sizestate); 
myw=W;
for i=k:-1:1
        [val,W]=revprod(fun(1,:),[x((i-1)*sizep+1:i*sizep); y(:,i)],W,data);
	W=W(sizep+1:sizep+sizestate)-grad_y(k*sizep+(i-1)*sizestate+1:k*sizep+i*sizestate);
	myw=[W;myw];
end
myw=-myw(sizestate+1:(k+1)*sizestate);
 
% Compute HtimesV
p=size(V,2);
C=zeros(k*sizep+(k+1)*sizestate,p);
ourHV=zeros(sizestate,p);
 
for i=1:k
        temp=tensprod(fun(1,:),[x((i-1)*sizep+1:i*sizep); y(:,i)],[-V((i-1)*sizep+1:i*sizep,:);ourHV],myw((i-1)*sizestate+1:i*sizestate),data);
        ourHV=-LinvAV((i-1)*sizestate+1:i*sizestate,:);
        C([(i-1)*sizep+1:i*sizep n+(i-1)*sizestate+1:n+i*sizestate],:)=temp;
end
C=C+HtimesV(fun(2,:),[x;accumy],[V;accumJV],datag);

outWJacc=-C(1:n,:);
W=-C(k*(sizep+sizestate)+1:k*sizep+(k+1)*sizestate,:); 
for i=k:-1:1
        [val,W]=revprod(fun(1,:),[x((i-1)*sizep+1:i*sizep); y(:,i)],W,data);
        outWJacc(1:sizep,:)=outWJacc(1:sizep,:)+W(1:sizep,:);
        W=W(sizep+1:sizep+sizestate,:)-C(k*sizep+(i-1)*sizestate+1:k*sizep+i*sizestate,:);
end
HV=-outWJacc(1:n,1:p);

