function [f,HV]=ExtHVgen(fun,x,V,fdata)

k=fdata.k;
m=fdata.m;
data=0;
n=length(x);
% Initialise 
saveV=V;
V=-V;
inputpt=x;
LinvAV=[];

% Forward Pass
	[inputpt,JV]=forwprod(fun(1,:),inputpt,V,k*m,data);
	V=[V;JV];
	LinvAV=[LinvAV;JV];
inputptsave=inputpt;
% Compute gradient ==w
[f,myw]=funcval(fun(2,:),inputpt,data);


% Compute HtimesV
p=size(V,2);
C=zeros((k+1)*n,p);
ourV=saveV;
C(1:n,:)=tensprod(fun(1,:),x,ourV,myw,data);
ourV=[ourV;-LinvAV];
C(n+1:(k+1)*n,:)=C(n+1:(k+1)*n,:)+HtimesV(fun(2,:),inputptsave,ourV(n+1:(k+1)*n,:),data); 
% Compute final H*V
W=-C(n+1:(k+1)*n,:);
[f1,WJ(1:n,1:p)]=revprod(fun(1,:),x,W,data);
HV=C(1:n,:)-WJ(1:n,1:p);
