function [a1,a2,a3]=ExtHfunc(func,ExtH,n,b1,b2)
%
%evalHfunc
%	
%	Computing with Extended Hessian.
%
%       ******************************************************************
%       *              ADMIT-2 Project   1996-97                         *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************

if nargin < 4 b1=[]; end
if nargin < 5 b2=[]; end
 
[nrow,ncol]=size(ExtH);
A=ExtH(1:nrow-n,1:n);
B=ExtH(nrow-n+1:nrow,1:n);
L=ExtH(1:nrow-n,n+1:ncol);
M=ExtH(nrow-n+1:nrow,n+1:ncol);

if func==1
% Solve HV
	 if L~=[]
                a1= B*b1-M*(L\(A*b1));
        else
                a1= B*b1;
        end
 
elseif func==2
% Solve V'HV

elseif func==3
% Compute H
 
elseif func==4
% Solve (H+C)s=f

elseif func==5
% Solve Z'HZs=f

elseif func==6
% Solve det(H)

elseif func==7
% Solve LDL'(H)

elseif func==8
% Solve QR(H)

elseif func==9
% Solve eig(H)

elseif func==10
% Solve rank(H)

elseif func==11
% Solve null(H)

end
