function [f,JV]=ExtJVDI1(fun,x,V,fdata)
% State Estimation Problem
p=size(V,2);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Recover
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 

n=length(x);
        ExtraArg=fdata.py0;
        impl=fdata.impl;
        k=fdata.k;
        kind=fdata.kind;
        numstates=fdata.numstates;
        dims=fdata.dims;
        sizep=dims(1);
        m=dims(2);
        consts=fdata.consts;
        outind = fdata.outind;
        yfinal=fdata.yfinal;

 
 
 
 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Recovery complete
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
total=ceil(abs((k(2)-k(1))/k(3)));
if ((k(2) < k(1)) & (k(3) > 0))
        k(3)=-k(3);
end
 

data=[0;numstates;sizep;k(3);k(1);1;consts];
oldf=[zeros((numstates-1)*n,1);x]; 
V=-V;
oldJV=[zeros((numstates-1)*n,p);V]; 
zz=zeros(sizep,p);
y=zeros(n,total+1);
y(:,1)=x;
accumy=x;
accumJV=V;

for i=1:total-1
	[y(:,i+1),JV]=forwprod(fun(1,:),[ExtraArg;oldf],[zz ; oldJV],n,data);
	data(5)=data(5)+k(3);
	data(6)=data(6)+1;
	oldf=[oldf(n+1:numstates*n);y(:,i+1)];
	oldJV=[oldJV(n+1:numstates*n,:);JV];
	accumy=[accumy;y(:,i+1)];
	accumJV=[accumJV;JV];
end

if total > 0
        data(4)=k(2)-(total-1)*k(3);
	[y(:,total+1),JV]=forwprod(fun(1,:),[ExtraArg;oldf],[zz ; oldJV],n,data);
	accumy=[accumy;y(:,total+1)];
	accumJV=[accumJV; JV];
	f=y(:,total+1);
else
	f=x;
	JV=V;
end

        datag=sizep;
 
        if length(outind)==1
                if outind==0
		if size(fun,1) > 1
			[f,JV]=forwprod(fun(2,:),[ExtraArg;f],[zz;JV],m,datag);
		end
		else
        % all ys, do it
		if size(fun,1) > 1
			[f,JV]=forwprod(fun(2,:),[ExtraArg;accumy],[zz;accumJV],m,datag);
                else
			f=accumy;
			JV=accumJV	
		end
		end
        else
        % outputindex is active
        myJV=[];
        for count=1:size(outind,1)
                outindy=[outindy;y(outind(count,2)),outind(count,1)];
		myJV=[myJV;accumJV(outind(count,1)*n+outind(count,2),:)];
        end
		if size(fun,1) > 1
	[f,JV]=forwprod(fun(2,:),[ExtraArg;outindy],[zz;myJV],m,datag);
        else
		f=outindy;
		JV=myJV;
	end

	end
JV=-JV;
f=f-yfinal;
