function [f,WJ]=ExtWJDI1(fun,x,W,fdata)
% State Estimation Problem

p=size(W,2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Recover
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
n=length(x);
        ExtraArg=fdata.py0;
        impl=fdata.impl;
        k=fdata.k;
        kind=fdata.kind;
        numstates=fdata.numstates;
        dims=fdata.dims;
        sizep=dims(1);
        m=dims(2);
        consts=fdata.consts;
        outind = fdata.outind;
        yfinal=fdata.yfinal;

 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Recovery complete
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
total=ceil(abs((k(2)-k(1))/k(3)));
if ((k(2) < k(1)) & (k(3) > 0))
        k(3)=-k(3);
end
 
data=[0;numstates;sizep;k(3);k(1);1;consts];
 
oldf=[zeros((numstates-1)*sizep,1);ExtraArg];
f=ExtraArg;
y=zeros(sizep,total+1);
y(:,1)=ExtraArg;
y=zeros(sizep,total+1);
accumy=ExtraArg;

for i=1:total-1
	y(:,i+1)=funcvalJ(fun(1,:),[x;oldf],sizep,data);
	data(5)=data(5)+k(3);
	data(6)=data(6)+1;
        oldf=[oldf(sizep+1:numstates*sizep);y(:,i+1)];
	accumy=[accumy;y(:,i+1)];
end

if total > 0
	data(4)=k(2)-(total-1)*k(3);
	y(:,total+1)=funcvalJ(fun(1,:),[x;oldf],sizep,data);
        accumy=[accumy;y(:,total+1)];
        f=y(:,total+1);
else
        f=x;
end

W=-W;
WJaccbig=zeros(total*sizep,p);
outWJacc=zeros(n,p);
	datag=n;
        if length(outind)==1
                if outind==0
			if size(fun,1) > 1
			[f,W]=revprod(fun(2,:),[x;y(:,total+1)],W,datag);
			W=W(n+1:n+sizep,:);
			outWJacc=outWJacc+W(1:n,:);
			end

                else
        % all ys, do it
			if size(fun,1) > 1
		[f,W]=revprod(fun(2,:),[x;accumy],W,datag);
                W=W(n+total*sizep+1:(total+1)*sizep+n,:);
                WJaccbig=W(n+1:n+total*sizep,:);
			outWJacc=outWJacc+W(1:n,:);
			else
			W=zeros(sizep,p);
			f=accumy;
			end
                end
        else
        % outputindex is active
        myJV=[];
	outindy=[];
        for count=1:size(outind,1)
                outindy=[outindy;y(outind(count,2)),outind(count,1)];
        end
		if size(fun,1) > 1
                [f,W]=revprod(fun(2,:),[ExtraArg;outindy],W,datag);
                totalW=zeros((total+1)*sizep,p);
                totalW(:,ind)=W(:,n+1:n+length(outindy));
                W=totalW(n+total*sizep+1:(total+1)*sizep+n,:);
                WJaccbig=totalW(n+1:n+total*sizep,:);
			outWJacc=outWJacc+W(1:n,:);
		else
			W=zeros(sizep,p);
			f=outindy;
		end
        end


if total > 0
[val,W]=revprod(fun(1,:),[x;oldf],W,data);
outWJacc=outWJacc+W(1:n,:);
data(4)=k(3);
if numstates > 1
                WJacc=zeros((numstates-1)*sizep,total*p);
		WJacc(:,(total-1)*p+1:total*p)=W(n+1:(numstates-1)*sizep+n,:);
end
W=W(n+1:n+sizep,:)+WJaccbig((total-1)*n+1:total*n,:);

end

for i=total-1:-1:1
        data(5)=data(5)-k(3);
        data(6)=data(6)-1;
	if i > numstates
        oldf=[y(:,i-numstates+1);oldf(1:(numstates-1)*sizep)];
        else
	oldf=[zeros(sizep,1);oldf(1:(numstates-1)*sizep)];
	end
	[val,W]=revprod(fun(1,:),[x; oldf],W,data);
        if i < numstates
                if ((i > 1) & (numstates > 1))
                        WJacc(1:(i-1)*sizep,(i-1)*p+1:i*p)=W(n+1+(numstates-i)*sizep:(numstates-1)*sizep+n,:);
                end
                W=W(n+(i-1)*sizep+1:n+i*sizep,:)+WJaccbig((i-1)*sizep+1:i*sizep,:);
                for j=i+1:min(i+numstates-1,total)
                        W=W+WJacc((2*i-j)*sizep+1:(2*i-j+1)*sizep,(j-1)*p+1:j*p);
                end
        else
                if (numstates > 1)
                WJacc(:,(i-1)*p+1:i*p)=W(n+1:(numstates-1)*sizep+n,:);
                end
		W=W(n+(numstates-1)*sizep+1:n+numstates*sizep,:)+WJaccbig((i-1)*sizep+1:i*sizep,:);
                for j=i+1:min(i+numstates-1,total)
			W=W+WJacc((numstates-j+i-1)*sizep+1:(numstates-j+i)*sizep,(j-1)*p+1:j*p);
                end
 
        end
	outWJacc=outWJacc+W(1:n,:);
end

if numstates > 1
WJ=-outWJacc;
else
WJ=-W(1:n,:);
end
f=f-yfinal; 

