function [f,WJ]=ExtWJDI1(fun,x,W,fdata)
% State Estimation Problem

p=size(W,2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Recover
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
n=length(x);
k=fdata.k;
dims=fdata.dims;
ExtraArg=fdata.py0;
sizep=dims(1);
sizestate=dims(2);


 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Recovery complete
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

y=zeros(sizep,k+1);
y(:,1)=ExtraArg;
accumy=ExtraArg;
data=sizep;
 
for i=1:k
	y(:,i+1)=funcvalJ(fun(1,:),[x((i-1)*sizep+1:i*sizep);y(:,i)],sizestate,data);
	accumy=[accumy;y(:,i+1)];
end


W=-W;
datag=[k;sizep];
[f,W]=revprod(fun(2,:),[x;accumy],W,datag);
outWJacc=W(1:k*sizep,:);
WJaccbig=W(k*sizep+1:k*sizep+k*sizestate,:);
W=W(k*sizep+k*sizestate+1:k*sizep+(k+1)*sizestate,:);
[val,W]=revprod(fun(1,:),[x((k-1)*sizep+1:k*sizep);y(:,k)],W,data);
outWJacc((k-1)*sizep+1:k*sizep,:)=outWJacc((k-1)*sizep+1:k*sizep,:)+W(1:sizep,:);
W=W(sizep+1:sizep+sizestate,:)+WJaccbig((i-1)*sizestate+1:i*sizestate);

for i=k-1:-1:1
        [val,W]=revprod(fun(1,:),[x((i-1)*sizep+1:i*sizep);y(:,i)],W,data);
	outWJacc((i-1)*sizep+1:i*sizep,:)=outWJacc((i-1)*sizep+1:i*sizep,:)+W(1:sizep,:);
        W=W(sizep+1:sizep+sizestate,:)+WJaccbig((i-1)*sizestate+1:i*sizestate);
end
WJ=-outWJacc;
