echo on 
 
%
% First doing a function evaluation, using K=10(number of nested function invokations)
% Using u(0)=ones(20,1);
%

f=funcvalJExt('IP',fun,ones(20,1),20,10,ones(20,1));
f
pause
%
% Doing a J*V, using K=10(number of nested function invokations)
%
V=ones(20,1);
[f,JV]=ExtJV('IP',fun,ones(20,1),V,20,10,ones(20,1));
JV
pause
%
% Now doing a reverse product W^T*J, using K=4
%
W=ones(20,1);
[f,WJ]=ExtWJ('IP',fun,ones(20,1),W,20,4,ones(20,1));
WJ

%
% Now evaluating extended J , using K=10
%

[f,extJ]=evalJExt('IP',fun,ones(20,1),20,10,ones(20,1),[],JPI);

%Sparsity structure of extended J

figure(1)
spy(extJ)
pause
% Now lets also compute the full Jacobian usinf linear algebra on Extended J

[f,extJ,J]=evalJExt('IP',fun,ones(20,1),20,10,ones(20,1),[],JPI);
 
%Sparsity structure of J
 
figure(2)
spy(J)

echo off 
