static char mc_version[] = "MATLAB Compiler 1.0 infun";
/*
 *  MATLAB Compiler: 1.0
 *  Date: Oct 20, 1995
 *  Arguments: -ire myfun 
 */
#include <math.h>
#include "matrix.h"
#include "mcc.h"
#include "matlab.h"

/* static array S0_ (1 x 1) text, line 6: 'n' */
static double S0__r_[] =
{
        110,
};
static Matrix S0_ = { {0}, mxFULL, mxDOUBLE, mxSTRING, 0,
        1, 1, S0__r_, 0, -1, 0, {0} };

Matrix *
mlfMyfun(Matrix **g_lhs_, Matrix *x_rhs_)
{
   int ci_, i_, j_;
   unsigned flags_;
   Matrix *Mplhs_[32], *Mprhs_[32];
   int nlhs_=1, nrhs_=0;
   Matrix *f_lhs_;
   if (g_lhs_) ++nlhs_;
   if (x_rhs_)
   {
      ++nrhs_;
   }
   {
/***************** Compiler Assumptions ****************
 *
 *       RM0_        	real vector/matrix temporary
 *       f           	real vector/matrix
 *       g           	real vector/matrix
 *       mlfMyfun    	<function being defined>
 *       nargout     	<function>
 *       ones        	<function>
 *       sum         	<function>
 *       x           	real vector/matrix
 *******************************************************/
      Matrix f;
      Matrix g;
      Matrix x;
      Matrix RM0_;
      
      mccRealInit(x);
      mccImport(&x, x_rhs_, 0, 0);
      mccRealInit(f);
      mccRealInit(g);
      mccRealInit(RM0_);
      
      
      /* f=sum(x); */
      mccSum(&f, &x);
      
      /* if nargout >=2 */
      if ((mccNargout() >= 2))
      {
         /* g=ones(n,1); */
         mccUndefVariable(&RM0_, &S0_);
         mccOnesMN(&g, ((int)*RM0_.pr), 1);
         /* end */
      }
      mccReturnFirstValue(&f_lhs_, &f);
      mccReturnValue(g_lhs_, &g);
      mccFreeMatrix(&f);
      mccFreeMatrix(&g);
      mccFreeMatrix(&x);
      mccFreeMatrix(&RM0_);
      return(f_lhs_);
   }
}
