function [f,g,extH]=evalHDI1(fun,fdata,x,PartInfo)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Recover
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
n=length(x);
        ExtraArg=fdata.py0;
        impl=fdata.impl;
        k=fdata.k;
        kind=fdata.kind;
        numstates=fdata.numstates;
        dims=fdata.dims;
        sizep=dims(1);
        m=dims(2);
        consts=fdata.consts;
        outind = fdata.outind;
        yfinal=fdata.yfinal;

 
 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Recovery complete
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
total=ceil(abs((k(2)-k(1))/k(3)));
if ((k(2) < k(1)) & (k(3) > 0))
        k(3)=-k(3);
end
 
data=[0;numstates;sizep;k(3);k(1);1;consts];
oldf=[zeros((numstates-1)*n,1);x];
 
 

if size(fun,1) > 1
[JPI,HPI1,HPI2]=ExtractJPI(PartInfo);
else
[JPI,HPI1]=ExtractJPI(PartInfo);
end 

Identity=-speye(n);
extH=sparse(0,n);
y=zeros(n,total+1);
y(:,1)=x;
accumy=x;

for i=1:total-1
        [y(:,i+1),J]=evalJ(fun(1,:),[ExtraArg;oldf],data,n,JPI);
        data(5)=data(5)+k(3);
        data(6)=data(6)+1;
                oldf=[oldf(n+1:numstates*n);y(:,i+1)];
        if i < numstates
                extH=[extH sparse((i-1)*n,n); J(:,sizep+1+(numstates-i)*n:sizep+numstates*n) Identity];
        else
                extH=[extH sparse((i-1)*n,n); 
		sparse(n,(i-numstates)*n) J(:,sizep+1:sizep+numstates*n) Identity];
        end
	accumy=[accumy;y(:,i+1)];
end

if total > 0
        data(4)=k(2)-(total-1)*k(3);
	[y(:,total+1),J]=evalJ(fun(1,:),[ExtraArg;oldf],data,n,JPI);
	if total >= numstates
                extH=[extH sparse((total-1)*n,n); 
	sparse(n,(total-numstates)*n) J(:,sizep+1:sizep+numstates*n) Identity];
        else
                extH=[extH sparse((total-1)*n,n); J(:,sizep+1+(numstates-total)*n:sizep+numstates*n) Identity];
        end
	accumy=[accumy;y(:,total+1)];
        f=y(:,total+1);
else
        f=x;
end

outm=n; 
datag=sizep;
	g_input=f;
 
        if length(outind)==1
            if outind==0
                if size(fun,1) > 1
                        outm=m;
                        [f,J]=evalJ(fun(2,:),[ExtraArg;f],datag,m,JPI2);
                        extH=[extH ; sparse(m,total*n) J(:,sizep+1:sizep+n)];
		else
			extH=extH(:,1:size(extH,2)-n);
                end

           else
        	g_input=accumy;
        % all ys, do it
                if size(fun,1) > 1
                [f,J]=evalJ(fun(2,:),[ExtraArg;accumy],datag,m,JPI2);
                        extH=[extH; J(:,sizep+1:sizep+(total+1)*n)];
                        outm=m;
                else
			f=g_input;
                        outm=(total+1)*n;
                        extH=[extH ; speye((total+1)*n) ];
                end
          end
        else
        % outputindex is active
        outindy=[];
        for count=1:size(outind,1)
                outindy=[outindy;y(outind(count,2)),outind(count,1)];
                ind=[ind;outind(count,1)*n+outind(count,2)];
        end
        if size(fun,1) > 1
        	[f,J]=evalJ(fun(2,:),[ExtraArg;outindy],datag,m,JPI2);
        	myJ=sparse(m,(total+1)*n);
       	 	myJ(:,ind)=J(:,sizep+1:sizep+length(outindy));
        	outm=m;
        	extH=[extH; myJ];
        else
		f=outindy;
        	outm=length(outindy);
        	myJ=sparse(length(outindy),(total+1)*n);
        	myJ(:,ind)=speye(length(outindy));
        	extH=[extH; myJ];
        end
		g_input=outindy;
 
        end

[nrows,ncols]=size(extH);
extH=[extH(1:nrows-outm,:) sparse(nrows-outm,outm) ; extH(nrows-outm+1:nrows,:) -speye(outm)];
[nrows,ncols]=size(extH);
f=f-yfinal;
grad_y=[zeros(nrows-outm,1);f];
f=0.5*(f'*f);
L=extH(:,n+1:ncols);
w= -L'\grad_y;
g=extH(:,1:n)'*w;
windex=1;

% Do Hessians Now
% Extract all HPIs and compute evalH	

oldf=[x;zeros((numstates-1)*n,1)];
HessP=sparse(ncols-outm,ncols-outm);
data=[0;numstates;sizep;k(3);k(1);1;consts];

for i=1:total-1
        [val,H]=evalHTens(fun(1,:),[ExtraArg;oldf],w(windex:windex+n-1),data,HPI1);
                oldf=[oldf(n+1:numstates*n);y(:,i+1)];
	if i < numstates
	HessP=HessP+[H(sizep+1+(numstates-i)*n:sizep+numstates*n,sizep+1+(numstates-i)*n:sizep+numstates*n) sparse(i*n,ncols-outm-i*n); 
		sparse(ncols-outm-i*n,ncols-outm)];
        else
		HessP=HessP+[sparse((i-numstates)*n,ncols-outm);
		sparse(numstates*n,(i-numstates)*n) H(sizep+1:sizep+numstates*n,sizep+1:sizep+numstates*n) sparse(numstates*n,ncols-outm-i*n);
                sparse(ncols-outm-i*n,ncols-outm)];

        end

	windex=windex+n;
	data(5)=data(5)+k(3);
        data(6)=data(6)+1;
end
if total > 0
        data(4)=k(2)-(total-1)*k(3);
        [val,H]=evalHTens(fun(1,:),[ExtraArg;oldf],w(windex:windex+n-1),data,HPI1);
        if total < numstates
	HessP=HessP+[H(sizep+1+(numstates-i)*n:sizep+numstates*n,sizep+1+(numstates-i)*n:sizep+numstates*n)  sparse(total*n,ncols-outm-total*n);
			sparse(ncols-outm-total*n,ncols-outm)];
        else
	HessP=HessP+[sparse(ncols-outm-numstates*n,ncols-outm);
sparse(numstates*n,ncols-outm-numstates*n) H(sizep+1:sizep+numstates*n,sizep+1:sizep+numstates*n)];
	end
	windex=windex+n;
end
 

datag=sizep;
 
        if length(outind)==1
                if outind==0
                if size(fun,1) > 1
       		[val,H]=evalHTens(fun(2,:),[ExtraArg;g_input],w(windex:windex+outm-1),datag,HPI2);
		HessP=HessP+[sparse(total*n,ncols-outm); 
		sparse(n,total*n) H(sizep+1:sizep+n,sizep+1:sizep+n) sparse(n,ncols-outm-(total+1)*n);
		sparse(ncols-outm-(total+1)*n,ncols-outm)];
		end
                else
                g_input=accumy;
        % all ys, do it
                if size(fun,1) > 1
       		[val,H]=evalHTens(fun(2,:),[ExtraArg;g_input],w(windex:windex+outm-1),datag,HPI2);
		HessP=HessP+H(sizep+1:sizep+(total+1)*n,sizep+1:sizep+(total+1)*n);
                end
                end
        else
        % outputindex is active
        outindy=[];
        for count=1:size(outind,1)
                outindy=[outindy;y(outind(count,2)),outind(count,1)];
                ind=[ind;outind(count,1)*n+outind(count,2)];
        end
        if size(fun,1) > 1
       		[val,H]=evalHTens(fun(2,:),[ExtraArg;g_input],w(windex:windex+outm-1),datag,HPI2);
       	        myJ=sparse(ncols-outm,ncols-outm);
       		myJ(ind,ind)=H(sizep+1:sizep+length(outindy),sizep+1:sizep+length(outindy));;
		HessP=HessP+myJ;
        end
	end
	
	HessP=[HessP sparse(ncols-outm,outm); sparse(outm,ncols-outm) speye(outm)];
        extH=[extH sparse(nrows,nrows); HessP(n+1:ncols,:) extH(1:nrows,n+1:ncols)'; 
             HessP(1:n,:) extH(1:nrows,1:n)'];

