function [f,g,extH]=evalHGC(fun,fdata,x,PartInfo)

n=length(x);
id =fdata(1);
idf =fdata(2);
k=fdata(3);
k=k+1;
m=n;
ExtraArg=fdata(5:n+4);
f=[x;ExtraArg];
 
index=1;
Identity=-speye(m);
extH=sparse(0,m);
        len = PartInfo(index);
        si = PartInfo(index+3:index+2+len);
        sj = PartInfo(index+3+len:index+2+2*len);
        v = PartInfo(index+3+2*len:index+2+3*len);
        JPI = sparse(si,sj,v,PartInfo(index+1),PartInfo(index+2),len);
        index=index+3*(len+1);
for i=1:k-1
	[f,J]=evalJ(id,f,[],n,JPI);
	f=[x;f];
	if (i==1)
                K=J(:,m+1:2*m);
	extH=[extH sparse((i-1)*m,m);
	      J(:,1:m) sparse(m,(i-1)*m) Identity];
        else
	extH=[extH sparse((i-1)*m,m);
	      J(:,1:m) sparse(m,(i-2)*m) K  Identity];
        end
end
% Do gradient first
f=f(m+1:2*m);
[f,grad_y]=revprod(idf,f,1);
grad_y=[zeros((k-2)*m,1);grad_y];
L=extH(1:(k-1)*m,m+1:k*m);
w= -L\grad_y;
g=w'*extH(1:(k-1)*m,1:m);

windex=1;

% Do Hessians Now
% Extract all HPIs and compute evalH	

f=[x;ExtraArg];
	len = PartInfo(index);
        si = PartInfo(index+3:index+2+len);
        sj = PartInfo(index+3+len:index+2+2*len);
        v = PartInfo(index+3+2*len:index+2+3*len);
        HPI = sparse(si,sj,v,PartInfo(index+1),PartInfo(index+2),len);
        index=index+3*(len+1);

HessP=sparse(k*m,k*m);

for i=1:k-1
        [f,H]=evalHTens(id,f,w(windex:windex+n-1),[],HPI);
	f=[x;f];
%        extH((k-1)*m+1:k*m,1:m)=extH((k-1)*m+1:k*m,1:m)+H(1:m,1:m);
	if (i==1)
		HessP=HessP+[H(1:m,1:m) sparse(m,(k-1)*m); sparse((k-1)*m,k*m)];
	else
		HessP=HessP+[H(1:m,1:m) sparse(m,(i-2)*m) H(1:m,m+1:2*m) sparse(m,(k-i)*m); 
				sparse((i-2)*m,k*m);
		H(m+1:2*m,1:m) sparse(m,(i-2)*m) H(m+1:2*m,m+1:2*m) sparse(m,(k-i)*m)
				sparse((k-i)*m,k*m)];
	end
	windex=windex+n;
end
	f=f(m+1:2*m);
        len = PartInfo(index);
        si = PartInfo(index+3:index+2+len);
        sj = PartInfo(index+3+len:index+2+2*len);
        v = PartInfo(index+3+2*len:index+2+3*len);
        HPI = sparse(si,sj,v,PartInfo(index+1),PartInfo(index+2),len);
        index=index+3*(len+1);
        [f,g,H]=evalH(idf,f,[],HPI);
	HessP=HessP+[sparse((k-1)*m,k*m);
		     sparse(m,(k-1)*m) H];
        extH=[extH sparse((k-1)*m,(k-1)*m); HessP(m+1:k*m,:) extH(1:(k-1)*m,m+1:k*m)'; 
             HessP(1:m,:) extH(1:(k-1)*m,1:m)'];


