function [f,g,extH]=evalHGC(fun,fdata,x,PartInfo)

k=fdata.k;
data=0;
n=length(x);
 
m=n;
 
k=k+1;
index=1;
Identity=-speye(m);
extH=sparse(0,m);
f=x;
[JPI,HPI1,HPI2]=ExtractJPI(PartInfo);

for i=1:k-1
	[f,J]=evalJ(fun(1,:),f,data,[],JPI);
	extH=[extH sparse((i-1)*m,m);
        sparse(m,(i-1)*m) J(:,1:m) Identity];
end

% Do gradient first
[f,grad_y]=funcval(fun(2,:),f,data);
grad_y=[zeros((k-2)*m,1);grad_y];
L=extH(1:(k-1)*m,m+1:k*m);
w= -L'\grad_y;

windex=1;
% Do Hessians Now
% Extract all HPIs and compute evalH	
f=x;
HessP=sparse(k*m,k*m);

for i=1:k-1
        [f,H]=evalHTens(fun(1,:),f,w(windex:windex+n-1),data,HPI1);
%        extH((k-1)*m+(i-1)*m+1:(k-1)*m+i*m,(i-1)*m+1:i*m)=extH((k-1)*m+(i-1)*m+1:(k-1)*m+i*m,(i-1)*m+1:i*m)+H;
HessP=HessP+[sparse((i-1)*m,k*m); sparse(m,(i-1)*m) H sparse(m,(k-i)*m); sparse((k-i)*m,k*m)];
        windex=windex+n;
end

        [f,g,H]=evalH(fun(2,:),f,data,HPI2);
        HessP=HessP+[sparse((k-1)*m,k*m);
                     sparse(m,(k-1)*m) H];
        extH=[extH sparse((k-1)*m,(k-1)*m); HessP(m+1:k*m,:) extH(1:(k-1)*m,m+1:k*m)';
             HessP(1:m,:) extH(1:(k-1)*m,1:m)'];
 

