function [f,g,extH]=evalHII1(fun,fdata,x,PartInfo)

 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Recover
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
n=length(x);
        ExtraArg=fdata.py0;
        impl=fdata.impl;
        k=fdata.k;
        kind=fdata.kind;
        numstates=fdata.numstates;
        dims=fdata.dims;
        sizep=dims(1);
        m=dims(2);
        consts=fdata.consts;
        outind = fdata.outind;
        yfinal=fdata.yfinal;

 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Recovery complete
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
total=ceil(abs((k(2)-k(1))/k(3)));
if ((k(2) < k(1)) & (k(3) > 0))
        k(3)=-k(3);
end
 
data=[0;numstates;sizep;k(3);k(1);1;consts];
dataI=[1;numstates;sizep;k(3);k(1);1;consts];
oldf=[zeros((numstates-1)*n,1);x];
 
 
Identity=-speye(n);
extH=sparse(0,n);
 
if size(fun,1) > 1
[JPI,HPI1,HPI2]=ExtractJPI(PartInfo);
else
[JPI,HPI1]=ExtractJPI(PartInfo);
end
y=zeros(n,total+1);
y(:,1)=x;
accumy=x;
 
for i=1:total-1
	y(:,i+1)=funcvalJ(fun(1,:),[ExtraArg;oldf],n,data);
	[dummy,J]=evalJ(fun(1,:),[ExtraArg;oldf;y(:,i+1)],dataI,n,JPI);
        oldf=[oldf(n+1:numstates*n);y(:,i+1)];
        if i < numstates
                extH=[extH sparse((i-1)*n,n); J(:,sizep+1+(numstates-i)*n:sizep+(numstates+1)*n)];
        else
                extH=[extH sparse((i-1)*n,n); 
		sparse(n,(i-numstates)*n) J(:,sizep+1:sizep+(numstates+1)*n)];
        end
        data(5)=data(5)+k(3);
        data(6)=data(6)+1;
        dataI(5)=dataI(5)+k(3);
        dataI(6)=dataI(6)+1;
	accumy=[accumy;y(:,i+1)];
end

 
if total > 0
        data(3)=k(2)-(total-1)*k(3);
        dataI(3)=k(2)-(total-1)*k(3);
	f=funcvalJ(fun(1,:),[ExtraArg;oldf],n,data);
	[dummy,J]=evalJ(fun(1,:),[ExtraArg;oldf;f],dataI,n,JPI);
        if total < numstates
                extH=[extH sparse((total-1)*n,n); J(:,sizep+1+(numstates-total)*n:sizep+(numstates+1)*n)];
        else
                extH=[extH sparse((total-1)*n,n); 
	sparse(n,(total-numstates)*n) J(:,sizep+1:sizep+(numstates+1)*n)];
        end
	accumy=[accumy;y(:,total+1)];
        f=y(:,total+1);
else
        f=x;
end
 
outm=n;
datag=sizep;
        g_input=f;
        if length(outind)==1
            if outind==0
                if size(fun,1) > 1
                        outm=m;
                        [f,J]=evalJ(fun(2,:),[ExtraArg;f],datag,m,JPI2);
                        extH=[extH ; sparse(m,total*n) J(:,sizep+1:sizep+n)];
                else
                        extH=extH(:,1:size(extH,2)-n);
                end
 
           else
                g_input=accumy;
        % all ys, do it
                if size(fun,1) > 1
                [f,J]=evalJ(fun(2,:),[ExtraArg;accumy],datag,m,JPI2);
                        extH=[extH; J(:,sizep+1:sizep+(total+1)*n)];
                        outm=m;
                else
			f=g_input;
                        outm=(total+1)*n;
                        extH=[extH ; speye((total+1)*n) ];
                end
          end
        else
        % outputindex is active
        outindy=[];
        for count=1:size(outind,1)
                outindy=[outindy;y(outind(count,2)),outind(count,1)];
                ind=[ind;outind(count,1)*n+outind(count,2)];
        end
        if size(fun,1) > 1
                [f,J]=evalJ(fun(2,:),[ExtraArg;outindy],datag,m,JPI2);
                myJ=sparse(m,(total+1)*n);
                myJ(:,ind)=J(:,sizep+1:sizep+length(outindy));
                outm=m;
                extH=[extH; myJ];
        else
		f=outindy;
                outm=length(outindy);
                myJ=sparse(length(outindy),(total+1)*n);
                myJ(:,ind)=speye(length(outindy));
                extH=[extH; myJ];
        end
                g_input=outindy;
 
        end
 
[nrows,ncols]=size(extH);
extH=[extH(1:nrows-outm,:) sparse(nrows-outm,outm) ; extH(nrows-outm+1:nrows,:) -speye(outm)];
[nrows,ncols]=size(extH);
f=f-yfinal;
grad_y=[zeros(nrows-outm,1);f];
f=0.5*(f'*f);
L=extH(:,n+1:ncols);
w= -L'\grad_y;
g=extH(:,1:n)'*w;
windex=1;
 
% Do Hessians Now
% Extract all HPIs and compute evalH
 
oldf=[zeros((numstates-1)*n,1);x];
HessP=sparse(ncols,ncols);
data=[0;numstates;sizep;k(3);k(1);1;consts];
dataI=[1;numstates;sizep;k(3);k(1);1;consts];

for i=1:total-1

[dummy,H]=evalHTens(fun(1,:),[ExtraArg;oldf;y(:,i+1)],w(windex:windex+n-1),dataI,HPI1);
                oldf=[oldf(n+1:numstates*n);y(:,i+1)];
if i < numstates
HessP=HessP+[H(sizep+1+(numstates-i)*n:sizep+(numstates+1)*n,sizep+1+(numstates-i)*n:sizep+(numstates+1)*n) sparse((i+1)*n,ncols-outm-i*n);
                sparse(ncols-outm-i*n,ncols-outm+n)];

        else
		HessP=HessP+[sparse((i-numstates)*n,ncols-outm+n);
sparse((numstates+1)*n,(i-numstates)*n) H(sizep+1:sizep+(numstates+1)*n,sizep+1:sizep+(numstates+1)*n) sparse((numstates+1)*n,ncols-outm-i*n);
                sparse(ncols-outm-i*n,ncols-outm+n)];

        end

	windex=windex+n;
	data(5)=data(5)+k(3);
        data(6)=data(6)+1;
	dataI(5)=dataI(5)+k(3);
        dataI(6)=dataI(6)+1;
end
if total > 0
[dummy,H]=evalHTens(fun(1,:),[ExtraArg;oldf;y(:,total+1)],w(windex:windex+n-1),dataI,HPI1);
        if total < numstates
HessP=HessP+[H(sizep+1+(numstates-total)*n:sizep+(numstates+1)*n,sizep+1+(numstates-total)*n:sizep+(numstates+1)*n)  sparse((total+1)*n,ncols-outm-total*n);
                        sparse(ncols-outm-total*n,ncols-outm+n)];

	else

        HessP=HessP+[sparse(ncols-outm-(numstates+1)*n,ncols-outm+n);
sparse((numstates+1)*n,ncols-outm-(numstates+1)*n) H(sizep+1:sizep+(numstates+1)*n,sizep+1:sizep+(numstates+1)*n) sparse((numstates+1)*n,n);
	sparse(n,ncols-outm+n)];

	end
else
        f=x;
end
 
datag=sizep;
 
        if length(outind)==1
                if outind==0
                if size(fun,1) > 1
                [val,H]=evalHTens(fun(2,:),[ExtraArg;g_input],w(windex:windex+outm-1),datag,HPI2);
                HessP=HessP+[sparse(total*n,ncols-outm+n);
                sparse(n,total*n) H(sizep+1:sizep+n,sizep+1:sizep+n) sparse(n,ncols-outm-total*n);
                sparse(ncols-outm-total*n,ncols-outm)];
                end
                else
                g_input=accumy;
        % all ys, do it
                if size(fun,1) > 1
                [val,H]=evalHTens(fun(2,:),[ExtraArg;g_input],w(windex:windex+outm-1),datag,HPI2);
                HessP=HessP+H(sizep+1:sizep+(total+1)*n,sizep+1:sizep+(total+1)*n);
                end
                end
        else
        % outputindex is active
        outindy=[];
        for count=1:size(outind,1)
                outindy=[outindy;y(outind(count,2)),outind(count,1)];
                ind=[ind;outind(count,1)*n+outind(count,2)];
        end
        if size(fun,1) > 1
                [val,H]=evalHTens(fun(2,:),[ExtraArg;g_input],w(windex:windex+outm-1),datag,HPI2);
                myJ=sparse(ncols-outm,ncols-outm);
                myJ(ind,ind)=H(sizep+1:sizep+length(outindy),sizep+1:sizep+length(outindy));;
                HessP=HessP+myJ;
        end
        end
 
%        [f,gg,H]=evalH(fun(2,:),[ExtraArg;f],datag,HPI2);
%       HessP=[HessP sparse(total*n,n);
%          sparse(n,total*n) H(sizep+1:sizep+n,sizep+1:sizep+n)];
 
        HessP=HessP+[sparse(ncols-outm,ncols); sparse(outm,ncols-outm) speye(outm)];
        extH=[extH sparse(nrows,nrows); HessP(n+1:ncols,:) extH(1:nrows,n+1:ncols)';
             HessP(1:n,:) extH(1:nrows,1:n)'];
 
