function [f,g,extH]=evalHDI1(fun,fdata,x,PartInfo)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Recover
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

n=length(x);
        ExtraArg=fdata.py0;
        impl=fdata.impl;
        k=fdata.k;
        kind=fdata.kind;
        numstates=fdata.numstates;
        dims=fdata.dims;
        sizep=dims(1);
        m=dims(2);
        consts=fdata.consts;
        outind = fdata.outind;
        yfinal=fdata.yfinal;

 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Recovery complete
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
total=ceil(abs((k(2)-k(1))/k(3)));
if ((k(2) < k(1)) & (k(3) > 0))
        k(3)=-k(3);
end
 
data=[0;numstates;sizep;k(3);k(1);1;consts];
dataI=[1;numstates;sizep;k(3);k(1);1;consts];
 
oldf=[zeros((numstates-1)*sizep,1);ExtraArg];
f=oldf; 
 
Identity=-speye(sizep);
extH=sparse(0,n+sizep);

if size(fun,1) > 1
[JPI,HPI1,HPI2]=ExtractJPI(PartInfo);
else
[JPI,HPI1]=ExtractJPI(PartInfo);
end
y=zeros(sizep,total+1);
y(:,1)=ExtraArg;
accumy=ExtraArg;
 
 
index=1;
for i=1:total-1
	 y(:,i+1)=funcvalJ(fun(1,:),[x;oldf],n,data);
        [dummy,J]=evalJ(fun(1,:),[x;oldf;y(:,i+1)],dataI,sizep,JPI);
                oldf=[oldf(sizep+1:numstates*sizep);y(:,i+1)];
       if i < numstates
                extH=[extH sparse((i-1)*sizep,sizep); J(:,[1:n n+1+(numstates-i)*sizep:n+(numstates+1)*sizep])];
        else
                extH=[extH sparse((i-1)*sizep,sizep); 
J(:,1:n) sparse(sizep,(i-numstates)*sizep) J(:,n+1:n+(numstates+1)*sizep)];
        end
        data(5)=data(5)+k(3);
        data(6)=data(6)+1;
        dataI(5)=dataI(5)+k(3);
        dataI(6)=dataI(6)+1;
	accumy=[accumy;y(:,i+1)];
end

 
if total > 0
        data(4)=k(2)-(total-1)*k(3);
	y(:,total+1)=funcvalJ(fun(1,:),[x;oldf],n,data);
        [dummy,J]=evalJ(fun(1,:),[x;oldf;y(:,total+1)],dataI,sizep,JPI);
       
	if i < numstates
                extH=[extH sparse((total-1)*sizep,sizep); 
		J(:,[1:n n+1+(numstates-total)*sizep:n+(numstates+1)*sizep])];
        else
                extH=[extH sparse((total-1)*sizep,sizep);
J(:,1:n) sparse(sizep,(total-numstates)*sizep) J(:,n+1:n+(numstates+1)*sizep)];
        end
	accumy=[accumy;y(:,total+1)];
	f=y(:,total+1);
else
	f=x;
end
 
datag=n;
outm=sizep;

        g_input=f;
 
        if length(outind)==1
            if outind==0
                if size(fun,1) > 1
                        outm=m;
                        [f,J]=evalJ(fun(2,:),[x;f],datag,m,JPI2);
                        extH=[extH ; sparse(m,total*sizep) J(:,n+1:sizep+n)];
                else
                        extH=extH(:,1:size(extH,2)-sizep);
                end
 
           else
                g_input=accumy;
        % all ys, do it
                if size(fun,1) > 1
                [f,J]=evalJ(fun(2,:),[x;accumy],datag,m,JPI2);
                        extH=[extH; J(:,n+1:sizep+(total+1)*sizep)];
                        outm=m;
                else
			f=g_input;
                        outm=(total+1)*sizep;
                        extH=[extH ; speye((total+1)*sizep) ];
                end
          end
        else
        % outputindex is active
        outindy=[];
        for count=1:size(outind,1)
                outindy=[outindy;y(outind(count,2)),outind(count,1)];
                ind=[ind;outind(count,1)*n+outind(count,2)];
        end
        if size(fun,1) > 1
                [f,J]=evalJ(fun(2,:),[ExtraArg;outindy],datag,m,JPI2);
                myJ=sparse(m,(total+1)*sizep);
                myJ(:,ind)=J(:,n+1:n+length(outindy));
                outm=m;
                extH=[extH; myJ];
        else
		f=outindy;
                outm=length(outindy);
                myJ=sparse(length(outindy),(total+1)*sizep);
                myJ(:,ind)=speye(length(outindy));
                extH=[extH; myJ];
        end
                g_input=outindy;
 
        end

 
[nrows,ncols]=size(extH);
extH=[extH(1:nrows-outm,:) sparse(nrows-outm,outm) ; extH(nrows-outm+1:nrows,:) -speye(outm)];
extH=[extH(:,1:n)  extH(:,1+n+sizep:size(extH,2))];
[nrows,ncols]=size(extH);
f=f-yfinal;
grad_y=[zeros(nrows-outm,1);f];
f=0.5*(f'*f);
L=extH(:,n+1:ncols);
w= -L'\grad_y;
g=extH(:,1:n)'*w;
windex=1;

% Do Hessians Now
% Extract all HPIs and compute evalH	

oldf=[zeros((numstates-1)*n,1);ExtraArg];
HessP=sparse(ncols+sizep,ncols+sizep);
ncols=ncols+sizep;
data=[0;numstates;sizep;k(3);k(1);1;consts];

for i=1:total-1
        [val,H]=evalHTens(fun(1,:),[x;oldf;y(:,i+1)],w(windex:windex+sizep-1),dataI,HPI1);
                oldf=[oldf(sizep+1:numstates*sizep);y(:,i+1)];
	if i < numstates
	HessP=HessP+[H([1:n n+1+(numstates-i)*sizep:n+(numstates+1)*sizep],[1:n n+1+(numstates-i)*sizep:n+(numstates+1)*sizep]) sparse(n+(i+1)*sizep,ncols-(n+(i+1)*sizep));
		sparse(ncols-(n+(i+1)*sizep),ncols)];
        else
HessP=HessP+[H(1:n,1:n) sparse(n,(i-numstates)*sizep) H(1:n,n+1:n+(numstates+1)*sizep) sparse(n,ncols-n-(i+1)*sizep);
sparse((i-numstates)*sizep,ncols);
H(n+1:n+(numstates+1)*sizep,1:n) sparse((numstates+1)*sizep,(i-numstates)*sizep) H(n+1:n+(numstates+1)*sizep,n+1:n+(numstates+1)*sizep) sparse((numstates+1)*sizep,ncols-(n+(i+1)*sizep));
                sparse(ncols-(n+(i+1)*sizep),ncols)];

        end

	windex=windex+sizep;
	data(5)=data(5)+k(3);
        data(6)=data(6)+1;
	dataI(5)=dataI(5)+k(3);
        dataI(6)=dataI(6)+1;
end
if total > 0
        data(4)=k(2)-(total-1)*k(3);
        dataI(4)=k(2)-(total-1)*k(3);
        [val,H]=evalHTens(fun(1,:),[x;oldf;y(:,total+1)],w(windex:windex+sizep-1),dataI,HPI1);
        if total < numstates
	HessP=HessP+[H([1:n n+1+(numstates-total)*sizep:n+(numstates+1)*sizep],[1:n n+1+(numstates-total)*sizep:n+(numstates+1)*sizep]) sparse(n+(total+1)*sizep,ncols-(n+(total+1)*sizep));
		sparse(ncols-(n+(total+1)*sizep),ncols)];
        else

HessP=HessP+[H(1:n,1:n) sparse(n,(total-numstates)*sizep) H(1:n,n+1:n+(numstates+1)*sizep) sparse(n,ncols-n-(total+1)*sizep);
sparse((total-numstates)*sizep,ncols);
H(n+1:n+(numstates+1)*sizep,1:n) sparse((numstates+1)*sizep,(total-numstates)*sizep) H(n+1:n+(numstates+1)*sizep,n+1:n+(numstates+1)*sizep) sparse((numstates+1)*sizep,ncols-(n+(total+1)*sizep));
                sparse(ncols-(n+(total+1)*sizep),ncols)];

        end
else
        f=x;
end
 

datag=n;
 
        if length(outind)==1
                if outind==0
                if size(fun,1) > 1
                [val,H]=evalHTens(fun(2,:),[x;g_input],w(windex:windex+outm-1),datag,HPI2);
                HessP=HessP+[H(1:n,1:n) sparse(n,total*sizep) H(1:n,n+1:n+sizep) sparse(n,ncols-(total+1)*sizep-n);
             H(n+1:n+sizep,1:n) sparse(sizep,total*sizep) H(n+1:n+sizep,n+1:n+sizep) sparse(sizep,ncols-(total+1)*sizep-n);
                sparse(ncols-outm-(total+1)*sizep,ncols)];
end
                else
                g_input=accumy;
        % all ys, do it
                if size(fun,1) > 1
                [val,H]=evalHTens(fun(2,:),[x;g_input],w(windex:windex+outm-1),datag,HPI2);
                HessP=HessP+H(1:n+(total+1)*sizep,1:n+(total+1)*sizep);
                end
                end
        else
        % outputindex is active
        outindy=[];
        for count=1:size(outind,1)
                outindy=[outindy;y(outind(count,2)),outind(count,1)];
                ind=[ind;outind(count,1)*n+outind(count,2)];
        end
        if size(fun,1) > 1
                [val,H]=evalHTens(fun(2,:),[x;g_input],w(windex:windex+outm-1),datag,HPI2);
                myJ=sparse(ncols-outm+sizep,ncols-outm+sizep);
                myJ([(1:n)';ind],[(1:n)';ind])=H(1:n+length(outindy),1:n+length(outindy));;
                HessP=HessP+myJ;
        end
        end


%        [f,gg,H]=evalH(fun(2,:),[ExtraArg;f],datag,HPI2);
%	HessP=[HessP sparse(total*n,n);
%	   sparse(n,total*n) H(sizep+1:sizep+n,sizep+1:sizep+n)];
%        extH=[extH sparse(total*n,total*n); HessP(n+1:(total+1)*n,:) extH(1:total*n,n+1:(total+1)*n)'; 
%             HessP(1:n,:) extH(1:total*n,1:n)'];

	HessP=HessP([1:n n+sizep+1:size(HessP,1)] , [1:n  n+sizep+1:size(HessP,2)]);
        HessP=HessP + [sparse(ncols-outm-sizep,ncols-sizep); sparse(outm,ncols-outm-sizep) speye(outm)];
	ncols=ncols-sizep;
        extH=[extH sparse(nrows,nrows); HessP(n+1:ncols,:) extH(1:nrows,n+1:ncols)';
             HessP(1:n,:) extH(1:nrows,1:n)'];


