function [f,extJ]=evalJDI1(fun,fdata,x,PartInfo)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Recover
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
n=length(x);
        ExtraArg=fdata.py0;
        impl=fdata.impl;
        k=fdata.k;
        kind=fdata.kind;
        numstates=fdata.numstates;
        dims=fdata.dims;
        sizep=dims(1);
        m=dims(2);
        consts=fdata.consts;
        outind = fdata.outind;
        yfinal=fdata.yfinal;

 
 
 
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Recovery complete
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
total=ceil(abs((k(2)-k(1))/k(3)));
if ((k(2) < k(1)) & (k(3) > 0))
        k(3)=-k(3);
end

data=[0;numstates;sizep;k(3);k(1);1;consts];

parm=x(1:sizep);
oldf=[zeros((numstates-1)*(n-sizep),1);x(sizep+1:n)];
f=oldf;
 

Identity=-speye(n-sizep);
extJ=sparse(0,n);
if size(fun,1) > 1
        [JPI1,JPI2]=ExtractJPI(PartInfo);
else
        JPI1=PartInfo;
end
 
y=zeros(n-sizep,total+1);
y(:,1)=x(sizep+1:n);
accumy=x(sizep+1:n);
 

for i=1:total-1
	[y(:,i+1),J]=evalJ(fun(1,:),[parm;oldf],data,n-sizep,JPI1);
	data(5)=data(5)+k(3);
        data(6)=data(6)+1;
        oldf=[oldf(n-sizep+1:numstates*(n-sizep));y(:,i+1)];
        if i < numstates
		extJ=[extJ sparse((i-1)*(n-sizep),n-sizep); 
		J(:,1:sizep) J(:,sizep+(numstates-i)*(n-sizep)+1:sizep+numstates*(n-sizep)) Identity];
        else
		extJ=[extJ sparse((i-1)*(n-sizep),(n-sizep)); 
		J(:,1:sizep) sparse(n-sizep,(i-numstates)*(n-sizep)) J(:,sizep+1:sizep+numstates*(n-sizep)) Identity];
        end

	accumy=[accumy;y(:,i+1)];
end

if total > 0
        data(4)=k(2)-(total-1)*k(3);
	[y(:,total+1),J]=evalJ(fun(1,:),[parm;oldf],data,n-sizep,JPI1);
	if total >= numstates
		extJ=[extJ sparse((total-1)*(n-sizep),n-sizep); 
		J(:,1:sizep) sparse(n-sizep,(total-numstates)*(n-sizep)) J(:,sizep+1:sizep+numstates*(n-sizep)) Identity];
	else
		extJ=[extJ sparse((total-1)*(n-sizep),n-sizep); 
		J(:,1:sizep) J(:,sizep+(numstates-total)*(n-sizep)+1:sizep+numstates*(n-sizep))  Identity];
	end
	accumy=[accumy;y(:,total+1)];
        f=y(:,total+1);
else
        f=x(sizep+1:n);
 
end

outm=n-sizep;
datag=sizep;

        if lnegth(outind)==1
                if outind==0
	if size(fun,1) > 1
	outm=m;
	[f,J]=evalJ(fun(2,:),[parm;f],datag,m,JPI2);
	extJ=[extJ; J(:,1:sizep) sparse(m,total*(n-sizep)) J(:,sizep+1:n)];
		else
	f=accumy;
	outm=n-sizep;
	extJ=extJ(:,1:size(extJ,2)-(n-sizep));
		end
                else
	if size(fun,1) > 1
        % all ys, do it
	outm=m;
	[f,J]=evalJ(fun(2,:),[parm;accumy],datag,m,JPI2);
	extJ=[extJ; J];
	else
	outm=(total+1)*(n-sizep);
	extJ=[extJ; speye((total+1)*(n-sizep))];
	end
                end
        else
        % outputindex is active
        outindy=[];
        for count=1:size(outind,1)
		outindy=[outindy;y(outind(count,2)),outind(count,2)];
                ind=[ind;(outind(count,1)*n+outind(count,2))];
        end
	if size(fun,1) > 1
	outm=m;
	[f,J]=evalJ(fun(2,:),[parm;outindy],datag,m,JPI2);
        myJ=sparse(m,(total+1)*(n-sizep));
        myJ(:,ind)=J(:,sizep+1:sizep+length(outindy));
        extJ=[extJ; J(:,1:sizep) myJ];
        else
	f=outindy;
	outm=length(outindy)
        myJ=sparse(m,(total+1)*(n-sizep));
        myJ(:,ind)=speye(length(outindy));
        extJ=[extJ; sparse(length(outindy),sizep) myJ];

	end
	end

f=f-yfinal;

