function [f,extJ,ns,J]=evalJgen(fun,fdata,x,PartInfo)


k=fdata(1);
for i=1:k
	implicit(i)=fdata(2*i);
	outdim(i)=fdata(2*i+1);
end 

n=length(x);
index=1;
m=n;
Identity=-speye(m);
extJ=sparse(0,m);
f=x;
inputpt=x;
index=1;
for i=1:k
	JPI = PartInfo{i};
	if (implicit(i)==0)
		[f,J]=evalJ(fun(i,:),inputpt,0,outdim(i),JPI);
		inputpt=[inputpt;f];
		if (i == k)
			extJ=[extJ; J];
		else
			extJ=[extJ sparse((i-1)*m,m);
                      		J Identity];
		end
	else
		f=funcvalJ(fun(i,:),inputpt,outdim(i),0);
		inputpt=[inputpt;f];
		[f,J]=evalJ(fun(i,:),inputpt,1,outdim(i),JPI);
		extJ=[extJ sparse((i-1)*m,m);
                      		J];
	end
end
if nargout == 3
	rhs=[zeros((k-1)*m,1);-f];
	ns=extJ\rhs;
	ns=ns(1:n);
end

if nargout == 4
        B=extJ((k-1)*m+1:k*m,1:m);
        A=extJ(1:(k-1)*m,1:m);
        L=extJ(1:(k-1)*m,m+1:k*m);
        M=extJ((k-1)*m+1:k*m,m+1:k*m);
        J=B-M*(L\A);
end
