function f=funcvalJExt(class,fun,x,fdata)
%
%funcvalJExt
%
%       compute the function value.
%
%       f=funcvalJExt(class,fun,x)
%
%       Please refer to ADMIT-2 users manual for complete reference.
%
%       ALSO SEE configureExtfun, evalHExt, ExtJV, ExtWJ, ExtHV, ExtVHV
%
%
%       ******************************************************************
%       *              ADMIT-2 Project   1996-97                         *
%       *              Copyright (c) 1996 Cornell University.            *
%       ******************************************************************

n=length(x);
 
% Initialize
 
if nargin < 4 fdata=[]; end

% Make the function data
if isempty(fdata) [fun,fdata]=MakeExtFdata(class,fun,n); end
 

if (class=='GI')
        if fdata.kind==1
        f=funcvalJDI1(fun,x,fdata);
        elseif fdata.kind==2
        f=funcvalJDI2(fun,x,fdata);
        else
        f=funcvalJDI3(fun,x,fdata);
        end
end
if class=='GC'
	if size(fun,1)==1
        f=funcvalJCF(fun,x,fdata);
	else
        f=funcvalJGC(fun,x,fdata);
	end	
end
if class=='GP'
	if size(fun,1)==1
	f=funcvalJPS(fun,x,fdata);
	else
	f=funcvalJGP(fun,x,fdata);
	end
end
if class=='GF'
	f=funcvalJgen(fun,x,fdata);
end
