% ADMAT (Automatic Differentiation and Matlab Interface Toolbox)
%       
%	fun			- setting up a 'fun' for AD.
%
%	evalJ			- evaluates the sparse Jacobian
%	evalH			- evaluates the sparse Hessian and gradient
%
%	ADfun			- overloaded function class for seamless derivative computation
%
%       evalJdens		- evaluate the dense Jacobian
%       evalHdens		- evaluate the dense Hessian
%
% Other drivers
%
%	forwprod		- compute J*V
%	revprod			- compute J^T*W
%	jacsp			- compute the sparsity pattern of the Jacobian matrix	
%	HtimesV			- Compute H*V
%	WHtimesV		- Compute W^TH*V
%	VHtimesV		- Compute V^TH*V
%	hesssp			- compute the sparsity pattern of the Hessian matrix	
%
% MISC
%       cleanup                 - cleanup the toolbox
