function JV= readtape(x,V)
global tape
global tapecounter
global globp
for i=2:tapecounter-1
[m,n]=size(tape(i).val);
if ((m > 1) &(n> 1))
	tape(i).V=zeros([m n globp]);
else
	tape(i).V=zeros(length(tape(i).val), globp);
end
end
tape(1).V=V;
for i=2:tapecounter-1
switch tape(i).op
case 'subsref',	
	tansubsref(i);
case 'subsindex',	
	tansubsindex(i);
case 'subsasgn',	
	tansubsasgn(i);
case 'assign',	
	tanassign(i);
case 'minusvec',	
	tanminusvec(i);
case 'timesvec',	
	tantimesvec(i);
case 'plusvec',	
	tanplusvec(i);
case 'plus',	
	tanplus(i);
case 'minus',	
	tanminus(i);
case 'rem',	
	tanrem(i);
case 'abs',	
	tanabs(i);
case 'times',	
	tantimes(i);
case 'mtimes',	
	tanmtimes(i);
case 'ctranspose',	
	tanctranspose(i);
case 'transpose',	
	tantranspose(i);
case 'sqrt',	
	tansqrt(i);
case 'mldivide',	
	tanmldivide(i);
case 'mrdivide',	
	tanmrdivide(i);
case 'rdivide',	
	tanrdivide(i);
case 'ldivide',	
	tanldivide(i);
case 'power',	
	tanpower(i);
case 'mpower',	
	tanmpower(i);
case 'prod',	
	tanprod(i);
case 'sum',	
	tansum(i);
case 'uminus',	
	tanuminus(i);
case 'norm',	
	tannorm(i);
case 'max',	
	tanmax(i);
case 'min',	
	tanmin(i);
case 'log',	
	tanlog(i);
case 'log2',	
	tanlog2(i);
case 'log10',	
	tanlog10(i);
case 'exp',	
	tanexp(i);
case 'horzcat',	
	tanhorzcat(i);
case 'vertcat',	
	tanvertcat(i);
case 'cos',	
	tancos(i);
case 'cosh',	
	tancosh(i);
case 'acos',	
	tanacos(i);
case 'acosh',	
	tanacosh(i);
case 'sin',	
	tansin(i);
case 'sinh',	
	tansinh(i);
case 'asin',	
	tanasin(i);
case 'asinh',	
	tanasinh(i);
case 'tan',	
	tantan(i);
case 'tanh',	
	tantanh(i);
case 'atan',	
	tanatan(i);
case 'atanh',	
	tanatanh(i);
case 'sec',	
	tansec(i);
case 'sech',	
	tansech(i);
case 'asec',	
	tanasec(i);
case 'asech',	
	tanasech(i);
case 'cot',
        tancot(i);
case 'coth',
        tancoth(i);
case 'acot',
        tanacot(i);
case 'acoth',
        tanacoth(i);
case 'csc',
        tancsc(i);
case 'coth',
        tancsch(i);
case 'acsc',
        tanacsc(i);
case 'acsch',
        tanacsch(i);
otherwise,
end
end
