function WJ= readtape(W)
global tape
global tapecounter

for i=1:(tapecounter-2)
[m,n]=size(tape(i).val);
if ((m > 1) & (n> 1))
	if issparse(tape(i).val) 
	tape(i).W=sparse(m,n);
	else
	tape(i).W=zeros([m n]);
	end
else
	tape(i).W=zeros(length(tape(i).val),1);
end
end

tape(tapecounter-1).W=W;

for i=tapecounter-1:-1:1
switch tape(i).op
case 'sparse',	
%	adjSsparse(i);
case 'reshape',	
	adjSreshape(i);
case 'repmat',	
	adjSrepmat(i);
case 'lul',	
	adjSlul(i);
case 'luu',	
	adjSluu(i);
case 'spdiags',	
	adjSspdiags(i);
case 'triu',	
	adjStriu(i);
case 'tril',	
	adjStril(i);
case 'flipud',	
	adjSflipud(i);
case 'fliplr',	
	adjSfliplr(i);
case 'subsref',	
	adjSsubsref(i);
case 'subsindex',	
	adjSsubsindex(i);
case 'subsasgn',	
	adjSsubsasgn(i);
case 'assign',	
	adjSassign(i);
case 'minusvec',	
	adjSminusvec(i);
case 'timesvec',	
	adjStimesvec(i);
case 'plusvec',	
	adjSplusvec(i);
case 'plus',	
	adjSplus(i);
case 'minus',	
	adjSminus(i);
case 'rem',	
	adjSrem(i);
case 'abs',	
	adjSabs(i);
case 'times',	
	adjStimes(i);
case 'mtimes',	
	adjSmtimes(i);
case 'ctranspose',	
	adjSctranspose(i);
case 'transpose',	
	adjStranspose(i);
case 'sqrt',	
	adjSsqrt(i);
case 'mldivide',	
	adjSmldivide(i);
case 'mrdivide',	
	adjSmrdivide(i);
case 'rdivide',	
	adjSrdivide(i);
case 'ldivide',	
	adjSldivide(i);
case 'power',	
	adjSpower(i);
case 'mpower',	
	adjSmpower(i);
case 'prod',	
	adjSprod(i);
case 'sum',	
	adjSsum(i);
case 'uminus',	
	adjSuminus(i);
case 'norm',	
	adjSnorm(i);
case 'max',	
	adjSmax(i);
case 'min',	
	adjSmin(i);
case 'log',	
	adjSlog(i);
case 'log2',	
	adjSlog2(i);
case 'log10',	
	adjSlog10(i);
case 'exp',	
	adjSexp(i);
case 'horzcat',	
	adjShorzcat(i);
case 'vertcat',	
	adjSvertcat(i);
case 'cos',	
	adjScos(i);
case 'cosh',	
	adjScosh(i);
case 'acos',	
	adjSacos(i);
case 'acosh',	
	adjSacosh(i);
case 'sin',	
	adjSsin(i);
case 'sinh',	
	adjSsinh(i);
case 'asin',	
	adjSasin(i);
case 'asinh',	
	adjSasinh(i);
case 'tan',	
	adjStan(i);
case 'tanh',	
	adjStanh(i);
case 'atan',	
	adjSatan(i);
case 'atanh',	
	adjSatanh(i);
case 'sec',	
	adjSsec(i);
case 'sech',	
	adjSsech(i);
case 'asec',	
	adjSasec(i);
case 'asech',	
	adjSasech(i);
case 'cot',
        adjScot(i);
case 'coth',
        adjScoth(i);
case 'acot',
        adjSacot(i);
case 'acoth',
        adjSacoth(i);
case 'csc',
        adjScsc(i);
case 'coth',
        adjScsch(i);
case 'acsc',
        adjSacsc(i);
case 'acsch',
        adjSacsch(i);
otherwise,
end
end
WJ=tape(1).W;
