function [s,it,normres]=cg(fun,x,tol,P)

n=length(x);
if nargin < 3 tol =[]; end
if nargin < 4 P =[]; end

if isempty(tol) tol =1e-6; end
if isempty(P)  P =speye(n); end

[f,g]=funcval(fun,x);
k=0;
s=zeros(n,1);
r=-g;
normb=norm(r);
rho=normb;

while (rho > tol*normb) 
	z=P\r;
	k=k+1;
	if k==1
		p=z;
	else
		beta=r'*z/(rprev'*zprev);
		p=z+beta.*p;
	end
	temp=HtimesV(fun,x,p);
	alpha=r'*z/(p'*temp);
	s=s+alpha.*p;
	zprev=z;
	rprev=r;
	r=r-alpha.*temp;
	rho=norm(r);
end

it=;
normres=rho;
	
