	if (nrhs <= 3)
		mexErrMsgTxt("At Least 3 Input Arguments Required");
	if (nrhs > 6)
		mexErrMsgTxt("Takes <=6 Input Arguments");
	funtag=(int)*mxGetPr(prhs[1]);
	 n = mxGetM(prhs[3]);
	p = mxGetN(prhs[3]);
	if (nrhs <= 4)
		m = n;
	else
		m = (int)*mxGetPr(prhs[4]);

	if (nlhs > 2)
		mexErrMsgTxt("forwprod takes <= 2 Output Argument");
	if (nrhs==6)
	{
		newm=mxGetM(prhs[5]);
		newn= mxGetN(prhs[5]);      
	       ExtraArg=new double[newm*newn];
		for(k=0;k<newn;k++)
			for (j=0;j<newm;j++)
			ExtraArg[k*newm+j]=*(mxGetPr(prhs[5])+j+newm*k);
	 }

	double* px;
        double* py=new double[m];
	px=mxGetPr(prhs[2]);
	trace_proc(funtag,px,py,m,n,ExtraArg,newm,newn);
        plhs[1] = mxCreateDoubleMatrix(m, p, mxREAL);
	double** v=myalloc(n,p);
	double** out= myalloc(m,p);

	for (j=0;j<n;j++)
                for(k=0;k<p;k++)
                        v[j][k]=*(mxGetPr(prhs[3])+j+n*k);

        plhs[0] = mxCreateDoubleMatrix(m, 1, mxREAL);
	fov_forward(funtag,m,n,p,mxGetPr(prhs[2]),v,mxGetPr(plhs[0]),out);

	for (j=0;j<m;j++)
		for(k=0;k<p;k++)
			*(mxGetPr(plhs[1])+j+m*k)=out[j][k];
	free((char *)py);	
	free((char *) *v);
	free((char *) v);
	free((char *) *out);
	free((char *) out); 
