/*
   ----------------------------------------------------------------------------
   Author  : Uwe Geitner
   Hardware: IBM-compatible PC 386/40
   Software: g++-GNU-Compiler (v2.4) under Linux
   Date    : 18/07/95
   Content : - Definition of struct MatLab_output
   ----------------------------------------------------------------------------
*/


#ifndef _MATLAB_H
#define _MATLAB_H


struct MatLab_output
{
  unsigned int size_array_elem ;
  unsigned int size_array_row ;
  int*   elem_cnt ;
  int*   row_indices ;

  friend  MatLab_output* alloc4MatLab(unsigned int, unsigned int) ;
  friend  void           destrMatLab(MatLab_output*) ;
} ;


#endif


