function [s,val]=Dogleg(sc,val_sc,st,M,gs)
%
%  starting from sc following dogleg path sc->st
%   min g's + 1/2 s'Hs
%

d=st-sc;
gc =M*sc+gs;

dTMd= d'*M*d;
gTd = gc'*d;
alpha_star=0;

if (gTd <0)
    alpha_star = -gTd/dTMd;
end;

if (gTd <0 & dTMd <0) alpha_star=1; end;

alpha_star = min(1,alpha_star);

s=sc+alpha_star*d;
val = val_sc + alpha_star*gTd+0.5*alpha_star^2*dTMd;

if( val > 0) disp('In dogleg'); val=val, keyboard, end;
