function [delta]=UpdateDelta(rho_f, rho_c,delta,ss,gamma,deltaL,deltaU)
%
%       determine the trust region size for the next iteration:
%           Scheme from Conn etc
%
eta = 0.75; mu = 0.25; gamma0 = 0.0625; gamma1 = 0.5; gamma2=2;

gammaK =1;

if ( rho_f <0 )
     gammaK = gamma0;
     delta = min(delta*gammaK,deltaU);
else
   if ( rho_f <= mu )
      gammaK = max(gamma0,gamma1*norm(ss)/delta);
      delta = min(delta*gammaK,deltaU);
   else
      if ( rho_f >= eta )
           if ( rho_c >= eta )
                gammaK = max(1,gamma2*norm(ss)/delta);
           else
                if rho_c  <= mu
                   gammaK = max(gamma1, gamma)
                end
           end
           delta = min(delta*gammaK,deltaU);
           delta = max(1,delta);
      end;
   end;
end;

return

