  function[s,posdef,Zsize,v1] = dirn2(M,D,p,grad,delta,tsub,opt);
%
% DETERMINE SEARCH DIRECTION
        n = length(grad); tsize = 0;
        TOT11 = flops;
        [v1,posdef] = newtorneg(M,p,grad);
        if posdef == 1
           v1 = v1/norm(v1);
        else
           if opt == 1
              v1 = v1/norm(v1);
              v1eig = v1'*M*v1
           elseif opt == 2
              v1 = (abs(diag(D))).*v1; 
              v1 = v1/norm(v1);
           elseif opt == 3
               w = full(abs(diag(D)));
               w = ones(n,1)./w;
               v1 = w.*v1;
              v1 = v1/norm(v1);
           end
         end

        TOT12 = flops - TOT11;
        if (posdef == 1 | tsub  < 4)
          if (posdef < 1 & tsub < 3)
             v2 = D*sign(grad);
             v2 = v2/norm(v2);
             v2 = v2 - v1*(v1'*v2);
             v2 = v2/norm(v2);
             Z(:,1) = v1; Z(:,2) = v2;
             Zsize = 2
          elseif (posdef < 1 & tsub == 3)
             v2 = D*sign(grad);
             v2 = v2/norm(v2);
             v2 = v2 - v1*(v1'*v2);
             v2 = v2/norm(v2);
             Z(:,1) = v1; Z(:,2) = v2;
             v3 = grad/norm(grad);
             v3 = v3 - Z*(Z'*v3);
             if norm(v3) > 0
               v3 = v3/norm(v3);
               Z(:,3) = v3;
               Zsize = 3
             else
               Zsize = 2
             end
          else
          TOT11 = flops;
          Z = zeros(n,2);
          Z = [v1,grad]; 
          v1 = v1/norm(v1); v2 = grad/norm(grad);
          Z(:,1) = v1; v2 = v2 - v1*(v1'*v2);
          nrmv2 = norm(v2);
          if nrmv2 > 0
             v2 = v2/nrmv2; Z(:,2) = v2; Zsize = 2;
          else
             Zsize = 1;
          end
          end
         else
          Zsize = min(tsub,n); reorth = 1;
          tsize = tsub -1;
          Zsize = tsize;
%        [Z,alpha,beta] = lanczos(M,grad,tsize,reorth);

         ggrad=D*sign(grad);
         [Z,alpha,beta] = lanczos2(M,ggrad,tsize);
         BETA = beta;
         w = Z'*v1; v1 = v1 - Z*w;
         if (norm(v1) > eps) & (opt < 4)
             v1 = v1/norm(v1);
             Z = [Z,v1]; 
         end
         [dum,Zsize] = size(Z);
         end
        TSIZE = tsize
        if tsize > 0
           MM = diag(alpha) + diag(beta(1:tsize-1),-1) + diag(beta(1:tsize-1),1);
           MMeig = min(eig(MM))
           if (norm(v1) > eps) & (opt < 4)
              w = M*v1; ww = Z'*w;
              MM = [MM ww(1:Zsize-1); ww(1:Zsize-1)' ww(Zsize,1)];
           end
           MMMeig = min(eig(MM))
           DIM = size(MM)
        else
           MM = full(Z'*M*Z);
        end 
        rhs=full(Z'*grad);
        [ss,qpval,po,key,fcnt,lambda] = trust(rhs,MM,delta);
        ss = Z*ss;

        norms = norm(ss); 
        s = abs(diag(D)).*ss;
ttt = full(s)./(full(diag(D)).^2);
mxttt = max(abs(ttt));
        TOT13 = flops - TOT11;
        if (po == 1) & (norms > 1.2*delta)
           PO = po
           NORMS = norms
           DELTA = delta
        end
        if (po == 0) & ((norms<.8*delta)|(norms >1.2*delta))
           PO = po
           NORMS = norms
           DELTA = delta
           keyboard
        end
