function [ss,val,posdef,rho_c]=SolveFull(x,l,u,M,sqrtv,p,sgr,delta,tsize,theta);
%
%  two-dimensional
%
n = length(sqrtv);

[sc,val_sc,flag_sc]=Truncate(-sgr,sqrtv,sgr,M,l,u,x,delta,theta);
[ss,val,posdef]=trust(sgr,full(M),delta);

[st,val,flag]=Truncate(ss,sqrtv,sgr,M,l,u,x,delta,theta);

% relfection path
val_r =1;
if flag >0
   A=sparse([-speye(n);speye(n)]);
   b=[(theta*(l-x))./sqrtv;(theta*(u-x))./sqrtv];
   [sr,val_r]=Reflect(flag,st,sgr,M,A,b,delta,theta);
end;

%dogleg path
[sd,val_d]=Dogleg(st,val,sc,M,sgr);

if val_r < val_d
   val=val_r;
   ss = sr;
else
   val = val_d;
   ss = sd;
end;

rho_c = val/val_sc;
