      format long e
clear;
      tol=0.5*10^(-12);
      itbound=100;
tsub=1;

      func= 'genroseF';
      grad= 'genroseG';
      hess= 'genroseH';
      Ugenrose


diary out

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub);
Ugenrose = it;
Ugenrose_ng = gcount
Ugenrose_cval = val
Ugenrose_val = eval( [func,'(soln)'] )

      genrose

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
genrose = it;
genrose_ng = gcount
genrose_cval = val
genrose_val = eval( [func,'(soln)'] )

clear xstart u l;


      func= 'chainroseF';
      grad= 'chainroseG';
      hess= 'chainroseH';
      Uchainrose

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
Uchainrose = it;
Uchainrose_ng = gcount
Uchainrose_cval = val
Uchainrose_val = eval( [func,'(soln)'] )
      
      chainrose

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
chainrose = it;
chainrose_ng = gcount
chainrose_cval = val
chainrose_val = eval( [func,'(soln)'] )

clear xstart u l;

      Udegenrose

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
Udegenrose = it;
Udegenrose_ng = gcount
Udegenrose_cval = val
Udegenrose_val = eval( [func,'(soln)'] )

      degenrose

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
degenrose = it;
degenrose_ng = gcount
degenrose_cval = val
degenrose_val = eval( [func,'(soln)'] )

clear xstart u l;
      
      func= 'gensingF';
      grad= 'gensingG';
      hess= 'gensingH';
      Ugensing

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
Ugensing = it;
Ugensing_ng = gcount
Ugensing_cval = val
Ugensing_val = eval( [func,'(soln)'] )

      gensing

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
gensing = it;
gensing_ng = gcount
gensing_cval = val
gensing_val = eval( [func,'(soln)'] )

clear xstart u l;
      
      
      func= 'chainsingF';
      grad= 'chainsingG';
      hess= 'chainsingH';
      Uchainsing

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
Uchainsing = it;
Uchainsing_ng = gcount
Uchainsing_cval = val
Uchainsing_val = eval( [func,'(soln)'] )

     chainsing

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
chainsing = it;
chainsing_ng = gcount
chainsing_cval = val
chainsing_val = eval( [func,'(soln)'] )

clear xstart u l;
      
      Udegensing

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
Udegensing = it;
Udegensing_ng = gcount
Udegensing_cval = val
Udegensing_val = eval( [func,'(soln)'] )

      degensing

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
degensing = it;
degensing_ng = gcount
degensing_cval = val
degensing_val = eval( [func,'(soln)'] )

clear xstart u l;
      
      func= 'genwoodF';
      grad= 'genwoodG';
      hess= 'genwoodH';
      Ugenwood

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
Ugenwood = it;
Ugenwood_ng = gcount
Ugenwood_cval = val
Ugenwood_val = eval( [func,'(soln)'] )

      genwood

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
genwood = it;
genwood_ng = gcount
genwood_cval = val
genwood_val = eval( [func,'(soln)'] )

clear xstart u l;
      
      func= 'chainwoodF';
      grad= 'chainwoodG';
      hess= 'chainwoodH';
      Uchainwood

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
Uchainwood = it;
Uchainwood_ng = gcount
Uchainwood_cval = val
Uchainwood_val = eval( [func,'(soln)'] )

     chainwood

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
chainwood = it;
chainwood_ng = gcount
chainwood_cval = val
chainwood_val = eval( [func,'(soln)'] )

clear xstart u l;
      
      func= 'hosc45F';
      grad= 'hosc45G';
      hess= 'hosc45H';
      Uhosc45

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
Uhosc45 = it;
Uhosc45_ng = gcount
Uhosc45_cval = val
Uhosc45_val = eval( [func,'(soln)'] )
 
     hosc45

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
hosc45 = it;
hosc45_ng = gcount
hosc45_cval = val
hosc45_val = eval( [func,'(soln)'] )

clear xstart u l;
      
      func= 'broyden1aF';
      grad= 'broyden1aG';
      hess= 'broyden1aH';
      Ubroyden1a

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
Ubroyden1a = it;
Ubroyden1a_ng = gcount
Ubroyden1a_cval = val
Ubroyden1a_val = eval( [func,'(soln)'] )

      broyden1a

      
[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
broyden1a = it;
broyden1a_ng = gcount
broyden1a_cval = val
broyden1a_val = eval( [func,'(soln)'] )

clear xstart u l;

      func= 'broyden1bF';
      grad= 'broyden1bG';
      hess= 'broyden1bH';
      Ubroyden1b

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
Ubroyden1b = it;
Ubroyden1b_ng = gcount
Ubroyden1b_cval = val
Ubroyden1b_val = eval( [func,'(soln)'] )

      broyden1b

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
broyden1b = it;
broyden1b_ng = gcount
broyden1b_cval = val
broyden1b_val = eval( [func,'(soln)'] )

clear xstart u l;

      func= 'broyden2aF';
      grad= 'broyden2aG';
      hess= 'broyden2aHs';
      Ubroyden2a

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
Ubroyden2a = it;
Ubroyden2a_ng = gcount
Ubroyden2a_cval = val
Ubroyden2a_val = eval( [func,'(soln)'] )

     broyden2a

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
broyden2a = it;
broyden2a_ng = gcount
broyden2a_cval = val
broyden2a_val = eval( [func,'(soln)'] )

clear xstart u l;

      func= 'broyden2bF';
      grad= 'broyden2bG';
      hess= 'broyden2bHs';
      Ubroyden2b

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
Ubroyden2b = it;
Ubroyden2b_ng = gcount
Ubroyden2b_cval = val
Ubroyden2b_val = eval( [func,'(soln)'] )

     broyden2b

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
broyden2b = it;
broyden2b_ng = gcount
broyden2b_cval = val
broyden2b_val = eval( [func,'(soln)'] )

clear xstart u l;

      func= 'tointbroyF';
      grad= 'tointbroyG';
      hess= 'tointbroyH';
      Utointbroy

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
Utointbroy= it;
Utointbroy_ng= gcount
Utointbroy_cval = val
Utointbroy_val = eval( [func,'(soln)'] )

     tointbroy

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
tointbroy= it;
tointbroy_ng= gcount
tointbroy_cval = val
tointbroy_val = eval( [func,'(soln)'] )

clear xstart u l;

      func= 'trigF';
      grad= 'trigG';
      hess= 'trigH';
      Utrig

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
Utrig= it;
Utrig_ng= gcount
Utrig_cval= val
Utrig_val = eval( [func,'(soln)'] )

     trig

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
trig= it;
trig_ng= gcount
trig_cval= val
trig_val = eval( [func,'(soln)'] )

clear xstart u l;

      func= 'tointtrigF';
      grad= 'tointtrigG';
      hess= 'tointtrigHs';
      Utointtrig

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
Utointtrig= it;
Utointtrig_ng= gcount
Utointtrig_cval= val
Utointtrig_val = eval( [func,'(soln)'] )

      tointtrig

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
tointtrig= it;
tointtrig_ng= gcount
tointtrig_cval= val
tointtrig_val = eval( [func,'(soln)'] )

clear xstart u l;

      func= 'cragglevyF';
      grad= 'cragglevyG';
      hess= 'cragglevyH';
      Ucragglevy

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
Ucragglevy= it;
Ucragglevy_ng= gcount
Ucragglevy_cval= val
Ucragglevy_val = eval( [func,'(soln)'] )

     cragglevy

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
cragglevy= it;
cragglevy_ng= gcount
cragglevy_cval= val;
cragglevy_val = eval( [func,'(soln)'] )

clear xstart u l;

      func= 'penaltyF';
      grad= 'penaltyG';
      hess= 'penaltyH';
      Upenalty

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
Upenalty= it;
Upenalty_ng= gcount
Upenalty_cval= val
Upenalty_val = eval( [func,'(soln)'] )

     penalty

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
penalty= it;
penalty_ng= gcount
penalty_cval= val
penalty_val = eval( [func,'(soln)'] )

clear xstart u l;

      func= 'augmlagnF';
      grad= 'augmlagnG';
      hess= 'augmlagnH';
      Uaugmlagn

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
Uaugmlagn = it;
Uaugmlagn_ng= gcount
Uaugmlagn_cval= val
Uaugmlagn_val = eval( [func,'(soln)'] )

     augmlagn

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
augmlagn = it;
augmlagn_ng= gcount
augmlagn_cval= val
augmlagn_val = eval( [func,'(soln)'] )

clear xstart u l;

      func= 'brown1F';
      grad= 'brown1G';
      hess= 'brown1H';
      Ubrown1

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
Ubrown1 = it;
Ubrown1_ng= gcount
Ubrown1_cval= val
Ubrown1_val = eval( [func,'(soln)'] )

     brown1

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
brown1 = it;
brown1_ng= gcount
brown1_cval= val
brown1_val = eval( [func,'(soln)'] )

clear xstart u l;

      func= 'brown3F';
      grad= 'brown3G';
      hess= 'brown3H';
      Ubrown3

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
Ubrown3 = it;
Ubrown3_ng= gcount
Ubrown3_cval= val
Ubrown3_val = eval( [func,'(soln)'] )

      brown3

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
brown3 = it;
brown3_ng= gcount
brown3_cval= val
brown3_val = eval( [func,'(soln)'] )

clear xstart u l;

%     Hessian of bvp is singular at the solution
      func= 'bvpF';
      grad= 'bvpG';
      hess= 'bvpH';
      Ubvp

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
Ubvp = it;
Ubvp_ng= gcount
Ubvp_cval= val
Ubvp_val = eval( [func,'(soln)'] )

     bvp

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
bvp = it;
bvp_ng= gcount
bvp_cval= val
bvp_val = eval( [func,'(soln)'] )

      func= 'varF'
      grad= 'varG'
      hess= 'varH'
      Uvar

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
Uvar = it;
Uvar_ng= gcount
Uvar_cval= val
Uvar_val = eval( [func,'(soln)'] )

     var

[it,gcount,val,x]= main(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
var= it;
var_ng= gcount
var_cval= val
var_val = eval( [func,'(soln)'] )
diary off

