      format long e
clear;

      tol=0.5*10^(-8);
      itbound=600;
      unitflag=0;
tsub=1;
n=1000
x=zeros(n,1);

diary large

      func= 'genroseF';
      grad= 'genroseG';
      hess= 'genroseHs';
      [xstart,l,u]=Ugenrose_large(n);


[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
Ugenrose = it
Ugenrose_nf = fcount
Ugenrose_cval = val

      [xstart,l,u]=genrose_large(n);

[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
genrose = it
genrose_nf = fcount
genrose_cval = val

clear xstart u l;


      func= 'gensingF';
      grad= 'gensingG';
      hess= 'gensingHs';
      [xstart,l,u]=Ugensing_large(n);

[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
Ugensing = it
Ugensing_nf = fcount
Ugensing_cval = val

      [xstart,l,u]=gensing_large(n);

[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
gensing = it
gensing_nf = fcount
gensing_cval = val

clear xstart u l;
      
      
      func= 'chainsingF';
      grad= 'chainsingG';
      hess= 'chainsingHs';
      [xstart,l,u]=Uchainsing_large(n);


[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
Uchainsing = it
Uchainsing_nf = fcount
Uchainsing_cval = val

      [xstart,l,u]=chainsing_large(n);

[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
chainsing = it
chainsing_nf = fcount
chainsing_cval = val

clear xstart u l;
      
      [xstart,l,u]=Udegensing_large(n);

[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
Udegensing = it
Udegensing_nf = fcount
Udegensing_cval = val

      [xstart,l,u]=degensing_large(n);

[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
degensing = it
degensing_nf = fcount
degensing_cval = val

clear xstart u l;
      
      func= 'genwoodF';
      grad= 'genwoodG';
      hess= 'genwoodHs';
%     [xstart,l,u]=Ugenwood_large(n);

%[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
%Ugenwood = it
%Ugenwood_nf = fcount
%Ugenwood_cval = val

      [xstart,l,u]=genwood_large(n);

[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
genwood = it
genwood_nf = fcount
genwood_cval = val

clear xstart u l;
      
      func= 'chainwoodF';
      grad= 'chainwoodG';
      hess= 'chainwoodHs';
%     [xstart,l,u]=Uchainwood_large(n);

%[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
%Uchainwood = it
%Uchainwood_nf = fcount
%Uchainwood_cval = val

     [xstart,l,u]=chainwood_large(n);

[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
chainwood = it
chainwood_nf = fcount
chainwood_cval = val

clear xstart u l;
      
      func= 'broyden1aF';
      grad= 'broyden1aG';
      hess= 'broyden1aHs';
      [xstart,l,u]=Ubroyden1a_large(n);

[it,fcount,val,x]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
Ubroyden1a = it
Ubroyden1a_nf = fcount
Ubroyden1a_cval = val

      [xstart,l,u]=broyden1a_large(n,x);

      
[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
broyden1a = it
broyden1a_nf = fcount
broyden1a_cval = val

clear xstart u l;

      func= 'broyden1bF';
      grad= 'broyden1bG';
      hess= 'broyden1bHs';
      [xstart,l,u]=Ubroyden1b_large(n);

[it,fcount,val,x]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
Ubroyden1b = it
Ubroyden1b_nf = fcount
Ubroyden1b_cval = val

      [xstart,l,u]=broyden1b_large(n,x);

[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
broyden1b = it
broyden1b_nf = fcount
broyden1b_cval = val

clear xstart u l;

      func= 'broyden2aF';
      grad= 'broyden2aG';
      hess= 'broyden2aHs';
      [xstart,l,u]=Ubroyden2a_large(n);

[it,fcount,val,x]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
Ubroyden2a = it
Ubroyden2a_nf = fcount
Ubroyden2a_cval = val

     [xstart,l,u]=broyden2a_large(n,x);

[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
broyden2a = it
broyden2a_nf = fcount
broyden2a_cval = val

clear xstart u l;

      func= 'broyden2bF';
      grad= 'broyden2bG';
      hess= 'broyden2bHs';
      [xstart,l,u]=Ubroyden2b_large(n);

[it,fcount,val,x]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
Ubroyden2b = it
Ubroyden2b_nf = fcount
Ubroyden2b_cval = val

     [xstart,l,u]=broyden2b_large(n,x);

[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
broyden2b = it
broyden2b_nf = fcount
broyden2b_cval = val

clear xstart u l;

      func= 'tointbroyF';
      grad= 'tointbroyG';
      hess= 'tointbroyHs';
      [xstart,l,u]=Utointbroy_large(n);

[it,fcount,val,x]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
Utointbroy= it
Utointbroy_nf= fcount
Utointbroy_cval = val

     [xstart,l,u]=tointbroy_large(n,x);

[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
tointbroy= it
tointbroy_nf= fcount
tointbroy_cval = val

clear xstart u l;

 clear xstart u l;

      func= 'cragglevyF';
      grad= 'cragglevyG';
      hess= 'cragglevyHs';
      [xstart,l,u]=Ucragglevy_large(n);

[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
Ucragglevy= it
Ucragglevy_nf= fcount
Ucragglevy_cval= val

     [xstart,l,u]=cragglevy_large(n);

[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
cragglevy= it
cragglevy_nf= fcount
cragglevy_cval= val

clear xstart u l;


      func= 'augmlagnF';
      grad= 'augmlagnG';
      hess= 'augmlagnHs';
      [xstart,l,u]=Uaugmlagn_large(n);

[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
Uaugmlagn = it
Uaugmlagn_nf= fcount
Uaugmlagn_cval= val

     [xstart,l,u]=augmlagn_large(n);

[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
augmlagn = it
augmlagn_nf= fcount
augmlagn_cval= val

clear xstart u l;

     func= 'brown1F';
     grad= 'brown1G';
     hess= 'brown1Hs';
     [xstart,l,u]=Ubrown1_large(n);

[it,fcount,val]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
Ubrown1 = it
Ubrown1_nf= fcount
Ubrown1_cval= val

    [xstart,l,u]=brown1_large(n);

[it,fcount,val]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub); 
brown1 = it
brown1_nf= fcount
brown1_cval= val

clear xstart u l;

      func= 'brown3F';
      grad= 'brown3G';
      hess= 'brown3Hs';
      [xstart,l,u]=Ubrown3_large(n);

[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
Ubrown3 = it
Ubrown3_nf= fcount
Ubrown3_cval= val

      [xstart,l,u]=brown3_large(n);

[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
brown3 = it
brown3_nf= fcount
brown3_cval= val

clear xstart u l;

%     Hsessian of bvp is singular at the solution
      func= 'bvpF';
      grad= 'bvpG';
      hess= 'bvpHs';
      [xstart,l,u]=Ubvp_large(n);

[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
Ubvp = it
Ubvp_nf= fcount
Ubvp_cval= val

     [xstart,l,u]=bvp_large(n);

[it,fcount,val,Tf]= mainCHOL(func,grad,hess,tol,itbound,xstart,u,l,tsub);
bvp = it
bvp_nf= fcount
bvp_cval= val

diary off

