function [f,g,H] = funopt(y,Extra);
%
%  the function evaluation routine for optimization
%  parameter: volatility values at knots of a spline 
%
echo on

global OBSERVED;


if nargout == 1
   fvec=optionJspline(y,Extra);
   fvec = fvec' - OBSERVED;
   f = 0.5*norm(fvec,2)^2;
end

if nargout >1
   [fvec,J]=optionJspline(y,Extra);
   fvec = fvec' - OBSERVED;
   f = 0.5*norm(fvec,2)^2;
   g = J'*fvec;
   if nargout == 3
      H = J'*J;
   end
end;


