function [f,g,H] = funopt2d(y,Extra);
%
%  the function evaluation routine for optimization
%  parameter: volatility values at knots of a spline 
%
echo on

global OBSERVED;

if nargout == 1
   fvec=optionfunspline2d(y,Extra);
   fvec = (fvec' - OBSERVED)./OBSERVED;
   f = 0.5*norm(fvec,2)^2;
end

if nargout >1
   [fvec,J]=optionJspline2dfd(y,Extra);
   fvec = (fvec' - OBSERVED)./OBSERVED;
   f = 0.5*norm(fvec,2)^2;
   m = length(OBSERVED);
   J =  ((ones(m,1)./OBSERVED)*ones(1,size(J,2))).*J; ,
   g = (J'*fvec);
   if nargout == 3
      H = J'*J;
   end
end;
