function [fvec,J] = funspline(y,Extra);
%
%  the function evaluation routine for optimization
%  parameter: volatility values at knots of a spline 
%
echo on

global OBSERVED;

tic;
if nargout == 1
   fvec=optionJspline(y,Extra);
   fvec = fvec' - OBSERVED;
end

if nargout >1
   [fvec,J]=optionJspline(y,Extra);
   fvec = fvec' - OBSERVED;
end;
funtime = toc

