global OBSERVED;

load DATA;

S0=590; r =.06;
q = 0.0262;

figure

T=[.175;.425; .695;.94;1;1.5;2];
K=S0*[.85;.9;.95;1;1.05;1.1;1.15;1.2;1.3;1.4];

valconds ='variational';

pp=csape({K,T},implsig',valconds);
s = linspace(0,2*S0,N)';
t = linspace(0,2,numtimesteps)';

XX =ppual(pp,{s, t});
mesh(t,s,XX);

title('Implied Volatility');

Extra.S0=S0;
Extra.r=r;
Extra.q=q;
Extra.T=TT;
Extra.K=KK;
Extra.numtimesteps=numtimesteps;
Extra.N=N;
Extra.knotT=optKnotT;
Extra.knotS=optKnotS;
Extra.Index= [];
Extra.consts=[];


val = funopt2dnew(optSigma(:),Extra)
figure
mesh(optKnotT,optKnotS,optSigma);
title('Reconstructed Spot Volatility');


