function [val,J]=optionJ(y,Extra,eps)
global Jspline

n=length(y);
if nargin < 3 eps=1e-5; end

S0=Extra.S0;
r=Extra.r;
q=Extra.q;
T=Extra.T;
K=Extra.K;
NUMT=Extra.numtimesteps;
N=Extra.N;
knotS=Extra.knotS;
knotT=Extra.knotT;
I =[]; J = [];
if ~isempty(Extra.Index)
   I=Extra.Index(:,1);
   J=Extra.Index(:,2);
end;
consts=Extra.consts;
count=1;
count2=1;
count3=1;
yval=y;

for j=1:length(knotT)
for i=1:length(knotS)

if (count3 <= length(consts)) & I(count3)==i & J(count3)==j
yval(count)=consts(count3);
count3=count3+1;
else
yval(count)=y(count2);
count2=count2+1;
end

count=count+1;

end
end
sigma=sigmay2d(knotS,knotT,yval,S0,T,NUMT,N);

val=optionblsprice2d(S0,K,r,T,sigma,q,NUMT,N);

if nargout ==2 
m=length(val);
J=zeros(m,length(y));

for i=1:length(y)
z=(optionblsprice2d(S0,K,r,T,sigma+eps*Jspline(:,:,i),q,NUMT,N)-val)./eps;
J(:,i)=z(:);
end
end
