sigma=0.1;

S0=590; r =.06;

Tmax=5;
Tmin=.1;
Nt=50;
Ns=50;
Nsig=20;
T=linspace(Tmin,Tmax,Nt);
K=S0*linspace(.5,1.5,Ns);


Val=blsprice(S0,repmat(K,Nt,1),r,repmat(T',1,Ns),sigma);

mesh(K,T,Val)
xlabel 'Strike price'
ylabel 'Maturity time'
