function sout=mtimes(s1,s2)
global globp;
s1=derivspj(s1);
s2=derivspj(s2);
sout=derivspj(s1.val*s2.val);

if ~isempty(sout.val)
    
    [m1,n1]=size(s1.val);
    [m2,n2]=size(s2.val);
    if ((m1>1)&(n1>1))
        s21=spones(s1.val);
        if (n2==1)
            if iscell(s2.derivspj) s2.derivspj=celltospj(s2.derivspj); end
            sout.derivspj=sparse(length(sout.val),globp);
            for k=1:m1
                sout.derivspj(k,:)=spones(s2.val)'*s1.derivspj{k}+s21(k,:)*s2.derivspj;
            end
        else
            for k=1:m1
                sout.derivspj{k}=spones(s2.val)'*s1.derivspj{k};
            end
            for k=1:m1
                for k2=1:m2
                    sout.derivspj{k}(k2,:)=sout.derivspj{k}(k2,:)+s21(k,:)*s2.derivspj{k2};
                end
            end
            
        end
    elseif ((m2>1)&(n2>1))
        sout.derivspj=s1.derivspj'*s2.val;
    else
        sout.derivspj=sparse(length(sout.val),globp);
        if iscell(s1.derivspj) s1.derivspj=celltospj(s1.derivspj); end
        if iscell(s2.derivspj) s2.derivspj=celltospj(s2.derivspj); end
        if ((length(s1.val)==1) | (length(s2.val)==1))
            for i=1:globp
                p=s1.derivspj(:,i);
                q=s2.derivspj(:,i);
                sout.derivspj(:,i)=p(:)+q(:);
            end
            
        else
            for i=1:globp
                sout.derivspj(:,i)=s2.val'*s1.derivspj(:,i)+s1.val*s2.derivspj(:,i);
            end
        end
    end   
end  
