function sout=mtimes(s1,s2)
global globp;
sout.val=getval(s1)*getval(s2);
if ~isempty(sout.val)
[m1,n1]=size(getval(s1));
[m2,n2]=size(getval(s2));

if (~isa(s1,'deriv'))

if ((m1>1)&(n1>1))
if n2==1
for i=1:globp
        sout.deriv(:,i)=s1*s2.deriv(:,i);
end
else
for i=1:globp
        sout.deriv(:,:,i)=s1*s2.deriv(:,:,i);
end

end
elseif ((m2>1)&(n2>1))
for i=1:globp
        sout.deriv(:,:,i)=s1*s2.deriv(:,:,i);
end
else
if ((length(s1)==1) | (length(s2.val)==1))
if (length(s1)==1)
sout.deriv=s1.*s2.deriv;
else
for i=1:globp
        sout.deriv(:,i)=s1.*s2.deriv(:,i);
end
end
elseif (m1 == 1)
%Inner product
for i=1:globp
        sout.deriv(:,i)=s1*s2.deriv(:,i);
end
else
%outer product
for i=1:globp
        sout.deriv(:,:,i)=s1*s2.deriv(:,i)';
end
end
end


elseif  (~isa(s2,'deriv'))
if ((m1>1)&(n1>1))
if n2==1
for i=1:globp
        sout.deriv(:,:,i)=s1.deriv(:,:,i)*s2;
end
else
for i=1:globp
        sout.deriv(:,:,i)=s1.deriv(:,:,i)*s2;
end

end
elseif ((m2>1)&(n2>1))
for i=1:globp
        sout.deriv(:,i)=s1.deriv(:,i)'*s2;
end
else
if ((length(s1.val)==1) | (length(s2)==1))
if (length(s2)==1)
sout.deriv=s2.*s1.deriv;
else
for i=1:globp
        sout.deriv(:,i)=s2.*s1.deriv(:,i);
end
end

elseif (m1 == 1)
%Inner product
for i=1:globp
        sout.deriv(:,i)=s2'*s1.deriv(:,i);
end
else
%outer product
for i=1:globp
        sout.deriv(:,:,i)=s1.deriv(:,i)*s2;
end
end
end

else
if ((m1>1)&(n1>1))
if n2==1
for i=1:globp
	sout.deriv(:,i)=s1.deriv(:,:,i)*s2.val+s1.val*s2.deriv(:,i);
end
else
for i=1:globp
	sout.deriv(:,:,i)=s1.deriv(:,:,i)*s2.val+s1.val*s2.deriv(:,:,i);
end

end
elseif ((m2>1)&(n2>1))
for i=1:globp
        sout.deriv(:,i)=s1.deriv(:,i)'*s2.val+s1.val*s2.deriv(:,:,i);
end
else
if ((length(s1.val)==1) | (length(s2.val)==1))
for i=1:globp
	p=s2.val.*s1.deriv(:,i);
        q=s1.val.*s2.deriv(:,i);
        sout.deriv(:,i)=p(:)+q(:);
end
elseif (m1 == 1)
%Inner product
for i=1:globp
        sout.deriv(:,i)=s2.val'*s1.deriv(:,i)+s1.val*s2.deriv(:,i);
end
else
%outer product
for i=1:globp
        sout.deriv(:,:,i)=s1.deriv(:,i)*s2.val+s1.val*s2.deriv(:,i)';
end
end
end 


end
 
sout=class(sout,'deriv'); 
else
sout=[];
end 
