
Stock=100;
Strike=[90;110];
Maturity=[1;2];
Vol=0.3;
Interestrate=0.05;
Dividend=0.02;

callprice=myblsprice(Stock,Strike,Interestrate,Maturity,Vol,Dividend)

d_Stock=deriv(Stock,1);

d_callprice=myblsprice(d_Stock,Strike,Interestrate,Maturity,Vol,Dividend);

sensitivity= getydot(d_callprice)

answer=questdlg('Continue with this demo to see a comparison plot between FD and AD?','Continue','OK','Cancel','OK');
if isequal(answer,'Cancel') return; end

delta   = [];
delta2  = [];

i = 1;

for s0=0.8:0.02:1.2
   
   delta(i) = getydot(myblsprice(deriv(s0,1),1,0.1,1,0.1,0));
   i=i+1;
   
end


i = 1;
eps=0.025;
for s0 = 0.8:0.02:1.2
   
    delta2(i) = myblsprice(s0+eps,1,0.1,1,0.1,0)-myblsprice(s0,1,0.1,1,0.1,0);
    delta2(i) = delta2(i)/eps;
    i = i+1;
   
end

subplot(2,1,1)
plot(0.8:0.02:1.2,delta,'r');
hold on;
plot(0.8:0.02:1.2,delta2,'b');
hold off
legend('Computed by AD', 'Computed by FD',2);
xlabel 'Price of underlying'
ylabel 'Delta'
subplot(2,1,2)
plot(abs(delta-delta2));
xlabel 'Price of underlying'
ylabel 'Absolute error of difference'

