function F = brus_fun(x,Extra)

prm=Extra.prm;
h=Extra.h;
dim=Extra.dim;
F=x;
p  = prm(1)/sqrt(prm(3));
f2 = -prm(1)^2/prm(5)*(x(1)^2*x(2)-prm(6)*x(1));
f1 = -prm(1)^2/prm(4)*((prm(6)+1)*x(1)-x(1)^2*x(2));
f1 = f1+prm(1)^2/prm(4)*(prm(2)/(1+exp(p))*(exp(p*h)+exp(p-p*h))); 

F(1) = prm(2)-2*x(1)+5.0/6*h*h*f1; 
F(2) = prm(6)/prm(2)-2*x(2)+5.0/6*h*h*f2; 
F(3) = x(1)+h*h/12.0*f1;
F(4) = x(2)+h*h/12.0*f2;

for i=1:dim/2-2
  f2 = -prm(1)^2/prm(5)*(x(2*i+1)^2*x(2*i+2)-prm(6)*x(2*i+1)); 
  f1 = -prm(1)^2/prm(4)*(prm(6)+1)*x(2*i+1); 
  f1 = f1+prm(1)^2/prm(4)*x(2*i+1)^2*x(2*i+2); 
  f1 = f1+prm(1)^2/prm(4)*(prm(2)/(1+exp(p)))*(exp(p*(i+1)*h)+exp(p-p*(i+1)*h));
  F(2*i-1) = F(2*i-1)+x(2*i+1)+h*h/12.0*f1;
  F(2*i) = F(2*i)+x(2*i+2)+h*h/12.0*f2; 
  F(2*i+1) = F(2*i+1)-2*x(2*i+1)+5.0/6*h*h*f1; 
  F(2*i+2) = F(2*i+2)-2*x(2*i+2)+5.0/6*h*h*f2; 
  F(2*i+3) = F(2*i+3)+x(2*i+1)+h*h/12.0*f1; 
  F(2*i+4) = F(2*i+4)+x(2*i+2)+h*h/12.0*f2;
end
 
f2 = -prm(1)^2/prm(5)*(x(dim-1)^2*x(dim)-prm(6)*x(dim-1));  
f1 = -prm(1)^2/prm(4)*((prm(6)+1)*x(dim-1)-x(dim-1)^2*x(dim)); 
f1 = f1+prm(1)^2/prm(4)*(prm(2)/(1+exp(p))*(exp(p*h)+exp(p-p*h))); 

F(dim-3) = F(dim-3)+x(dim-1)+h*h/12.0*f1; 
F(dim-2) = F(dim-2)+x(dim)+h*h/12.0*f2; 
F(dim-1) = F(dim-1)-2*x(dim-1)+prm(2)+5.0/6*h*h*f1; 
F(dim) = F(dim)-2*x(dim)+prm(6)/prm(2)+5.0/6*h*h*f2;

%
%        Funktionsauswertung Ende
%    


