% 
%     Beispiel: Exzentrizitaet fuer ein geschlossenes Ringlager
%               (Thomas Henlich)
%

%
%        Initialisierung der Startwerte: 
%   

ep = 0.5
b = 0.4

So = 0.5


%
%        Funktionsauswertung Beginn:
%
x=[];
x(1) = 1.1642-1.9456*b+7.1161*b*b-10.1073*b^3+5.0141*b^4;
x(2) = -1.000026-0.23634*b-0.4215*b*b-0.038817*b^3-0.090551*b^4;

Extra=[];
Extra.ep=ep;
Extra.b=b;
Extra.So=So;

f=ringlager_fun(x,Extra);

W=ones(length(f),1);
[f,WJ] = revprod('ringlager_fun',x,W,Extra);

% Forward mode and sparse Jacobian -- you can try these later
% [f,JV]=forwprod('ringlager_fun',x,eye(length(x)),[],Extra);
% 
% 
% 
% [f,J] = evalJ('ringlager_fun',x,Extra);
