function [value,g] = brownfd(x,dummy)
%BROWNFD Nonlinear minimization test problem
% 
% Evaluate the function.
  n=length(x); y=zeros(n,1);
  i=1:(n-1);
  y(i,1)=(x(i,1).^2).^(x(i+1,1).^2+1)+(x(i+1,1).^2).^(x(i,1).^2+1);
  value=sum(y);
%
% Evaluate the gradient.
  if nargout > 1
     i=1:(n-1); g = zeros(n,1);
     g(i,1)= 2*(x(i+1,1).^2+1).*x(i,1).*((x(i,1).^2).^(x(i+1,1).^2))+...
             2*x(i,1).*((x(i+1,1).^2).^(x(i,1).^2+1)).*log(x(i+1,1).^2);
     g(i+1,1)=g(i+1,1)+...
              2*x(i+1,1).*((x(i,1).^2).^(x(i+1,1).^2+1)).*log(x(i,1).^2)+...
              2*(x(i,1).^2+1).*x(i+1,1).*((x(i+1,1).^2).^(x(i,1).^2));
  end
