function fvec= broy1a_sfd(x,Extra);
%
% Evaluate  the Broyden nonlinear equations test function.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% INPUT:
%     x - The current point (column vector).
%
% OUTPUT:
%  fvec - The (vector) function value at x.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Evaluate the vector function
  n = length(x); fvec=zeros(n,1);
  i=2:(n-1);
  fvec(i)= (3-2*x(i)).*x(i)-x(i-1)-2*x(i+1)+ones(n-2,1);
  fvec(n)= (3-2*x(n)).*x(n)-x(n-1)+1;
  fvec(1)= (3-2*x(1)).*x(1)-2*x(2)+1;
