clear;

eps = 4;
p = 4;
to = 12;
alfa = 5;

x = [eps;p;to;alfa];
xdot = eye(4);
Extra = [50;1;1];

x = deriv(x,xdot);
disp('begin AD');
ADz = getydot(lift(x,Extra))

delta = 1.e-4;

disp('begin FD1');
FDz(1)  = (lift([eps+delta;p;to;alfa], Extra)-lift([eps-delta;p;to;alfa],Extra))./(2*delta);
disp('begin FD2');
FDz(2)  = (lift([eps;p+delta;to;alfa], Extra)-lift([eps;p-delta;to;alfa],Extra))./(2*delta);
disp('begin FD3');
FDz(3)  = (lift([eps;p;to+delta;alfa], Extra)-lift([eps;p;to-delta;alfa],Extra))./(2*delta);
disp('begin FD4');
FDz(4)  = (lift([eps;p;to;alfa+delta], Extra)-lift([eps;p;to;alfa-delta],Extra))./(2*delta);

FDz = FDz

error = (ADz - FDz)./FDz
 
