/*
 * MATLAB Compiler: 2.1
 * Date: Mon Dec 18 14:38:48 2000
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-x" "-W" "mex" "-L" "C"
 * "-t" "-T" "link:mexlibrary" "libmatlbmx.mlib" "mytry3" 
 */

#ifndef MLF_V2
#define MLF_V2 1
#endif

#include "libmatlb.h"
#include "mytry3.h"
#include "sprandn.h"

static mexFunctionTableEntry function_table[2]
  = { { "mytry3", mlxMytry3, 0, 1, &_local_function_table_mytry3 },
      { "sprandn", mlxSprandn, 4, 1, NULL } };

static _mexInitTermTableEntry init_term_table[1]
  = { { InitializeModule_mytry3, TerminateModule_mytry3 } };

static _mex_information _mex_info
  = { 1, 2, function_table, 0, NULL, 0, NULL, 1, init_term_table };

/*
 * The function "Msprandn" is the MATLAB callback version of the "sprandn"
 * function from file "C:\Program
 * Files\matlabR12\toolbox\matlab\sparfun\sprandn.m". It performs a callback to
 * MATLAB to run the "sprandn" function, and passes any resulting output
 * arguments back to its calling function.
 */
static mxArray * Msprandn(int nargout_,
                          mxArray * arg1,
                          mxArray * n,
                          mxArray * density,
                          mxArray * rc) {
    mxArray * R = mclGetUninitializedArray();
    mclFevalCallMATLAB(
      mclNVarargout(nargout_, 0, &R, NULL),
      "sprandn",
      arg1, n, density, rc, NULL);
    return R;
}

/*
 * The function "mexLibrary" is a Compiler-generated mex wrapper, suitable for
 * building a MEX-function. It initializes any persistent variables as well as
 * a function table for use by the feval function. It then calls the function
 * "mlxMytry3". Finally, it clears the feval table and exits.
 */
mex_information mexLibrary(void) {
    return &_mex_info;
}

/*
 * The function "mlfSprandn" contains the normal interface for the "sprandn"
 * M-function from file "C:\Program
 * Files\matlabR12\toolbox\matlab\sparfun\sprandn.m" (lines 0-0). This function
 * processes any input arguments and passes them to the implementation version
 * of the function, appearing above.
 */
mxArray * mlfSprandn(mxArray * arg1,
                     mxArray * n,
                     mxArray * density,
                     mxArray * rc) {
    int nargout = 1;
    mxArray * R = mclGetUninitializedArray();
    mlfEnterNewContext(0, 4, arg1, n, density, rc);
    R = Msprandn(nargout, arg1, n, density, rc);
    mlfRestorePreviousContext(0, 4, arg1, n, density, rc);
    return mlfReturnValue(R);
}

/*
 * The function "mlxSprandn" contains the feval interface for the "sprandn"
 * M-function from file "C:\Program
 * Files\matlabR12\toolbox\matlab\sparfun\sprandn.m" (lines 0-0). The feval
 * function calls the implementation version of sprandn through this function.
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxSprandn(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[4];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: sprandn Line: 1 Column: "
            "1 The function \"sprandn\" was called with mor"
            "e than the declared number of outputs (1)."));
    }
    if (nrhs > 4) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: sprandn Line: 1 Column: "
            "1 The function \"sprandn\" was called with mor"
            "e than the declared number of inputs (4)."));
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = mclGetUninitializedArray();
    }
    for (i = 0; i < 4 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 4; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 4, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    mplhs[0] = Msprandn(nlhs, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    mlfRestorePreviousContext(0, 4, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    plhs[0] = mplhs[0];
}
